module: dylan-user
author: Bruce Mitchener, Jr.
copyright: See LICENSE file in this distribution.

define library cairo
  use dylan;
  use common-dylan;
  use io;
  use c-ffi;
  use gobject;

  export cairo;
end library;

define module cairo
  use common-dylan, exclude: { format-to-string };
  use c-ffi;
  use dylan-direct-c-ffi;
  use gobject-glue; // For g-value-to-dylan-helper

  export
    $CAIRO-ANTIALIAS-DEFAULT,
    $CAIRO-ANTIALIAS-GRAY,
    $CAIRO-ANTIALIAS-NONE,
    $CAIRO-ANTIALIAS-SUBPIXEL,
    $CAIRO-CONTENT-ALPHA,
    $CAIRO-CONTENT-COLOR,
    $CAIRO-CONTENT-COLOR-ALPHA,
    $CAIRO-DEVICE-TYPE-DRM,
    $CAIRO-DEVICE-TYPE-GL,
    $CAIRO-DEVICE-TYPE-SCRIPT,
    $CAIRO-DEVICE-TYPE-XCB,
    $CAIRO-DEVICE-TYPE-XLIB,
    $CAIRO-DEVICE-TYPE-XML,
    $CAIRO-EXTEND-NONE,
    $CAIRO-EXTEND-PAD,
    $CAIRO-EXTEND-REFLECT,
    $CAIRO-EXTEND-REPEAT,
    $CAIRO-FILL-RULE-EVEN-ODD,
    $CAIRO-FILL-RULE-WINDING,
    $CAIRO-FILTER-BEST,
    $CAIRO-FILTER-BILINEAR,
    $CAIRO-FILTER-FAST,
    $CAIRO-FILTER-GAUSSIAN,
    $CAIRO-FILTER-GOOD,
    $CAIRO-FILTER-NEAREST,
    $CAIRO-FONT-SLANT-ITALIC,
    $CAIRO-FONT-SLANT-NORMAL,
    $CAIRO-FONT-SLANT-OBLIQUE,
    $CAIRO-FONT-TYPE-FT,
    $CAIRO-FONT-TYPE-QUARTZ,
    $CAIRO-FONT-TYPE-TOY,
    $CAIRO-FONT-TYPE-USER,
    $CAIRO-FONT-TYPE-WIN32,
    $CAIRO-FONT-WEIGHT-BOLD,
    $CAIRO-FONT-WEIGHT-NORMAL,
    $CAIRO-FORMAT-A1,
    $CAIRO-FORMAT-A8,
    $CAIRO-FORMAT-ARGB32,
    $CAIRO-FORMAT-INVALID,
    $CAIRO-FORMAT-RGB16-565,
    $CAIRO-FORMAT-RGB24,
    $CAIRO-HINT-METRICS-DEFAULT,
    $CAIRO-HINT-METRICS-OFF,
    $CAIRO-HINT-METRICS-ON,
    $CAIRO-HINT-STYLE-DEFAULT,
    $CAIRO-HINT-STYLE-FULL,
    $CAIRO-HINT-STYLE-MEDIUM,
    $CAIRO-HINT-STYLE-NONE,
    $CAIRO-HINT-STYLE-SLIGHT,
    $CAIRO-LINE-CAP-BUTT,
    $CAIRO-LINE-CAP-ROUND,
    $CAIRO-LINE-CAP-SQUARE,
    $CAIRO-LINE-JOIN-BEVEL,
    $CAIRO-LINE-JOIN-MITER,
    $CAIRO-LINE-JOIN-ROUND,
    $CAIRO-MIME-TYPE-JP2,
    $CAIRO-MIME-TYPE-JPEG,
    $CAIRO-MIME-TYPE-PNG,
    $CAIRO-MIME-TYPE-URI,
    $CAIRO-OPERATOR-ADD,
    $CAIRO-OPERATOR-ATOP,
    $CAIRO-OPERATOR-CLEAR,
    $CAIRO-OPERATOR-COLOR-BURN,
    $CAIRO-OPERATOR-COLOR-DODGE,
    $CAIRO-OPERATOR-DARKEN,
    $CAIRO-OPERATOR-DEST,
    $CAIRO-OPERATOR-DEST-ATOP,
    $CAIRO-OPERATOR-DEST-IN,
    $CAIRO-OPERATOR-DEST-OUT,
    $CAIRO-OPERATOR-DEST-OVER,
    $CAIRO-OPERATOR-DIFFERENCE,
    $CAIRO-OPERATOR-EXCLUSION,
    $CAIRO-OPERATOR-HARD-LIGHT,
    $CAIRO-OPERATOR-HSL-COLOR,
    $CAIRO-OPERATOR-HSL-HUE,
    $CAIRO-OPERATOR-HSL-LUMINOSITY,
    $CAIRO-OPERATOR-HSL-SATURATION,
    $CAIRO-OPERATOR-IN,
    $CAIRO-OPERATOR-LIGHTEN,
    $CAIRO-OPERATOR-MULTIPLY,
    $CAIRO-OPERATOR-OUT,
    $CAIRO-OPERATOR-OVER,
    $CAIRO-OPERATOR-OVERLAY,
    $CAIRO-OPERATOR-SATURATE,
    $CAIRO-OPERATOR-SCREEN,
    $CAIRO-OPERATOR-SOFT-LIGHT,
    $CAIRO-OPERATOR-SOURCE,
    $CAIRO-OPERATOR-XOR,
    $CAIRO-PATH-CLOSE-PATH,
    $CAIRO-PATH-CURVE-TO,
    $CAIRO-PATH-LINE-TO,
    $CAIRO-PATH-MOVE-TO,
    $CAIRO-PATTERN-TYPE-LINEAR,
    $CAIRO-PATTERN-TYPE-RADIAL,
    $CAIRO-PATTERN-TYPE-SOLID,
    $CAIRO-PATTERN-TYPE-SURFACE,
    $CAIRO-PDF-VERSION-1-4,
    $CAIRO-PDF-VERSION-1-5,
    $CAIRO-PS-LEVEL-2,
    $CAIRO-PS-LEVEL-3,
    $CAIRO-REGION-OVERLAP-IN,
    $CAIRO-REGION-OVERLAP-OUT,
    $CAIRO-REGION-OVERLAP-PART,
    $CAIRO-STATUS-CLIP-NOT-REPRESENTABLE,
    $CAIRO-STATUS-DEVICE-ERROR,
    $CAIRO-STATUS-DEVICE-TYPE-MISMATCH,
    $CAIRO-STATUS-FILE-NOT-FOUND,
    $CAIRO-STATUS-FONT-TYPE-MISMATCH,
    $CAIRO-STATUS-INVALID-CLUSTERS,
    $CAIRO-STATUS-INVALID-CONTENT,
    $CAIRO-STATUS-INVALID-DASH,
    $CAIRO-STATUS-INVALID-DSC-COMMENT,
    $CAIRO-STATUS-INVALID-FORMAT,
    $CAIRO-STATUS-INVALID-INDEX,
    $CAIRO-STATUS-INVALID-MATRIX,
    $CAIRO-STATUS-INVALID-PATH-DATA,
    $CAIRO-STATUS-INVALID-POP-GROUP,
    $CAIRO-STATUS-INVALID-RESTORE,
    $CAIRO-STATUS-INVALID-SIZE,
    $CAIRO-STATUS-INVALID-SLANT,
    $CAIRO-STATUS-INVALID-STATUS,
    $CAIRO-STATUS-INVALID-STRIDE,
    $CAIRO-STATUS-INVALID-STRING,
    $CAIRO-STATUS-INVALID-VISUAL,
    $CAIRO-STATUS-INVALID-WEIGHT,
    $CAIRO-STATUS-LAST-STATUS,
    $CAIRO-STATUS-NEGATIVE-COUNT,
    $CAIRO-STATUS-NO-CURRENT-POINT,
    $CAIRO-STATUS-NO-MEMORY,
    $CAIRO-STATUS-NULL-POINTER,
    $CAIRO-STATUS-PATTERN-TYPE-MISMATCH,
    $CAIRO-STATUS-READ-ERROR,
    $CAIRO-STATUS-SUCCESS,
    $CAIRO-STATUS-SURFACE-FINISHED,
    $CAIRO-STATUS-SURFACE-TYPE-MISMATCH,
    $CAIRO-STATUS-TEMP-FILE-ERROR,
    $CAIRO-STATUS-USER-FONT-ERROR,
    $CAIRO-STATUS-USER-FONT-IMMUTABLE,
    $CAIRO-STATUS-USER-FONT-NOT-IMPLEMENTED,
    $CAIRO-STATUS-WRITE-ERROR,
    $CAIRO-SUBPIXEL-ORDER-BGR,
    $CAIRO-SUBPIXEL-ORDER-DEFAULT,
    $CAIRO-SUBPIXEL-ORDER-RGB,
    $CAIRO-SUBPIXEL-ORDER-VBGR,
    $CAIRO-SUBPIXEL-ORDER-VRGB,
    $CAIRO-SURFACE-TYPE-BEOS,
    $CAIRO-SURFACE-TYPE-DIRECTFB,
    $CAIRO-SURFACE-TYPE-DRM,
    $CAIRO-SURFACE-TYPE-GL,
    $CAIRO-SURFACE-TYPE-GLITZ,
    $CAIRO-SURFACE-TYPE-IMAGE,
    $CAIRO-SURFACE-TYPE-OS2,
    $CAIRO-SURFACE-TYPE-PDF,
    $CAIRO-SURFACE-TYPE-PS,
    $CAIRO-SURFACE-TYPE-QT,
    $CAIRO-SURFACE-TYPE-QUARTZ,
    $CAIRO-SURFACE-TYPE-QUARTZ-IMAGE,
    $CAIRO-SURFACE-TYPE-RECORDING,
    $CAIRO-SURFACE-TYPE-SCRIPT,
    $CAIRO-SURFACE-TYPE-SKIA,
    $CAIRO-SURFACE-TYPE-SUBSURFACE,
    $CAIRO-SURFACE-TYPE-SVG,
    $CAIRO-SURFACE-TYPE-TEE,
    $CAIRO-SURFACE-TYPE-VG,
    $CAIRO-SURFACE-TYPE-WIN32,
    $CAIRO-SURFACE-TYPE-WIN32-PRINTING,
    $CAIRO-SURFACE-TYPE-XCB,
    $CAIRO-SURFACE-TYPE-XLIB,
    $CAIRO-SURFACE-TYPE-XML,
    $CAIRO-SVG-VERSION-1-1,
    $CAIRO-SVG-VERSION-1-2,
    $CAIRO-TEXT-CLUSTER-FLAG-BACKWARD,
    $CAIRO-VERSION,
    $CAIRO-VERSION-MAJOR,
    $CAIRO-VERSION-MICRO,
    $CAIRO-VERSION-MINOR,
    <CairoAntialias>,
    <CairoContent>,
    <CairoDestroyFunc>,
    <CairoDevice>,
    <CairoDeviceType>,
    <CairoExtend>,
    <CairoFillRule>,
    <CairoFilter>,
    <CairoFontExtents>,
    <CairoFontFace>,
    <CairoFontOptions>,
    <CairoFontSlant>,
    <CairoFontType>,
    <CairoFontWeight>,
    <CairoFormat>,
    <CairoGlyph*>,
    <CairoGlyph>,
    <CairoHintMetrics>,
    <CairoHintStyle>,
    <CairoLineCap>,
    <CairoLineJoin>,
    <CairoMatrix>,
    <CairoOperator>,
    <CairoPathData>,
    <CairoPathDataType>,
    <CairoPath>,
    <CairoPattern>,
    <CairoPatternType>,
    <CairoPDFVersion**>,
    <CairoPDFVersion*>,
    <CairoPDFVersion>,
    <CairoPSLevel**>,
    <CairoPSLevel*>,
    <CairoPSLevel>,
    <CairoReadFunc>,
    <CairoRectangleInt>,
    <CairoRectangleList>,
    <CairoRectangle>,
    <CairoRegionOverlap>,
    <CairoRegion>,
    <CairoScaledFont>,
    <CairoStatus>,
    <CairoSubpixelOrder>,
    <CairoSurface*>,
    <CairoSurface>,
    <CairoSurfaceType>,
    <CairoSVGVersion**>,
    <CairoSVGVersion*>,
    <CairoSVGVersion>,
    <CairoContext>,
    <CairoTextClusterFlags*>,
    <CairoTextClusterFlags>,
    <CairoTextCluster*>,
    <CairoTextCluster>,
    <CairoTextExtents>,
    <CairoUserDataKey>,
    <CairoUserScaledFontInitFunc>,
    <CairoUserScaledFontRenderGlyphFunc>,
    <CairoUserScaledFontTextToGlyphsFunc>,
    <CairoUserScaledFontUnicodeToGlyphFunc>,
    <CairoWriteFunc>,
    <double*>,
    <int*>,
    <unsigned-char**>,
    <unsigned-char*>,
    <unsigned-long*>,
    cairo-matrix-x0,
    cairo-matrix-x0-setter,
    cairo-matrix-xx,
    cairo-matrix-xx-setter,
    cairo-matrix-xy,
    cairo-matrix-xy-setter,
    cairo-matrix-y0,
    cairo-matrix-y0-setter,
    cairo-matrix-yx,
    cairo-matrix-yx-setter,
    cairo-matrix-yy,
    cairo-matrix-yy-setter,
    cairo-path-data-header,
    cairo-path-data-header-setter,
    cairo-path-data-point,
    cairo-path-data-point-setter,
    cairo-rectangle-height,
    cairo-rectangle-height-setter,
    cairo-rectangle-width,
    cairo-rectangle-width-setter,
    cairo-rectangle-x,
    cairo-rectangle-x-setter,
    cairo-rectangle-y,
    cairo-rectangle-y-setter,
    cairo-rectangle-int-height,
    cairo-rectangle-int-height-setter,
    cairo-rectangle-int-width,
    cairo-rectangle-int-width-setter,
    cairo-rectangle-int-x,
    cairo-rectangle-int-x-setter,
    cairo-rectangle-int-y,
    cairo-rectangle-int-y-setter,
    cairo-rectangle-list-num-rectangles,
    cairo-rectangle-list-num-rectangles-setter,
    cairo-rectangle-list-rectangles,
    cairo-rectangle-list-rectangles-setter,
    cairo-rectangle-list-status,
    cairo-rectangle-list-status-setter,
    cairo-user-data-key-unused,
    cairo-user-data-key-unused-setter,
    cairo-append-path,
    cairo-arc,
    cairo-arc-negative,
    cairo-clip,
    cairo-clip-extents,
    cairo-clip-preserve,
    cairo-close-path,
    cairo-copy-clip-rectangle-list,
    cairo-copy-page,
    cairo-copy-path,
    cairo-copy-path-flat,
    cairo-create,
    cairo-curve-to,
    cairo-debug-reset-static-data,
    cairo-destroy,
    cairo-device-acquire,
    cairo-device-destroy,
    cairo-device-finish,
    cairo-device-flush,
    cairo-device-get-reference-count,
    cairo-device-get-type,
    cairo-device-get-user-data,
    cairo-device-reference,
    cairo-device-release,
    cairo-device-set-user-data,
    cairo-device-status,
    cairo-device-to-user,
    cairo-device-to-user-distance,
    cairo-fill,
    cairo-fill-extents,
    cairo-fill-preserve,
    cairo-font-extents,
    cairo-font-face-destroy,
    cairo-font-face-get-reference-count,
    cairo-font-face-get-type,
    cairo-font-face-get-user-data,
    cairo-font-face-reference,
    cairo-font-face-set-user-data,
    cairo-font-face-status,
    cairo-font-options-copy,
    cairo-font-options-create,
    cairo-font-options-destroy,
    cairo-font-options-equal,
    cairo-font-options-get-antialias,
    cairo-font-options-get-hint-metrics,
    cairo-font-options-get-hint-style,
    cairo-font-options-get-subpixel-order,
    cairo-font-options-hash,
    cairo-font-options-merge,
    cairo-font-options-set-antialias,
    cairo-font-options-set-hint-metrics,
    cairo-font-options-set-hint-style,
    cairo-font-options-set-subpixel-order,
    cairo-font-options-status,
    cairo-format-stride-for-width,
    cairo-get-antialias,
    cairo-get-current-point,
    cairo-get-dash,
    cairo-get-dash-count,
    cairo-get-fill-rule,
    cairo-get-font-face,
    cairo-get-font-matrix,
    cairo-get-font-options,
    cairo-get-group-target,
    cairo-get-line-cap,
    cairo-get-line-join,
    cairo-get-line-width,
    cairo-get-matrix,
    cairo-get-miter-limit,
    cairo-get-operator,
    cairo-get-reference-count,
    cairo-get-scaled-font,
    cairo-get-source,
    cairo-get-target,
    cairo-get-tolerance,
    cairo-get-user-data,
    cairo-glyph-allocate,
    cairo-glyph-extents,
    cairo-glyph-free,
    cairo-glyph-path,
    cairo-has-current-point,
    cairo-identity-matrix,
    cairo-image-surface-create,
    cairo-image-surface-create-for-data,
    cairo-image-surface-create-from-png,
    cairo-image-surface-create-from-png-stream,
    cairo-image-surface-get-data,
    cairo-image-surface-get-format,
    cairo-image-surface-get-height,
    cairo-image-surface-get-stride,
    cairo-image-surface-get-width,
    cairo-in-clip,
    cairo-in-fill,
    cairo-in-stroke,
    cairo-line-to,
    cairo-mask,
    cairo-mask-surface,
    cairo-matrix-init,
    cairo-matrix-init-identity,
    cairo-matrix-init-rotate,
    cairo-matrix-init-scale,
    cairo-matrix-init-translate,
    cairo-matrix-invert,
    cairo-matrix-multiply,
    cairo-matrix-rotate,
    cairo-matrix-scale,
    cairo-matrix-transform-distance,
    cairo-matrix-transform-point,
    cairo-matrix-translate,
    cairo-move-to,
    cairo-new-path,
    cairo-new-sub-path,
    cairo-paint,
    cairo-paint-with-alpha,
    cairo-path-destroy,
    cairo-path-extents,
    cairo-pattern-add-color-stop-rgb,
    cairo-pattern-add-color-stop-rgba,
    cairo-pattern-create-for-surface,
    cairo-pattern-create-linear,
    cairo-pattern-create-radial,
    cairo-pattern-create-rgb,
    cairo-pattern-create-rgba,
    cairo-pattern-destroy,
    cairo-pattern-get-color-stop-count,
    cairo-pattern-get-color-stop-rgba,
    cairo-pattern-get-extend,
    cairo-pattern-get-filter,
    cairo-pattern-get-linear-points,
    cairo-pattern-get-matrix,
    cairo-pattern-get-radial-circles,
    cairo-pattern-get-reference-count,
    cairo-pattern-get-rgba,
    cairo-pattern-get-surface,
    cairo-pattern-get-type,
    cairo-pattern-get-user-data,
    cairo-pattern-reference,
    cairo-pattern-set-extend,
    cairo-pattern-set-filter,
    cairo-pattern-set-matrix,
    cairo-pattern-set-user-data,
    cairo-pattern-status,
    cairo-pdf-get-versions,
    cairo-pdf-surface-create,
    cairo-pdf-surface-create-for-stream,
    cairo-pdf-surface-restrict-to-version,
    cairo-pdf-surface-set-size,
    cairo-pdf-version-to-string,
    cairo-pop-group,
    cairo-pop-group-to-source,
    cairo-ps-get-levels,
    cairo-ps-level-to-string,
    cairo-ps-surface-create,
    cairo-ps-surface-create-for-stream,
    cairo-ps-surface-dsc-begin-page-setup,
    cairo-ps-surface-dsc-begin-setup,
    cairo-ps-surface-dsc-comment,
    cairo-ps-surface-get-eps,
    cairo-ps-surface-restrict-to-level,
    cairo-ps-surface-set-eps,
    cairo-ps-surface-set-size,
    cairo-push-group,
    cairo-push-group-with-content,
    cairo-recording-surface-create,
    cairo-recording-surface-ink-extents,
    cairo-rectangle,
    cairo-rectangle-list-destroy,
    cairo-reference,
    cairo-region-contains-point,
    cairo-region-contains-rectangle,
    cairo-region-copy,
    cairo-region-create,
    cairo-region-create-rectangle,
    cairo-region-create-rectangles,
    cairo-region-destroy,
    cairo-region-equal,
    cairo-region-get-extents,
    cairo-region-get-rectangle,
    cairo-region-intersect,
    cairo-region-intersect-rectangle,
    cairo-region-is-empty,
    cairo-region-num-rectangles,
    cairo-region-reference,
    cairo-region-status,
    cairo-region-subtract,
    cairo-region-subtract-rectangle,
    cairo-region-translate,
    cairo-region-union,
    cairo-region-union-rectangle,
    cairo-region-xor,
    cairo-region-xor-rectangle,
    cairo-rel-curve-to,
    cairo-rel-line-to,
    cairo-rel-move-to,
    cairo-reset-clip,
    cairo-restore,
    cairo-rotate,
    cairo-save,
    cairo-scale,
    cairo-scaled-font-create,
    cairo-scaled-font-destroy,
    cairo-scaled-font-extents,
    cairo-scaled-font-get-ctm,
    cairo-scaled-font-get-font-face,
    cairo-scaled-font-get-font-matrix,
    cairo-scaled-font-get-font-options,
    cairo-scaled-font-get-reference-count,
    cairo-scaled-font-get-scale-matrix,
    cairo-scaled-font-get-type,
    cairo-scaled-font-get-user-data,
    cairo-scaled-font-glyph-extents,
    cairo-scaled-font-reference,
    cairo-scaled-font-set-user-data,
    cairo-scaled-font-status,
    cairo-scaled-font-text-extents,
    cairo-scaled-font-text-to-glyphs,
    cairo-select-font-face,
    cairo-set-antialias,
    cairo-set-dash,
    cairo-set-fill-rule,
    cairo-set-font-face,
    cairo-set-font-matrix,
    cairo-set-font-options,
    cairo-set-font-size,
    cairo-set-line-cap,
    cairo-set-line-join,
    cairo-set-line-width,
    cairo-set-matrix,
    cairo-set-miter-limit,
    cairo-set-operator,
    cairo-set-scaled-font,
    cairo-set-source,
    cairo-set-source-rgb,
    cairo-set-source-rgba,
    cairo-set-source-surface,
    cairo-set-tolerance,
    cairo-set-user-data,
    cairo-show-glyphs,
    cairo-show-page,
    cairo-show-text,
    cairo-show-text-glyphs,
    cairo-status,
    cairo-status-to-string,
    cairo-stroke,
    cairo-stroke-extents,
    cairo-stroke-preserve,
    cairo-surface-copy-page,
    cairo-surface-create-for-rectangle,
    cairo-surface-create-similar,
    cairo-surface-destroy,
    cairo-surface-finish,
    cairo-surface-flush,
    cairo-surface-get-content,
    cairo-surface-get-device,
    cairo-surface-get-device-offset,
    cairo-surface-get-fallback-resolution,
    cairo-surface-get-font-options,
    cairo-surface-get-mime-data,
    cairo-surface-get-reference-count,
    cairo-surface-get-type,
    cairo-surface-get-user-data,
    cairo-surface-has-show-text-glyphs,
    cairo-surface-mark-dirty,
    cairo-surface-mark-dirty-rectangle,
    cairo-surface-reference,
    cairo-surface-set-device-offset,
    cairo-surface-set-fallback-resolution,
    cairo-surface-set-mime-data,
    cairo-surface-set-user-data,
    cairo-surface-show-page,
    cairo-surface-status,
    cairo-surface-write-to-png,
    cairo-surface-write-to-png-stream,
    cairo-svg-get-versions,
    cairo-svg-surface-create,
    cairo-svg-surface-create-for-stream,
    cairo-svg-surface-restrict-to-version,
    cairo-svg-version-to-string,
    cairo-text-cluster-allocate,
    cairo-text-cluster-free,
    cairo-text-extents,
    cairo-text-path,
    cairo-toy-font-face-create,
    cairo-toy-font-face-get-family,
    cairo-toy-font-face-get-slant,
    cairo-toy-font-face-get-weight,
    cairo-transform,
    cairo-translate,
    cairo-user-font-face-create,
    cairo-user-font-face-get-init-func,
    cairo-user-font-face-get-render-glyph-func,
    cairo-user-font-face-get-text-to-glyphs-func,
    cairo-user-font-face-get-unicode-to-glyph-func,
    cairo-user-font-face-set-init-func,
    cairo-user-font-face-set-render-glyph-func,
    cairo-user-font-face-set-text-to-glyphs-func,
    cairo-user-font-face-set-unicode-to-glyph-func,
    cairo-user-to-device,
    cairo-user-to-device-distance,
    cairo-version,
    cairo-version-string,
    cairo-font-extents-ascent,
    cairo-font-extents-ascent-setter,
    cairo-font-extents-descent,
    cairo-font-extents-descent-setter,
    cairo-font-extents-height,
    cairo-font-extents-height-setter,
    cairo-font-extents-max-x-advance,
    cairo-font-extents-max-x-advance-setter,
    cairo-font-extents-max-y-advance,
    cairo-font-extents-max-y-advance-setter,
    cairo-glyph-index,
    cairo-glyph-index-setter,
    cairo-glyph-x,
    cairo-glyph-x-setter,
    cairo-glyph-y,
    cairo-glyph-y-setter,
    cairo-path-data,
    cairo-path-data-setter,
    cairo-path-num-data,
    cairo-path-num-data-setter,
    cairo-path-status,
    cairo-path-status-setter,
    cairo-text-cluster-num-bytes,
    cairo-text-cluster-num-bytes-setter,
    cairo-text-cluster-num-glyphs,
    cairo-text-cluster-num-glyphs-setter,
    cairo-text-extents-height,
    cairo-text-extents-height-setter,
    cairo-text-extents-width,
    cairo-text-extents-width-setter,
    cairo-text-extents-x-advance,
    cairo-text-extents-x-advance-setter,
    cairo-text-extents-x-bearing,
    cairo-text-extents-x-bearing-setter,
    cairo-text-extents-y-advance,
    cairo-text-extents-y-advance-setter,
    cairo-text-extents-y-bearing,
    cairo-text-extents-y-bearing-setter;
end module;
