module: dylan-user
copyright: See LICENSE file in this distribution.

define library gdk
  use dylan;
  use common-dylan;
  use c-ffi;
  use glib;
  use gmodule;
  use gmodule;
  use gio;
  use gobject;
  use gdkpixbuf;
  use cairo;
  use pango;
  use gobject;
  use glib;

  export gdk;
  export gdk-properties;
end library;

define module gdk
  use dylan;
  use common-dylan;
  use c-ffi;
  use gobject-glue;
  use glib;
  use gmodule;
  use gmodule;
  use gio;
  use gobject;
  use gdkpixbuf;
  use cairo;
  use pango;
  use gobject;
  use glib;

  export
    gdk-utf8-to-string-target,
    gdk-unicode-to-keyval,
    gdk-threads-leave,
    gdk-threads-init,
    gdk-threads-enter,
    gdk-threads-add-timeout-seconds-full,
    gdk-threads-add-timeout-full,
    gdk-threads-add-idle-full,
    gdk-text-property-to-utf8-list-for-display,
    gdk-test-simulate-key,
    gdk-test-simulate-button,
    gdk-test-render-sync,
    gdk-synthesize-window-state,
    gdk-setting-get,
    gdk-set-show-events,
    gdk-set-program-class,
    gdk-set-double-click-time,
    gdk-selection-send-notify-for-display,
    gdk-selection-send-notify,
    gdk-selection-owner-set-for-display,
    gdk-selection-owner-set,
    gdk-selection-owner-get-for-display,
    gdk-selection-owner-get,
    gdk-selection-convert,
    gdk-rectangle-union,
    gdk-rectangle-intersect,
    gdk-rectangle-get-type,
    gdk-query-visual-types,
    gdk-query-depths,
    gdk-property-get,
    gdk-property-delete,
    gdk-pre-parse-libgtk-only,
    gdk-pixbuf-get-from-window,
    gdk-pixbuf-get-from-surface,
    gdk-parse-args,
    gdk-pango-context-get-for-screen,
    gdk-pango-context-get,
    gdk-offscreen-window-set-embedder,
    gdk-offscreen-window-get-surface,
    gdk-offscreen-window-get-embedder,
    gdk-notify-startup-complete-with-id,
    gdk-notify-startup-complete,
    gdk-list-visuals,
    gdk-keyval-to-upper,
    gdk-keyval-to-unicode,
    gdk-keyval-to-lower,
    gdk-keyval-name,
    gdk-keyval-is-upper,
    gdk-keyval-is-lower,
    gdk-keyval-from-name,
    gdk-keyval-convert-case,
    gdk-init-check,
    gdk-init,
    gdk-get-show-events,
    gdk-get-program-class,
    gdk-get-display-arg-name,
    gdk-get-display,
    gdk-get-default-root-window,
    gdk-flush,
    gdk-events-pending,
    gdk-error-trap-push,
    gdk-error-trap-pop-ignored,
    gdk-error-trap-pop,
    gdk-drop-reply,
    gdk-drop-finish,
    gdk-drag-status,
    gdk-drag-motion,
    gdk-drag-get-selection,
    gdk-drag-find-window-for-screen,
    gdk-drag-drop-succeeded,
    gdk-drag-drop,
    gdk-drag-begin-for-device,
    gdk-drag-begin,
    gdk-drag-abort,
    gdk-disable-multidevice,
    gdk-cairo-set-source-window,
    gdk-cairo-set-source-rgba,
    gdk-cairo-set-source-pixbuf,
    gdk-cairo-region-create-from-surface,
    gdk-cairo-region,
    gdk-cairo-rectangle,
    gdk-cairo-get-clip-rectangle,
    gdk-cairo-create,
    gdk-beep,
    gdk-add-option-entries-libgtk-only,
    <GdkWindowWindowClass*>,
    <GdkWindowWindowClass>,
    $gdk-input-only,
    $gdk-input-output,
    <GdkWindowTypeHint*>,
    <GdkWindowTypeHint>,
    $gdk-window-type-hint-dnd,
    $gdk-window-type-hint-combo,
    $gdk-window-type-hint-notification,
    $gdk-window-type-hint-tooltip,
    $gdk-window-type-hint-popup-menu,
    $gdk-window-type-hint-dropdown-menu,
    $gdk-window-type-hint-desktop,
    $gdk-window-type-hint-dock,
    $gdk-window-type-hint-utility,
    $gdk-window-type-hint-splashscreen,
    $gdk-window-type-hint-toolbar,
    $gdk-window-type-hint-menu,
    $gdk-window-type-hint-dialog,
    $gdk-window-type-hint-normal,
    <GdkWindowType*>,
    <GdkWindowType>,
    $gdk-window-offscreen,
    $gdk-window-foreign,
    $gdk-window-temp,
    $gdk-window-child,
    $gdk-window-toplevel,
    $gdk-window-root,
    <GdkWindowState*>,
    <GdkWindowState>,
    $gdk-window-state-focused,
    $gdk-window-state-below,
    $gdk-window-state-above,
    $gdk-window-state-fullscreen,
    $gdk-window-state-sticky,
    $gdk-window-state-maximized,
    $gdk-window-state-iconified,
    $gdk-window-state-withdrawn,
    <GdkWindowRedirect>,
    <GdkWindowHints*>,
    <GdkWindowHints>,
    $gdk-hint-user-size,
    $gdk-hint-user-pos,
    $gdk-hint-win-gravity,
    $gdk-hint-resize-inc,
    $gdk-hint-aspect,
    $gdk-hint-base-size,
    $gdk-hint-max-size,
    $gdk-hint-min-size,
    $gdk-hint-pos,
    <GdkWindowEdge*>,
    <GdkWindowEdge>,
    $gdk-window-edge-south-east,
    $gdk-window-edge-south,
    $gdk-window-edge-south-west,
    $gdk-window-edge-east,
    $gdk-window-edge-west,
    $gdk-window-edge-north-east,
    $gdk-window-edge-north,
    $gdk-window-edge-north-west,
    gdk-window-class-_gdk-reserved8,
    gdk-window-class-_gdk-reserved7,
    gdk-window-class-_gdk-reserved6,
    gdk-window-class-_gdk-reserved5,
    gdk-window-class-_gdk-reserved4,
    gdk-window-class-_gdk-reserved3,
    gdk-window-class-_gdk-reserved2,
    gdk-window-class-_gdk-reserved1,
    gdk-window-class-create-surface,
    gdk-window-class-from-embedder,
    gdk-window-class-to-embedder,
    gdk-window-class-pick-embedded-child,
    gdk-window-class-parent-class,
    <GdkWindowClass>,
    <GdkWindowAttributesType*>,
    <GdkWindowAttributesType>,
    $gdk-wa-type-hint,
    $gdk-wa-noredir,
    $gdk-wa-wmclass,
    $gdk-wa-visual,
    $gdk-wa-cursor,
    $gdk-wa-y,
    $gdk-wa-x,
    $gdk-wa-title,
    gdk-window-attr-type-hint-setter,
    gdk-window-attr-type-hint,
    gdk-window-attr-override-redirect-setter,
    gdk-window-attr-override-redirect,
    gdk-window-attr-wmclass-class-setter,
    gdk-window-attr-wmclass-class,
    gdk-window-attr-wmclass-name-setter,
    gdk-window-attr-wmclass-name,
    gdk-window-attr-cursor-setter,
    gdk-window-attr-cursor,
    gdk-window-attr-window-type-setter,
    gdk-window-attr-window-type,
    gdk-window-attr-visual-setter,
    gdk-window-attr-visual,
    gdk-window-attr-wclass-setter,
    gdk-window-attr-wclass,
    gdk-window-attr-height-setter,
    gdk-window-attr-height,
    gdk-window-attr-width-setter,
    gdk-window-attr-width,
    gdk-window-attr-y-setter,
    gdk-window-attr-y,
    gdk-window-attr-x-setter,
    gdk-window-attr-x,
    gdk-window-attr-event-mask-setter,
    gdk-window-attr-event-mask,
    gdk-window-attr-title-setter,
    gdk-window-attr-title,
    <GdkWindowAttr>,
    gdk-window-withdraw,
    gdk-window-unstick,
    gdk-window-unmaximize,
    gdk-window-unfullscreen,
    gdk-window-thaw-updates,
    gdk-window-thaw-toplevel-updates-libgtk-only,
    gdk-window-stick,
    gdk-window-show-unraised,
    gdk-window-show,
    gdk-window-shape-combine-region,
    gdk-window-set-user-data,
    gdk-window-set-urgency-hint,
    gdk-window-set-type-hint,
    gdk-window-set-transient-for,
    gdk-window-set-title,
    gdk-window-set-support-multidevice,
    gdk-window-set-static-gravities,
    gdk-window-set-startup-id,
    gdk-window-set-source-events,
    gdk-window-set-skip-taskbar-hint,
    gdk-window-set-skip-pager-hint,
    gdk-window-set-role,
    gdk-window-set-override-redirect,
    gdk-window-set-opacity,
    gdk-window-set-modal-hint,
    gdk-window-set-keep-below,
    gdk-window-set-keep-above,
    gdk-window-set-icon-name,
    gdk-window-set-icon-list,
    gdk-window-set-group,
    gdk-window-set-geometry-hints,
    gdk-window-set-functions,
    gdk-window-set-focus-on-map,
    gdk-window-set-events,
    gdk-window-set-device-events,
    gdk-window-set-device-cursor,
    gdk-window-set-decorations,
    gdk-window-set-cursor,
    gdk-window-set-composited,
    gdk-window-set-child-shapes,
    gdk-window-set-child-input-shapes,
    gdk-window-set-background-rgba,
    gdk-window-set-background-pattern,
    gdk-window-set-background,
    gdk-window-set-accept-focus,
    gdk-window-scroll,
    gdk-window-restack,
    gdk-window-resize,
    gdk-window-reparent,
    gdk-window-register-dnd,
    gdk-window-raise,
    gdk-window-process-updates,
    gdk-window-peek-children,
    gdk-window-move-resize,
    gdk-window-move-region,
    gdk-window-move,
    gdk-window-merge-child-shapes,
    gdk-window-merge-child-input-shapes,
    gdk-window-maximize,
    gdk-window-lower,
    gdk-window-is-visible,
    gdk-window-is-viewable,
    gdk-window-is-shaped,
    gdk-window-is-input-only,
    gdk-window-is-destroyed,
    gdk-window-invalidate-region,
    gdk-window-invalidate-rect,
    gdk-window-invalidate-maybe-recurse,
    gdk-window-input-shape-combine-region,
    gdk-window-iconify,
    gdk-window-hide,
    gdk-window-has-native,
    gdk-window-get-window-type,
    gdk-window-get-width,
    gdk-window-get-visual,
    gdk-window-get-visible-region,
    gdk-window-get-user-data,
    gdk-window-get-update-area,
    gdk-window-get-type-hint,
    gdk-window-get-toplevel,
    gdk-window-get-support-multidevice,
    gdk-window-get-state,
    gdk-window-get-source-events,
    gdk-window-get-screen,
    gdk-window-get-root-origin,
    gdk-window-get-root-coords,
    gdk-window-get-position,
    gdk-window-get-pointer,
    gdk-window-get-parent,
    gdk-window-get-origin,
    gdk-window-get-modal-hint,
    gdk-window-get-height,
    gdk-window-get-group,
    gdk-window-get-geometry,
    gdk-window-get-frame-extents,
    gdk-window-get-focus-on-map,
    gdk-window-get-events,
    gdk-window-get-effective-toplevel,
    gdk-window-get-effective-parent,
    gdk-window-get-drag-protocol,
    gdk-window-get-display,
    gdk-window-get-device-position,
    gdk-window-get-device-events,
    gdk-window-get-device-cursor,
    gdk-window-get-decorations,
    gdk-window-get-cursor,
    gdk-window-get-composited,
    gdk-window-get-clip-region,
    gdk-window-get-children,
    gdk-window-get-background-pattern,
    gdk-window-get-accept-focus,
    gdk-window-geometry-changed,
    gdk-window-fullscreen,
    gdk-window-freeze-updates,
    gdk-window-freeze-toplevel-updates-libgtk-only,
    gdk-window-focus,
    gdk-window-flush,
    gdk-window-ensure-native,
    gdk-window-end-paint,
    gdk-window-enable-synchronized-configure,
    gdk-window-destroy-notify,
    gdk-window-destroy,
    gdk-window-deiconify,
    gdk-window-create-similar-surface,
    gdk-window-coords-to-parent,
    gdk-window-coords-from-parent,
    gdk-window-configure-finished,
    gdk-window-begin-resize-drag-for-device,
    gdk-window-begin-resize-drag,
    gdk-window-begin-paint-region,
    gdk-window-begin-paint-rect,
    gdk-window-begin-move-drag-for-device,
    gdk-window-begin-move-drag,
    gdk-window-beep,
    gdk-window-set-debug-updates,
    gdk-window-process-all-updates,
    gdk-window-constrain-size,
    gdk-window-at-pointer,
    gdk-window-new,
    <GdkWindow*>,
    <GdkWindow>,
    <GdkWMFunction*>,
    <GdkWMFunction>,
    $gdk-func-close,
    $gdk-func-maximize,
    $gdk-func-minimize,
    $gdk-func-move,
    $gdk-func-resize,
    $gdk-func-all,
    <GdkWMDecoration*>,
    <GdkWMDecoration>,
    $gdk-decor-maximize,
    $gdk-decor-minimize,
    $gdk-decor-menu,
    $gdk-decor-title,
    $gdk-decor-resizeh,
    $gdk-decor-border,
    $gdk-decor-all,
    <GdkVisualType*>,
    <GdkVisualType>,
    $gdk-visual-direct-color,
    $gdk-visual-true-color,
    $gdk-visual-pseudo-color,
    $gdk-visual-static-color,
    $gdk-visual-grayscale,
    $gdk-visual-static-gray,
    gdk-visual-get-visual-type,
    gdk-visual-get-screen,
    gdk-visual-get-red-pixel-details,
    gdk-visual-get-green-pixel-details,
    gdk-visual-get-depth,
    gdk-visual-get-colormap-size,
    gdk-visual-get-byte-order,
    gdk-visual-get-blue-pixel-details,
    gdk-visual-get-bits-per-rgb,
    gdk-visual-get-system,
    gdk-visual-get-best-with-type,
    gdk-visual-get-best-with-depth,
    gdk-visual-get-best-with-both,
    gdk-visual-get-best-type,
    gdk-visual-get-best-depth,
    gdk-visual-get-best,
    <GdkVisual*>,
    <GdkVisual>,
    <GdkVisibilityState*>,
    <GdkVisibilityState>,
    $gdk-visibility-fully-obscured,
    $gdk-visibility-partial,
    $gdk-visibility-unobscured,
    gdk-time-coord-axes-setter,
    gdk-time-coord-axes,
    gdk-time-coord-time-setter,
    gdk-time-coord-time,
    <GdkTimeCoord>,
    <GdkStatus*>,
    <GdkStatus>,
    $gdk-error-mem,
    $gdk-error-file,
    $gdk-error-param,
    $gdk-error,
    $gdk-ok,
    <GdkSettingAction*>,
    <GdkSettingAction>,
    $gdk-setting-action-deleted,
    $gdk-setting-action-changed,
    $gdk-setting-action-new,
    <GdkScrollDirection*>,
    <GdkScrollDirection>,
    $gdk-scroll-smooth,
    $gdk-scroll-right,
    $gdk-scroll-left,
    $gdk-scroll-down,
    $gdk-scroll-up,
    gdk-screen-set-resolution,
    gdk-screen-set-font-options,
    gdk-screen-make-display-name,
    gdk-screen-list-visuals,
    gdk-screen-is-composited,
    gdk-screen-get-window-stack,
    gdk-screen-get-width-mm,
    gdk-screen-get-width,
    gdk-screen-get-toplevel-windows,
    gdk-screen-get-system-visual,
    gdk-screen-get-setting,
    gdk-screen-get-root-window,
    gdk-screen-get-rgba-visual,
    gdk-screen-get-resolution,
    gdk-screen-get-primary-monitor,
    gdk-screen-get-number,
    gdk-screen-get-n-monitors,
    gdk-screen-get-monitor-workarea,
    gdk-screen-get-monitor-width-mm,
    gdk-screen-get-monitor-plug-name,
    gdk-screen-get-monitor-height-mm,
    gdk-screen-get-monitor-geometry,
    gdk-screen-get-monitor-at-window,
    gdk-screen-get-monitor-at-point,
    gdk-screen-get-height-mm,
    gdk-screen-get-height,
    gdk-screen-get-font-options,
    gdk-screen-get-display,
    gdk-screen-get-active-window,
    gdk-screen-width-mm,
    gdk-screen-width,
    gdk-screen-height-mm,
    gdk-screen-height,
    gdk-screen-get-default,
    <GdkScreen*>,
    <GdkScreen>,
    gdk-rgba-to-string,
    gdk-rgba-parse,
    gdk-rgba-hash,
    gdk-rgba-free,
    gdk-rgba-equal,
    gdk-rgba-copy,
    gdk-rgba-alpha-setter,
    gdk-rgba-alpha,
    gdk-rgba-blue-setter,
    gdk-rgba-blue,
    gdk-rgba-green-setter,
    gdk-rgba-green,
    gdk-rgba-red-setter,
    gdk-rgba-red,
    <GdkRGBA>,
    <GdkPropertyState*>,
    <GdkPropertyState>,
    $gdk-property-delete,
    $gdk-property-new-value,
    <GdkPropMode*>,
    <GdkPropMode>,
    $gdk-prop-mode-append,
    $gdk-prop-mode-prepend,
    $gdk-prop-mode-replace,
    gdk-point-y-setter,
    gdk-point-y,
    gdk-point-x-setter,
    gdk-point-x,
    <GdkPoint>,
    $priority-redraw,
    $parent-relative,
    <GdkOwnerChange*>,
    <GdkOwnerChange>,
    $gdk-owner-change-close,
    $gdk-owner-change-destroy,
    $gdk-owner-change-new-owner,
    <GdkNotifyType*>,
    <GdkNotifyType>,
    $gdk-notify-unknown,
    $gdk-notify-nonlinear-virtual,
    $gdk-notify-nonlinear,
    $gdk-notify-inferior,
    $gdk-notify-virtual,
    $gdk-notify-ancestor,
    <GdkModifierType*>,
    <GdkModifierType>,
    $gdk-modifier-mask,
    $gdk-release-mask,
    $gdk-modifier-reserved-29-mask,
    $gdk-meta-mask,
    $gdk-hyper-mask,
    $gdk-super-mask,
    $gdk-modifier-reserved-25-mask,
    $gdk-modifier-reserved-24-mask,
    $gdk-modifier-reserved-23-mask,
    $gdk-modifier-reserved-22-mask,
    $gdk-modifier-reserved-21-mask,
    $gdk-modifier-reserved-20-mask,
    $gdk-modifier-reserved-19-mask,
    $gdk-modifier-reserved-18-mask,
    $gdk-modifier-reserved-17-mask,
    $gdk-modifier-reserved-16-mask,
    $gdk-modifier-reserved-15-mask,
    $gdk-modifier-reserved-14-mask,
    $gdk-modifier-reserved-13-mask,
    $gdk-button5-mask,
    $gdk-button4-mask,
    $gdk-button3-mask,
    $gdk-button2-mask,
    $gdk-button1-mask,
    $gdk-mod5-mask,
    $gdk-mod4-mask,
    $gdk-mod3-mask,
    $gdk-mod2-mask,
    $gdk-mod1-mask,
    $gdk-control-mask,
    $gdk-lock-mask,
    $gdk-shift-mask,
    <GdkModifierIntent*>,
    <GdkModifierIntent>,
    $gdk-modifier-intent-shift-group,
    $gdk-modifier-intent-no-text-input,
    $gdk-modifier-intent-modify-selection,
    $gdk-modifier-intent-extend-selection,
    $gdk-modifier-intent-context-menu,
    $gdk-modifier-intent-primary-accelerator,
    $max-timecoord-axes,
    gdk-keymap-key-level-setter,
    gdk-keymap-key-level,
    gdk-keymap-key-group-setter,
    gdk-keymap-key-group,
    gdk-keymap-key-keycode-setter,
    gdk-keymap-key-keycode,
    <GdkKeymapKey>,
    gdk-keymap-translate-keyboard-state,
    gdk-keymap-map-virtual-modifiers,
    gdk-keymap-lookup-key,
    gdk-keymap-have-bidi-layouts,
    gdk-keymap-get-num-lock-state,
    gdk-keymap-get-modifier-state,
    gdk-keymap-get-modifier-mask,
    gdk-keymap-get-entries-for-keyval,
    gdk-keymap-get-entries-for-keycode,
    gdk-keymap-get-direction,
    gdk-keymap-get-caps-lock-state,
    gdk-keymap-add-virtual-modifiers,
    gdk-keymap-get-for-display,
    gdk-keymap-get-default,
    <GdkKeymap*>,
    <GdkKeymap>,
    $key-zerosuperior,
    $key-zerosubscript,
    $key-yen,
    $key-vt,
    $key-voicedsound,
    $key-vertconnector,
    $key-vertbar,
    $key-variation,
    $key-uptack,
    $key-upstile,
    $key-upshoe,
    $key-uprightcorner,
    $key-upleftcorner,
    $key-upcaret,
    $key-uparrow,
    $key-union,
    $key-underscore,
    $key-underbar,
    $key-twothirds,
    $key-twosuperior,
    $key-twosubscript,
    $key-twofifths,
    $key-trademarkincircle,
    $key-trademark,
    $key-topvertsummationconnector,
    $key-topt,
    $key-toprightsummation,
    $key-toprightsqbracket,
    $key-toprightparens,
    $key-topleftsummation,
    $key-topleftsqbracket,
    $key-topleftradical,
    $key-topleftparens,
    $key-topintegral,
    $key-tintegral,
    $key-threesuperior,
    $key-threesubscript,
    $key-threequarters,
    $key-threefifths,
    $key-threeeighths,
    $key-thinspace,
    $key-therefore,
    $key-telephonerecorder,
    $key-telephone,
    $key-stricteq,
    $key-sterling,
    $key-ssharp,
    $key-squareroot,
    $key-space,
    $key-soliddiamond,
    $key-slash,
    $key-sixsuperior,
    $key-sixsubscript,
    $key-singlelowquotemark,
    $key-similarequal,
    $key-signifblank,
    $key-signaturemark,
    $key-sevensuperior,
    $key-sevensubscript,
    $key-seveneighths,
    $key-semivoicedsound,
    $key-semicolon,
    $key-section,
    $key-seconds,
    $key-script-switch,
    $key-righttack,
    $key-rightt,
    $key-rightsinglequotemark,
    $key-rightshoe,
    $key-rightpointer,
    $key-rightopentriangle,
    $key-rightmiddlesummation,
    $key-rightmiddlecurlybrace,
    $key-rightdoublequotemark,
    $key-rightcaret,
    $key-rightarrow,
    $key-rightanglebracket,
    $key-registered,
    $key-radical,
    $key-quoteright,
    $key-quoteleft,
    $key-quotedbl,
    $key-questiondown,
    $key-question,
    $key-quad,
    $key-punctspace,
    $key-prolongedsound,
    $key-prescription,
    $key-plusminus,
    $key-plus,
    $key-phonographcopyright,
    $key-permille,
    $key-periodcentered,
    $key-period,
    $key-percent,
    $key-partialderivative,
    $key-partdifferential,
    $key-parenright,
    $key-parenleft,
    $key-paragraph,
    $key-overline,
    $key-overbar,
    $key-ordfeminine,
    $key-opentribulletup,
    $key-opentribulletdown,
    $key-openstar,
    $key-openrectbullet,
    $key-onethird,
    $key-onesuperior,
    $key-onesubscript,
    $key-onesixth,
    $key-onequarter,
    $key-onehalf,
    $key-onefifth,
    $key-oneeighth,
    $key-ogonek,
    $key-numerosign,
    $key-numbersign,
    $key-notsign,
    $key-notidentical,
    $key-notequal,
    $key-notelementof,
    $key-notapproxeq,
    $key-nobreakspace,
    $key-nl,
    $key-ninesuperior,
    $key-ninesubscript,
    $key-nabla,
    $key-musicalsharp,
    $key-musicalflat,
    $key-multiply,
    $key-mu,
    $key-minutes,
    $key-minus,
    $key-masculine,
    $key-marker,
    $key-maltesecross,
    $key-malesymbol,
    $key-macron,
    $key-lowrightcorner,
    $key-lowleftcorner,
    $key-logicalor,
    $key-logicaland,
    $key-lf,
    $key-lessthanequal,
    $key-less,
    $key-lefttack,
    $key-leftt,
    $key-leftsinglequotemark,
    $key-leftshoe,
    $key-leftradical,
    $key-leftpointer,
    $key-leftopentriangle,
    $key-leftmiddlecurlybrace,
    $key-leftdoublequotemark,
    $key-leftcaret,
    $key-leftarrow,
    $key-leftanglebracket,
    $key-latincross,
    $key-kra,
    $key-kappa,
    $key-kana-switch,
    $key-kana-openingbracket,
    $key-kana-middledot,
    $key-kana-fullstop,
    $key-kana-conjunctive,
    $key-kana-comma,
    $key-kana-closingbracket,
    $key-kana-yu,
    $key-kana-yo,
    $key-kana-ya,
    $key-kana-wo,
    $key-kana-wa,
    $key-kana-u,
    $key-kana-tu,
    $key-kana-tsu,
    $key-kana-to,
    $key-kana-ti,
    $key-kana-te,
    $key-kana-ta,
    $key-kana-su,
    $key-kana-so,
    $key-kana-shi,
    $key-kana-se,
    $key-kana-sa,
    $key-kana-ru,
    $key-kana-ro,
    $key-kana-ri,
    $key-kana-re,
    $key-kana-ra,
    $key-kana-o,
    $key-kana-nu,
    $key-kana-no,
    $key-kana-ni,
    $key-kana-ne,
    $key-kana-na,
    $key-kana-n,
    $key-kana-mu,
    $key-kana-mo,
    $key-kana-mi,
    $key-kana-me,
    $key-kana-ma,
    $key-kana-ku,
    $key-kana-ko,
    $key-kana-ki,
    $key-kana-ke,
    $key-kana-ka,
    $key-kana-i,
    $key-kana-hu,
    $key-kana-ho,
    $key-kana-hi,
    $key-kana-he,
    $key-kana-ha,
    $key-kana-fu,
    $key-kana-e,
    $key-kana-chi,
    $key-kana-a,
    $key-jot,
    $key-intersection,
    $key-integral,
    $key-infinity,
    $key-includes,
    $key-includedin,
    $key-implies,
    $key-ifonlyif,
    $key-idotless,
    $key-identical,
    $key-i-touch,
    $key-hyphen,
    $key-ht,
    $key-horizlinescan9,
    $key-horizlinescan7,
    $key-horizlinescan5,
    $key-horizlinescan3,
    $key-horizlinescan1,
    $key-horizconnector,
    $key-hexagram,
    $key-hebrew-zayin,
    $key-hebrew-zain,
    $key-hebrew-zadi,
    $key-hebrew-zade,
    $key-hebrew-yod,
    $key-hebrew-waw,
    $key-hebrew-teth,
    $key-hebrew-tet,
    $key-hebrew-taw,
    $key-hebrew-taf,
    $key-hebrew-shin,
    $key-hebrew-samekh,
    $key-hebrew-samech,
    $key-hebrew-resh,
    $key-hebrew-qoph,
    $key-hebrew-pe,
    $key-hebrew-nun,
    $key-hebrew-mem,
    $key-hebrew-lamed,
    $key-hebrew-kuf,
    $key-hebrew-kaph,
    $key-hebrew-het,
    $key-hebrew-he,
    $key-hebrew-gimmel,
    $key-hebrew-gimel,
    $key-hebrew-finalzadi,
    $key-hebrew-finalzade,
    $key-hebrew-finalpe,
    $key-hebrew-finalnun,
    $key-hebrew-finalmem,
    $key-hebrew-finalkaph,
    $key-hebrew-doublelowline,
    $key-hebrew-daleth,
    $key-hebrew-dalet,
    $key-hebrew-chet,
    $key-hebrew-beth,
    $key-hebrew-bet,
    $key-hebrew-ayin,
    $key-hebrew-aleph,
    $key-heart,
    $key-hairspace,
    $key-guillemotright,
    $key-guillemotleft,
    $key-greaterthanequal,
    $key-greater,
    $key-grave,
    $key-function,
    $key-fourthroot,
    $key-foursuperior,
    $key-foursubscript,
    $key-fourfifths,
    $key-fivesuperior,
    $key-fivesubscript,
    $key-fivesixths,
    $key-fiveeighths,
    $key-filledtribulletup,
    $key-filledtribulletdown,
    $key-filledrighttribullet,
    $key-filledrectbullet,
    $key-filledlefttribullet,
    $key-figdash,
    $key-ff,
    $key-femalesymbol,
    $key-exclamdown,
    $key-exclam,
    $key-equal,
    $key-enspace,
    $key-enopensquarebullet,
    $key-enopencircbullet,
    $key-enfilledsqbullet,
    $key-enfilledcircbullet,
    $key-endash,
    $key-emspace,
    $key-emptyset,
    $key-emopenrectangle,
    $key-emopencircle,
    $key-emfilledrect,
    $key-emfilledcircle,
    $key-emdash,
    $key-em4space,
    $key-em3space,
    $key-ellipsis,
    $key-elementof,
    $key-eightsuperior,
    $key-eightsubscript,
    $key-downtack,
    $key-downstile,
    $key-downshoe,
    $key-downcaret,
    $key-downarrow,
    $key-doublelowquotemark,
    $key-doubledagger,
    $key-doubleacute,
    $key-doubbaselinedot,
    $key-dollar,
    $key-division,
    $key-dintegral,
    $key-digitspace,
    $key-diamond,
    $key-diaeresis,
    $key-degree,
    $key-decimalpoint,
    $key-dead-voiced-sound,
    $key-dead-tilde,
    $key-dead-stroke,
    $key-dead-small-schwa,
    $key-dead-semivoiced-sound,
    $key-dead-psili,
    $key-dead-perispomeni,
    $key-dead-ogonek,
    $key-dead-macron,
    $key-dead-iota,
    $key-dead-invertedbreve,
    $key-dead-horn,
    $key-dead-hook,
    $key-dead-greek,
    $key-dead-grave,
    $key-dead-doublegrave,
    $key-dead-doubleacute,
    $key-dead-diaeresis,
    $key-dead-dasia,
    $key-dead-currency,
    $key-dead-circumflex,
    $key-dead-cedilla,
    $key-dead-caron,
    $key-dead-capital-schwa,
    $key-dead-breve,
    $key-dead-belowtilde,
    $key-dead-belowring,
    $key-dead-belowmacron,
    $key-dead-belowdot,
    $key-dead-belowdiaeresis,
    $key-dead-belowcomma,
    $key-dead-belowcircumflex,
    $key-dead-belowbreve,
    $key-dead-acute,
    $key-dead-abovering,
    $key-dead-abovereversedcomma,
    $key-dead-abovedot,
    $key-dead-abovecomma,
    $key-dead-u,
    $key-dead-o,
    $key-dead-i,
    $key-dead-e,
    $key-dead-a,
    $key-dagger,
    $key-cursor,
    $key-currency,
    $key-cuberoot,
    $key-crossinglines,
    $key-cr,
    $key-copyright,
    $key-containsas,
    $key-comma,
    $key-colon,
    $key-club,
    $key-circle,
    $key-checkmark,
    $key-checkerboard,
    $key-cent,
    $key-cedilla,
    $key-caron,
    $key-caret,
    $key-careof,
    $key-brokenbar,
    $key-breve,
    $key-braille-dots-8,
    $key-braille-dots-78,
    $key-braille-dots-7,
    $key-braille-dots-68,
    $key-braille-dots-678,
    $key-braille-dots-67,
    $key-braille-dots-6,
    $key-braille-dots-58,
    $key-braille-dots-578,
    $key-braille-dots-57,
    $key-braille-dots-568,
    $key-braille-dots-5678,
    $key-braille-dots-567,
    $key-braille-dots-56,
    $key-braille-dots-5,
    $key-braille-dots-48,
    $key-braille-dots-478,
    $key-braille-dots-47,
    $key-braille-dots-468,
    $key-braille-dots-4678,
    $key-braille-dots-467,
    $key-braille-dots-46,
    $key-braille-dots-458,
    $key-braille-dots-4578,
    $key-braille-dots-457,
    $key-braille-dots-4568,
    $key-braille-dots-45678,
    $key-braille-dots-4567,
    $key-braille-dots-456,
    $key-braille-dots-45,
    $key-braille-dots-4,
    $key-braille-dots-38,
    $key-braille-dots-378,
    $key-braille-dots-37,
    $key-braille-dots-368,
    $key-braille-dots-3678,
    $key-braille-dots-367,
    $key-braille-dots-36,
    $key-braille-dots-358,
    $key-braille-dots-3578,
    $key-braille-dots-357,
    $key-braille-dots-3568,
    $key-braille-dots-35678,
    $key-braille-dots-3567,
    $key-braille-dots-356,
    $key-braille-dots-35,
    $key-braille-dots-348,
    $key-braille-dots-3478,
    $key-braille-dots-347,
    $key-braille-dots-3468,
    $key-braille-dots-34678,
    $key-braille-dots-3467,
    $key-braille-dots-346,
    $key-braille-dots-3458,
    $key-braille-dots-34578,
    $key-braille-dots-3457,
    $key-braille-dots-34568,
    $key-braille-dots-345678,
    $key-braille-dots-34567,
    $key-braille-dots-3456,
    $key-braille-dots-345,
    $key-braille-dots-34,
    $key-braille-dots-3,
    $key-braille-dots-28,
    $key-braille-dots-278,
    $key-braille-dots-27,
    $key-braille-dots-268,
    $key-braille-dots-2678,
    $key-braille-dots-267,
    $key-braille-dots-26,
    $key-braille-dots-258,
    $key-braille-dots-2578,
    $key-braille-dots-257,
    $key-braille-dots-2568,
    $key-braille-dots-25678,
    $key-braille-dots-2567,
    $key-braille-dots-256,
    $key-braille-dots-25,
    $key-braille-dots-248,
    $key-braille-dots-2478,
    $key-braille-dots-247,
    $key-braille-dots-2468,
    $key-braille-dots-24678,
    $key-braille-dots-2467,
    $key-braille-dots-246,
    $key-braille-dots-2458,
    $key-braille-dots-24578,
    $key-braille-dots-2457,
    $key-braille-dots-24568,
    $key-braille-dots-245678,
    $key-braille-dots-24567,
    $key-braille-dots-2456,
    $key-braille-dots-245,
    $key-braille-dots-24,
    $key-braille-dots-238,
    $key-braille-dots-2378,
    $key-braille-dots-237,
    $key-braille-dots-2368,
    $key-braille-dots-23678,
    $key-braille-dots-2367,
    $key-braille-dots-236,
    $key-braille-dots-2358,
    $key-braille-dots-23578,
    $key-braille-dots-2357,
    $key-braille-dots-23568,
    $key-braille-dots-235678,
    $key-braille-dots-23567,
    $key-braille-dots-2356,
    $key-braille-dots-235,
    $key-braille-dots-2348,
    $key-braille-dots-23478,
    $key-braille-dots-2347,
    $key-braille-dots-23468,
    $key-braille-dots-234678,
    $key-braille-dots-23467,
    $key-braille-dots-2346,
    $key-braille-dots-23458,
    $key-braille-dots-234578,
    $key-braille-dots-23457,
    $key-braille-dots-234568,
    $key-braille-dots-2345678,
    $key-braille-dots-234567,
    $key-braille-dots-23456,
    $key-braille-dots-2345,
    $key-braille-dots-234,
    $key-braille-dots-23,
    $key-braille-dots-2,
    $key-braille-dots-18,
    $key-braille-dots-178,
    $key-braille-dots-17,
    $key-braille-dots-168,
    $key-braille-dots-1678,
    $key-braille-dots-167,
    $key-braille-dots-16,
    $key-braille-dots-158,
    $key-braille-dots-1578,
    $key-braille-dots-157,
    $key-braille-dots-1568,
    $key-braille-dots-15678,
    $key-braille-dots-1567,
    $key-braille-dots-156,
    $key-braille-dots-15,
    $key-braille-dots-148,
    $key-braille-dots-1478,
    $key-braille-dots-147,
    $key-braille-dots-1468,
    $key-braille-dots-14678,
    $key-braille-dots-1467,
    $key-braille-dots-146,
    $key-braille-dots-1458,
    $key-braille-dots-14578,
    $key-braille-dots-1457,
    $key-braille-dots-14568,
    $key-braille-dots-145678,
    $key-braille-dots-14567,
    $key-braille-dots-1456,
    $key-braille-dots-145,
    $key-braille-dots-14,
    $key-braille-dots-138,
    $key-braille-dots-1378,
    $key-braille-dots-137,
    $key-braille-dots-1368,
    $key-braille-dots-13678,
    $key-braille-dots-1367,
    $key-braille-dots-136,
    $key-braille-dots-1358,
    $key-braille-dots-13578,
    $key-braille-dots-1357,
    $key-braille-dots-13568,
    $key-braille-dots-135678,
    $key-braille-dots-13567,
    $key-braille-dots-1356,
    $key-braille-dots-135,
    $key-braille-dots-1348,
    $key-braille-dots-13478,
    $key-braille-dots-1347,
    $key-braille-dots-13468,
    $key-braille-dots-134678,
    $key-braille-dots-13467,
    $key-braille-dots-1346,
    $key-braille-dots-13458,
    $key-braille-dots-134578,
    $key-braille-dots-13457,
    $key-braille-dots-134568,
    $key-braille-dots-1345678,
    $key-braille-dots-134567,
    $key-braille-dots-13456,
    $key-braille-dots-1345,
    $key-braille-dots-134,
    $key-braille-dots-13,
    $key-braille-dots-128,
    $key-braille-dots-1278,
    $key-braille-dots-127,
    $key-braille-dots-1268,
    $key-braille-dots-12678,
    $key-braille-dots-1267,
    $key-braille-dots-126,
    $key-braille-dots-1258,
    $key-braille-dots-12578,
    $key-braille-dots-1257,
    $key-braille-dots-12568,
    $key-braille-dots-125678,
    $key-braille-dots-12567,
    $key-braille-dots-1256,
    $key-braille-dots-125,
    $key-braille-dots-1248,
    $key-braille-dots-12478,
    $key-braille-dots-1247,
    $key-braille-dots-12468,
    $key-braille-dots-124678,
    $key-braille-dots-12467,
    $key-braille-dots-1246,
    $key-braille-dots-12458,
    $key-braille-dots-124578,
    $key-braille-dots-12457,
    $key-braille-dots-124568,
    $key-braille-dots-1245678,
    $key-braille-dots-124567,
    $key-braille-dots-12456,
    $key-braille-dots-1245,
    $key-braille-dots-124,
    $key-braille-dots-1238,
    $key-braille-dots-12378,
    $key-braille-dots-1237,
    $key-braille-dots-12368,
    $key-braille-dots-123678,
    $key-braille-dots-12367,
    $key-braille-dots-1236,
    $key-braille-dots-12358,
    $key-braille-dots-123578,
    $key-braille-dots-12357,
    $key-braille-dots-123568,
    $key-braille-dots-1235678,
    $key-braille-dots-123567,
    $key-braille-dots-12356,
    $key-braille-dots-1235,
    $key-braille-dots-12348,
    $key-braille-dots-123478,
    $key-braille-dots-12347,
    $key-braille-dots-123468,
    $key-braille-dots-1234678,
    $key-braille-dots-123467,
    $key-braille-dots-12346,
    $key-braille-dots-123458,
    $key-braille-dots-1234578,
    $key-braille-dots-123457,
    $key-braille-dots-1234568,
    $key-braille-dots-12345678,
    $key-braille-dots-1234567,
    $key-braille-dots-123456,
    $key-braille-dots-12345,
    $key-braille-dots-1234,
    $key-braille-dots-123,
    $key-braille-dots-12,
    $key-braille-dots-1,
    $key-braille-dot-9,
    $key-braille-dot-8,
    $key-braille-dot-7,
    $key-braille-dot-6,
    $key-braille-dot-5,
    $key-braille-dot-4,
    $key-braille-dot-3,
    $key-braille-dot-2,
    $key-braille-dot-10,
    $key-braille-dot-1,
    $key-braille-blank,
    $key-bracketright,
    $key-bracketleft,
    $key-braceright,
    $key-braceleft,
    $key-botvertsummationconnector,
    $key-bott,
    $key-botrightsummation,
    $key-botrightsqbracket,
    $key-botrightparens,
    $key-botleftsummation,
    $key-botleftsqbracket,
    $key-botleftparens,
    $key-botintegral,
    $key-blank,
    $key-because,
    $key-bar,
    $key-ballotcross,
    $key-backslash,
    $key-at,
    $key-asterisk,
    $key-asciitilde,
    $key-asciicircum,
    $key-approximate,
    $key-approxeq,
    $key-apostrophe,
    $key-ampersand,
    $key-acute,
    $key-abovedot,
    $key-zstroke,
    $key-zoom-out,
    $key-zoom-in,
    $key-zenkaku-hankaku,
    $key-zenkaku,
    $key-zen-koho,
    $key-zcaron,
    $key-zacute,
    $key-zabovedot,
    $key-z,
    $key-ytilde,
    $key-yhook,
    $key-ygrave,
    $key-yellow,
    $key-ydiaeresis,
    $key-ycircumflex,
    $key-ybelowdot,
    $key-yacute,
    $key-y,
    $key-xfer,
    $key-xabovedot,
    $key-x,
    $key-word,
    $key-won-sign,
    $key-window-clear,
    $key-wheel-button,
    $key-wgrave,
    $key-web-cam,
    $key-wdiaeresis,
    $key-wcircumflex,
    $key-wake-up,
    $key-wacute,
    $key-www,
    $key-wlan,
    $key-w,
    $key-void-symbol,
    $key-view,
    $key-video,
    $key-vendor-home,
    $key-v,
    $key-utilde,
    $key-user-pb,
    $key-user2kb,
    $key-user1kb,
    $key-uring,
    $key-up,
    $key-uogonek,
    $key-ungrab,
    $key-undo,
    $key-umacron,
    $key-ukranian-yi,
    $key-ukranian-je,
    $key-ukranian-i,
    $key-ukrainian-yi,
    $key-ukrainian-ie,
    $key-ukrainian-i,
    $key-ukrainian-ghe-with-upturn,
    $key-uhorntilde,
    $key-uhornhook,
    $key-uhorngrave,
    $key-uhornbelowdot,
    $key-uhornacute,
    $key-uhorn,
    $key-uhook,
    $key-ugrave,
    $key-udoubleacute,
    $key-udiaeresis,
    $key-ucircumflex,
    $key-ubreve,
    $key-ubelowdot,
    $key-uacute,
    $key-uwb,
    $key-u,
    $key-tslash,
    $key-travel,
    $key-touroku,
    $key-touchpad-toggle,
    $key-touchpad-on,
    $key-touchpad-off,
    $key-top-menu,
    $key-tools,
    $key-to-do-list,
    $key-time,
    $key-thai-yoying,
    $key-thai-yoyak,
    $key-thai-wowaen,
    $key-thai-totao,
    $key-thai-topatak,
    $key-thai-thothung,
    $key-thai-thothong,
    $key-thai-thothan,
    $key-thai-thothahan,
    $key-thai-thophuthao,
    $key-thai-thonangmontho,
    $key-thai-thanthakhat,
    $key-thai-sosua,
    $key-thai-soso,
    $key-thai-sosala,
    $key-thai-sorusi,
    $key-thai-sarauu,
    $key-thai-sarauee,
    $key-thai-saraue,
    $key-thai-sarau,
    $key-thai-sarao,
    $key-thai-saraii,
    $key-thai-sarai,
    $key-thai-sarae,
    $key-thai-saraam,
    $key-thai-saraaimaimuan,
    $key-thai-saraaimaimalai,
    $key-thai-saraae,
    $key-thai-saraaa,
    $key-thai-saraa,
    $key-thai-ru,
    $key-thai-rorua,
    $key-thai-popla,
    $key-thai-phosamphao,
    $key-thai-phophung,
    $key-thai-phophan,
    $key-thai-phinthu,
    $key-thai-paiyannoi,
    $key-thai-oang,
    $key-thai-nonu,
    $key-thai-nonen,
    $key-thai-nikhahit,
    $key-thai-ngongu,
    $key-thai-moma,
    $key-thai-maiyamok,
    $key-thai-maitri,
    $key-thai-maitho,
    $key-thai-maitaikhu,
    $key-thai-maihanakat-maitho,
    $key-thai-maihanakat,
    $key-thai-maiek,
    $key-thai-maichattawa,
    $key-thai-lu,
    $key-thai-loling,
    $key-thai-lochula,
    $key-thai-leksun,
    $key-thai-leksong,
    $key-thai-leksi,
    $key-thai-leksam,
    $key-thai-lekpaet,
    $key-thai-leknung,
    $key-thai-lekkao,
    $key-thai-lekhok,
    $key-thai-lekha,
    $key-thai-lekchet,
    $key-thai-lakkhangyao,
    $key-thai-kokai,
    $key-thai-khorakhang,
    $key-thai-khokhwai,
    $key-thai-khokhuat,
    $key-thai-khokhon,
    $key-thai-khokhai,
    $key-thai-honokhuk,
    $key-thai-hohip,
    $key-thai-fofan,
    $key-thai-fofa,
    $key-thai-dodek,
    $key-thai-dochada,
    $key-thai-chochoe,
    $key-thai-choching,
    $key-thai-chochang,
    $key-thai-chochan,
    $key-thai-bobaimai,
    $key-thai-baht,
    $key-terminate-server,
    $key-terminal,
    $key-tcedilla,
    $key-tcaron,
    $key-task-pane,
    $key-tabovedot,
    $key-tab,
    $key-thorn,
    $key-t,
    $key-sys-req,
    $key-switch-vt-9,
    $key-switch-vt-8,
    $key-switch-vt-7,
    $key-switch-vt-6,
    $key-switch-vt-5,
    $key-switch-vt-4,
    $key-switch-vt-3,
    $key-switch-vt-2,
    $key-switch-vt-12,
    $key-switch-vt-11,
    $key-switch-vt-10,
    $key-switch-vt-1,
    $key-suspend,
    $key-support,
    $key-super-r,
    $key-super-l,
    $key-subtitle,
    $key-stop,
    $key-sticky-keys-enable,
    $key-start,
    $key-standby,
    $key-split-screen,
    $key-spell,
    $key-slow-keys-enable,
    $key-sleep,
    $key-sinh-ya,
    $key-sinh-va,
    $key-sinh-uu2,
    $key-sinh-uu,
    $key-sinh-u2,
    $key-sinh-u,
    $key-sinh-ttha,
    $key-sinh-tta,
    $key-sinh-thha,
    $key-sinh-tha,
    $key-sinh-ssha,
    $key-sinh-sha,
    $key-sinh-sa,
    $key-sinh-ruu2,
    $key-sinh-ru2,
    $key-sinh-rii,
    $key-sinh-ri,
    $key-sinh-ra,
    $key-sinh-pha,
    $key-sinh-pa,
    $key-sinh-oo2,
    $key-sinh-oo,
    $key-sinh-o2,
    $key-sinh-o,
    $key-sinh-nya,
    $key-sinh-nna,
    $key-sinh-nja,
    $key-sinh-nga,
    $key-sinh-ng2,
    $key-sinh-ng,
    $key-sinh-ndha,
    $key-sinh-ndda,
    $key-sinh-na,
    $key-sinh-mba,
    $key-sinh-ma,
    $key-sinh-luu2,
    $key-sinh-luu,
    $key-sinh-lu2,
    $key-sinh-lu,
    $key-sinh-lla,
    $key-sinh-la,
    $key-sinh-kunddaliya,
    $key-sinh-kha,
    $key-sinh-ka,
    $key-sinh-jnya,
    $key-sinh-jha,
    $key-sinh-ja,
    $key-sinh-ii2,
    $key-sinh-ii,
    $key-sinh-i2,
    $key-sinh-i,
    $key-sinh-ha,
    $key-sinh-h2,
    $key-sinh-gha,
    $key-sinh-ga,
    $key-sinh-fa,
    $key-sinh-ee2,
    $key-sinh-ee,
    $key-sinh-e2,
    $key-sinh-e,
    $key-sinh-dhha,
    $key-sinh-dha,
    $key-sinh-ddha,
    $key-sinh-dda,
    $key-sinh-cha,
    $key-sinh-ca,
    $key-sinh-bha,
    $key-sinh-ba,
    $key-sinh-au2,
    $key-sinh-au,
    $key-sinh-al,
    $key-sinh-ai2,
    $key-sinh-ai,
    $key-sinh-aee2,
    $key-sinh-aee,
    $key-sinh-ae2,
    $key-sinh-ae,
    $key-sinh-aa2,
    $key-sinh-aa,
    $key-sinh-a,
    $key-single-candidate,
    $key-shop,
    $key-shift-r,
    $key-shift-lock,
    $key-shift-l,
    $key-serbian-tshe,
    $key-serbian-nje,
    $key-serbian-lje,
    $key-serbian-je,
    $key-serbian-dze,
    $key-serbian-dje,
    $key-send,
    $key-select-button,
    $key-select,
    $key-search,
    $key-scroll-lock,
    $key-scroll-up,
    $key-scroll-down,
    $key-scroll-click,
    $key-screen-saver,
    $key-scircumflex,
    $key-scedilla,
    $key-scaron,
    $key-save,
    $key-sacute,
    $key-sabovedot,
    $key-schwa,
    $key-s,
    $key-rupee-sign,
    $key-rotation-pb,
    $key-rotation-kb,
    $key-rotate-windows,
    $key-romaji,
    $key-rocker-up,
    $key-rocker-enter,
    $key-rocker-down,
    $key-right,
    $key-return,
    $key-reply,
    $key-repeat-keys-enable,
    $key-reload,
    $key-refresh,
    $key-redo,
    $key-red,
    $key-rcedilla,
    $key-rcaron,
    $key-racute,
    $key-r9,
    $key-r8,
    $key-r7,
    $key-r6,
    $key-r5,
    $key-r4,
    $key-r3,
    $key-r2,
    $key-r15,
    $key-r14,
    $key-r13,
    $key-r12,
    $key-r11,
    $key-r10,
    $key-r1,
    $key-r,
    $key-q,
    $key-prior,
    $key-print,
    $key-previous-candidate,
    $key-prev-virtual-screen,
    $key-prev-v-mode,
    $key-power-off,
    $key-power-down,
    $key-pointer-up-right,
    $key-pointer-up-left,
    $key-pointer-up,
    $key-pointer-right,
    $key-pointer-left,
    $key-pointer-enable-keys,
    $key-pointer-drag-dflt,
    $key-pointer-drag5,
    $key-pointer-drag4,
    $key-pointer-drag3,
    $key-pointer-drag2,
    $key-pointer-drag1,
    $key-pointer-down-right,
    $key-pointer-down-left,
    $key-pointer-down,
    $key-pointer-dflt-btn-prev,
    $key-pointer-dflt-btn-next,
    $key-pointer-dbl-click-dflt,
    $key-pointer-dbl-click5,
    $key-pointer-dbl-click4,
    $key-pointer-dbl-click3,
    $key-pointer-dbl-click2,
    $key-pointer-dbl-click1,
    $key-pointer-button-dflt,
    $key-pointer-button5,
    $key-pointer-button4,
    $key-pointer-button3,
    $key-pointer-button2,
    $key-pointer-button1,
    $key-pointer-accelerate,
    $key-pictures,
    $key-phone,
    $key-peseta-sign,
    $key-pause,
    $key-paste,
    $key-page-up,
    $key-page-down,
    $key-pabovedot,
    $key-p,
    $key-overlay2-enable,
    $key-overlay1-enable,
    $key-otilde,
    $key-oslash,
    $key-option,
    $key-open-url,
    $key-open,
    $key-ooblique,
    $key-omacron,
    $key-ohorntilde,
    $key-ohornhook,
    $key-ohorngrave,
    $key-ohornbelowdot,
    $key-ohornacute,
    $key-ohorn,
    $key-ohook,
    $key-ograve,
    $key-office-home,
    $key-odoubleacute,
    $key-odiaeresis,
    $key-ocircumflextilde,
    $key-ocircumflexhook,
    $key-ocircumflexgrave,
    $key-ocircumflexbelowdot,
    $key-ocircumflexacute,
    $key-ocircumflex,
    $key-ocaron,
    $key-obelowdot,
    $key-obarred,
    $key-oacute,
    $key-oe,
    $key-o,
    $key-num-lock,
    $key-ntilde,
    $key-next-virtual-screen,
    $key-next-v-mode,
    $key-next,
    $key-news,
    $key-new-sheqel-sign,
    $key-new,
    $key-ncedilla,
    $key-ncaron,
    $key-naira-sign,
    $key-nacute,
    $key-n,
    $key-my-sites,
    $key-my-computer,
    $key-music,
    $key-multiple-candidate,
    $key-multi-key,
    $key-muhenkan,
    $key-mouse-keys-enable,
    $key-mouse-keys-accel-enable,
    $key-mon-brightness-up,
    $key-mon-brightness-down,
    $key-mode-switch,
    $key-mode-lock,
    $key-mill-sign,
    $key-meta-r,
    $key-meta-l,
    $key-messenger,
    $key-menu-pb,
    $key-menu-kb,
    $key-menu,
    $key-memo,
    $key-meeting,
    $key-massyo,
    $key-market,
    $key-mail-forward,
    $key-mail,
    $key-mae-koho,
    $key-macedonia-kje,
    $key-macedonia-gje,
    $key-macedonia-dse,
    $key-mabovedot,
    $key-m,
    $key-lstroke,
    $key-log-window-tree,
    $key-log-off,
    $key-log-grab-info,
    $key-lira-sign,
    $key-linefeed,
    $key-light-bulb,
    $key-left,
    $key-lcedilla,
    $key-lcaron,
    $key-lbelowdot,
    $key-launch-f,
    $key-launch-e,
    $key-launch-d,
    $key-launch-c,
    $key-launch-b,
    $key-launch-a,
    $key-launch9,
    $key-launch8,
    $key-launch7,
    $key-launch6,
    $key-launch5,
    $key-launch4,
    $key-launch3,
    $key-launch2,
    $key-launch1,
    $key-launch0,
    $key-last-virtual-screen,
    $key-lacute,
    $key-l9,
    $key-l8,
    $key-l7,
    $key-l6,
    $key-l5,
    $key-l4,
    $key-l3,
    $key-l2,
    $key-l10,
    $key-l1,
    $key-l,
    $key-korean-won,
    $key-kcedilla,
    $key-kbd-light-on-off,
    $key-kbd-brightness-up,
    $key-kbd-brightness-down,
    $key-katakana,
    $key-kanji-bangou,
    $key-kanji,
    $key-kana-shift,
    $key-kana-lock,
    $key-kp-up,
    $key-kp-tab,
    $key-kp-subtract,
    $key-kp-space,
    $key-kp-separator,
    $key-kp-right,
    $key-kp-prior,
    $key-kp-page-up,
    $key-kp-page-down,
    $key-kp-next,
    $key-kp-multiply,
    $key-kp-left,
    $key-kp-insert,
    $key-kp-home,
    $key-kp-f4,
    $key-kp-f3,
    $key-kp-f2,
    $key-kp-f1,
    $key-kp-equal,
    $key-kp-enter,
    $key-kp-end,
    $key-kp-down,
    $key-kp-divide,
    $key-kp-delete,
    $key-kp-decimal,
    $key-kp-begin,
    $key-kp-add,
    $key-kp-9,
    $key-kp-8,
    $key-kp-7,
    $key-kp-6,
    $key-kp-5,
    $key-kp-4,
    $key-kp-3,
    $key-kp-2,
    $key-kp-1,
    $key-kp-0,
    $key-k,
    $key-jcircumflex,
    $key-j,
    $key-itilde,
    $key-iogonek,
    $key-insert,
    $key-imacron,
    $key-ihook,
    $key-igrave,
    $key-idiaeresis,
    $key-icircumflex,
    $key-ibreve,
    $key-ibelowdot,
    $key-iacute,
    $key-iabovedot,
    $key-iso-set-margin-right,
    $key-iso-set-margin-left,
    $key-iso-release-margin-right,
    $key-iso-release-margin-left,
    $key-iso-release-both-margins,
    $key-iso-prev-group-lock,
    $key-iso-prev-group,
    $key-iso-partial-space-right,
    $key-iso-partial-space-left,
    $key-iso-partial-line-up,
    $key-iso-partial-line-down,
    $key-iso-next-group-lock,
    $key-iso-next-group,
    $key-iso-move-line-up,
    $key-iso-move-line-down,
    $key-iso-lock,
    $key-iso-level5-shift,
    $key-iso-level5-lock,
    $key-iso-level5-latch,
    $key-iso-level3-shift,
    $key-iso-level3-lock,
    $key-iso-level3-latch,
    $key-iso-level2-latch,
    $key-iso-left-tab,
    $key-iso-last-group-lock,
    $key-iso-last-group,
    $key-iso-group-shift,
    $key-iso-group-lock,
    $key-iso-group-latch,
    $key-iso-first-group-lock,
    $key-iso-first-group,
    $key-iso-fast-cursor-up,
    $key-iso-fast-cursor-right,
    $key-iso-fast-cursor-left,
    $key-iso-fast-cursor-down,
    $key-iso-enter,
    $key-iso-emphasize,
    $key-iso-discontinuous-underline,
    $key-iso-continuous-underline,
    $key-iso-center-object,
    $key-i,
    $key-hyper-r,
    $key-hyper-l,
    $key-hstroke,
    $key-hot-links,
    $key-home-page,
    $key-home,
    $key-history,
    $key-hiragana-katakana,
    $key-hiragana,
    $key-hibernate,
    $key-henkan-mode,
    $key-henkan,
    $key-help,
    $key-hebrew-switch,
    $key-hcircumflex,
    $key-hankaku,
    $key-hangul-switch,
    $key-hangul-yeorin-hieuh,
    $key-hangul-yu,
    $key-hangul-yo,
    $key-hangul-yi,
    $key-hangul-yeo,
    $key-hangul-ye,
    $key-hangul-yae,
    $key-hangul-ya,
    $key-hangul-wi,
    $key-hangul-weo,
    $key-hangul-we,
    $key-hangul-wae,
    $key-hangul-wa,
    $key-hangul-u,
    $key-hangul-tieut,
    $key-hangul-sunkyeongeum-pieub,
    $key-hangul-sunkyeongeum-phieuf,
    $key-hangul-sunkyeongeum-mieum,
    $key-hangul-start,
    $key-hangul-ssang-sios,
    $key-hangul-ssang-pieub,
    $key-hangul-ssang-kiyeog,
    $key-hangul-ssang-jieuj,
    $key-hangul-ssang-dikeud,
    $key-hangul-special,
    $key-hangul-sios,
    $key-hangul-single-candidate,
    $key-hangul-romaja,
    $key-hangul-rieul-yeorin-hieuh,
    $key-hangul-rieul-tieut,
    $key-hangul-rieul-sios,
    $key-hangul-rieul-pieub,
    $key-hangul-rieul-phieuf,
    $key-hangul-rieul-mieum,
    $key-hangul-rieul-kiyeog,
    $key-hangul-rieul-hieuh,
    $key-hangul-rieul,
    $key-hangul-previous-candidate,
    $key-hangul-pre-hanja,
    $key-hangul-post-hanja,
    $key-hangul-pieub-sios,
    $key-hangul-pieub,
    $key-hangul-phieuf,
    $key-hangul-pan-sios,
    $key-hangul-oe,
    $key-hangul-o,
    $key-hangul-nieun-jieuj,
    $key-hangul-nieun-hieuh,
    $key-hangul-nieun,
    $key-hangul-multiple-candidate,
    $key-hangul-mieum,
    $key-hangul-kkogji-dalrin-ieung,
    $key-hangul-kiyeog-sios,
    $key-hangul-kiyeog,
    $key-hangul-khieuq,
    $key-hangul-jieuj,
    $key-hangul-jeonja,
    $key-hangul-jamo,
    $key-hangul-j-yeorin-hieuh,
    $key-hangul-j-tieut,
    $key-hangul-j-ssang-sios,
    $key-hangul-j-ssang-kiyeog,
    $key-hangul-j-sios,
    $key-hangul-j-rieul-tieut,
    $key-hangul-j-rieul-sios,
    $key-hangul-j-rieul-pieub,
    $key-hangul-j-rieul-phieuf,
    $key-hangul-j-rieul-mieum,
    $key-hangul-j-rieul-kiyeog,
    $key-hangul-j-rieul-hieuh,
    $key-hangul-j-rieul,
    $key-hangul-j-pieub-sios,
    $key-hangul-j-pieub,
    $key-hangul-j-phieuf,
    $key-hangul-j-pan-sios,
    $key-hangul-j-nieun-jieuj,
    $key-hangul-j-nieun-hieuh,
    $key-hangul-j-nieun,
    $key-hangul-j-mieum,
    $key-hangul-j-kkogji-dalrin-ieung,
    $key-hangul-j-kiyeog-sios,
    $key-hangul-j-kiyeog,
    $key-hangul-j-khieuq,
    $key-hangul-j-jieuj,
    $key-hangul-j-ieung,
    $key-hangul-j-hieuh,
    $key-hangul-j-dikeud,
    $key-hangul-j-cieuc,
    $key-hangul-ieung,
    $key-hangul-i,
    $key-hangul-hieuh,
    $key-hangul-hanja,
    $key-hangul-end,
    $key-hangul-eu,
    $key-hangul-eo,
    $key-hangul-e,
    $key-hangul-dikeud,
    $key-hangul-codeinput,
    $key-hangul-cieuc,
    $key-hangul-banja,
    $key-hangul-arae-ae,
    $key-hangul-arae-a,
    $key-hangul-ae,
    $key-hangul-a,
    $key-hangul,
    $key-h,
    $key-green,
    $key-greek-upsilondieresis,
    $key-greek-upsilonaccentdieresis,
    $key-greek-upsilonaccent,
    $key-greek-switch,
    $key-greek-omicronaccent,
    $key-greek-omegaaccent,
    $key-greek-iotadieresis,
    $key-greek-iotaaccentdieresis,
    $key-greek-iotaaccent,
    $key-greek-horizbar,
    $key-greek-finalsmallsigma,
    $key-greek-etaaccent,
    $key-greek-epsilonaccent,
    $key-greek-alphaaccent,
    $key-greek-accentdieresis,
    $key-greek-zeta,
    $key-greek-xi,
    $key-greek-upsilo-ndieresis,
    $key-greek-upsilo-naccent,
    $key-greek-upsilon,
    $key-greek-theta,
    $key-greek-tau,
    $key-greek-sigma,
    $key-greek-rho,
    $key-greek-psi,
    $key-greek-pi,
    $key-greek-phi,
    $key-greek-omicro-naccent,
    $key-greek-omicron,
    $key-greek-omeg-aaccent,
    $key-greek-omega,
    $key-greek-nu,
    $key-greek-mu,
    $key-greek-lamda,
    $key-greek-lambda,
    $key-greek-kappa,
    $key-greek-iot-adieresis,
    $key-greek-iot-adiaeresis,
    $key-greek-iot-aaccent,
    $key-greek-iota,
    $key-greek-gamma,
    $key-greek-et-aaccent,
    $key-greek-eta,
    $key-greek-epsilo-naccent,
    $key-greek-epsilon,
    $key-greek-delta,
    $key-greek-chi,
    $key-greek-beta,
    $key-greek-alph-aaccent,
    $key-greek-alpha,
    $key-go,
    $key-georgian-zhar,
    $key-georgian-zen,
    $key-georgian-xan,
    $key-georgian-we,
    $key-georgian-vin,
    $key-georgian-un,
    $key-georgian-tar,
    $key-georgian-tan,
    $key-georgian-shin,
    $key-georgian-san,
    $key-georgian-rae,
    $key-georgian-qar,
    $key-georgian-phar,
    $key-georgian-par,
    $key-georgian-on,
    $key-georgian-nar,
    $key-georgian-man,
    $key-georgian-las,
    $key-georgian-khar,
    $key-georgian-kan,
    $key-georgian-jil,
    $key-georgian-jhan,
    $key-georgian-in,
    $key-georgian-hoe,
    $key-georgian-hie,
    $key-georgian-he,
    $key-georgian-har,
    $key-georgian-hae,
    $key-georgian-ghan,
    $key-georgian-gan,
    $key-georgian-fi,
    $key-georgian-en,
    $key-georgian-don,
    $key-georgian-cil,
    $key-georgian-chin,
    $key-georgian-char,
    $key-georgian-can,
    $key-georgian-ban,
    $key-georgian-an,
    $key-gcircumflex,
    $key-gcedilla,
    $key-gcaron,
    $key-gbreve,
    $key-game,
    $key-gabovedot,
    $key-g,
    $key-frame-forward,
    $key-frame-back,
    $key-forward,
    $key-first-virtual-screen,
    $key-find,
    $key-finance,
    $key-favorites,
    $key-farsi-yeh,
    $key-farsi-9,
    $key-farsi-8,
    $key-farsi-7,
    $key-farsi-6,
    $key-farsi-5,
    $key-farsi-4,
    $key-farsi-3,
    $key-farsi-2,
    $key-farsi-1,
    $key-farsi-0,
    $key-fabovedot,
    $key-f-franc-sign,
    $key-f9,
    $key-f8,
    $key-f7,
    $key-f6,
    $key-f5,
    $key-f4,
    $key-f35,
    $key-f34,
    $key-f33,
    $key-f32,
    $key-f31,
    $key-f30,
    $key-f3,
    $key-f29,
    $key-f28,
    $key-f27,
    $key-f26,
    $key-f25,
    $key-f24,
    $key-f23,
    $key-f22,
    $key-f21,
    $key-f20,
    $key-f2,
    $key-f19,
    $key-f18,
    $key-f17,
    $key-f16,
    $key-f15,
    $key-f14,
    $key-f13,
    $key-f12,
    $key-f11,
    $key-f10,
    $key-f1,
    $key-f,
    $key-explorer,
    $key-execute,
    $key-excel,
    $key-euro-sign,
    $key-etilde,
    $key-escape,
    $key-eogonek,
    $key-end,
    $key-emacron,
    $key-eject,
    $key-eisu-toggle,
    $key-eisu-shift,
    $key-ehook,
    $key-egrave,
    $key-ediaeresis,
    $key-ecu-sign,
    $key-ecircumflextilde,
    $key-ecircumflexhook,
    $key-ecircumflexgrave,
    $key-ecircumflexbelowdot,
    $key-ecircumflexacute,
    $key-ecircumflex,
    $key-ecaron,
    $key-ebelowdot,
    $key-eacute,
    $key-eabovedot,
    $key-ezh,
    $key-eth,
    $key-eng,
    $key-e,
    $key-dstroke,
    $key-down,
    $key-dong-sign,
    $key-documents,
    $key-display,
    $key-delete,
    $key-dcaron,
    $key-dabovedot,
    $key-dos,
    $key-d,
    $key-cyrillic-zhe-descender,
    $key-cyrillic-zhe,
    $key-cyrillic-ze,
    $key-cyrillic-yu,
    $key-cyrillic-yeru,
    $key-cyrillic-ya,
    $key-cyrillic-ve,
    $key-cyrillic-u-straight-bar,
    $key-cyrillic-u-straight,
    $key-cyrillic-u-macron,
    $key-cyrillic-u,
    $key-cyrillic-tse,
    $key-cyrillic-te,
    $key-cyrillic-softsign,
    $key-cyrillic-shorti,
    $key-cyrillic-shha,
    $key-cyrillic-shcha,
    $key-cyrillic-sha,
    $key-cyrillic-schwa,
    $key-cyrillic-pe,
    $key-cyrillic-o-bar,
    $key-cyrillic-o,
    $key-cyrillic-nje,
    $key-cyrillic-lje,
    $key-cyrillic-ka-vertstroke,
    $key-cyrillic-ka-descender,
    $key-cyrillic-ka,
    $key-cyrillic-je,
    $key-cyrillic-i-macron,
    $key-cyrillic-io,
    $key-cyrillic-ie,
    $key-cyrillic-i,
    $key-cyrillic-ha-descender,
    $key-cyrillic-hardsign,
    $key-cyrillic-ha,
    $key-cyrillic-ghe-bar,
    $key-cyrillic-ghe,
    $key-cyrillic-es,
    $key-cyrillic-er,
    $key-cyrillic-en-descender,
    $key-cyrillic-en,
    $key-cyrillic-em,
    $key-cyrillic-el,
    $key-cyrillic-ef,
    $key-cyrillic-e,
    $key-cyrillic-dzhe,
    $key-cyrillic-de,
    $key-cyrillic-che-vertstroke,
    $key-cyrillic-che-descender,
    $key-cyrillic-che,
    $key-cyrillic-be,
    $key-cyrillic-a,
    $key-cycle-angle,
    $key-cut,
    $key-cruzeiro-sign,
    $key-copy,
    $key-control-r,
    $key-control-l,
    $key-contrast-adjust,
    $key-community,
    $key-colon-sign,
    $key-codeinput,
    $key-close,
    $key-clear-grab,
    $key-clear,
    $key-ccircumflex,
    $key-ccedilla,
    $key-ccaron,
    $key-caps-lock,
    $key-cancel,
    $key-calendar,
    $key-calculator,
    $key-cacute,
    $key-cabovedot,
    $key-c-h,
    $key-ch,
    $key-cd,
    $key-c,
    $key-byelorussian-shortu,
    $key-brightness-adjust,
    $key-break,
    $key-bounce-keys-enable,
    $key-book,
    $key-bluetooth,
    $key-blue,
    $key-begin,
    $key-battery,
    $key-back-space,
    $key-back-forward,
    $key-back,
    $key-babovedot,
    $key-b,
    $key-away,
    $key-audio-stop,
    $key-audio-rewind,
    $key-audio-repeat,
    $key-audio-record,
    $key-audio-random-play,
    $key-audio-raise-volume,
    $key-audio-prev,
    $key-audio-play,
    $key-audio-pause,
    $key-audio-next,
    $key-audio-mute,
    $key-audio-media,
    $key-audio-lower-volume,
    $key-audio-forward,
    $key-audio-cycle-track,
    $key-audible-bell-enable,
    $key-atilde,
    $key-armenian-yentamna,
    $key-armenian-verjaket,
    $key-armenian-shesht,
    $key-armenian-separation-mark,
    $key-armenian-question,
    $key-armenian-paruyk,
    $key-armenian-ligature-ew,
    $key-armenian-hyphen,
    $key-armenian-full-stop,
    $key-armenian-exclam,
    $key-armenian-but,
    $key-armenian-apostrophe,
    $key-armenian-amanak,
    $key-armenian-accent,
    $key-armenian-zhe,
    $key-armenian-za,
    $key-armenian-yech,
    $key-armenian-vyun,
    $key-armenian-vo,
    $key-armenian-vev,
    $key-armenian-tyun,
    $key-armenian-tso,
    $key-armenian-tsa,
    $key-armenian-to,
    $key-armenian-tche,
    $key-armenian-sha,
    $key-armenian-se,
    $key-armenian-re,
    $key-armenian-ra,
    $key-armenian-pyur,
    $key-armenian-pe,
    $key-armenian-o,
    $key-armenian-nu,
    $key-armenian-men,
    $key-armenian-lyun,
    $key-armenian-khe,
    $key-armenian-ken,
    $key-armenian-ke,
    $key-armenian-je,
    $key-armenian-ini,
    $key-armenian-ho,
    $key-armenian-hi,
    $key-armenian-gim,
    $key-armenian-ghat,
    $key-armenian-fe,
    $key-armenian-e,
    $key-armenian-dza,
    $key-armenian-da,
    $key-armenian-cha,
    $key-armenian-ben,
    $key-armenian-ayb,
    $key-armenian-at,
    $key-aring,
    $key-arabic-zain,
    $key-arabic-zah,
    $key-arabic-yeh-baree,
    $key-arabic-yeh,
    $key-arabic-waw,
    $key-arabic-veh,
    $key-arabic-tteh,
    $key-arabic-theh,
    $key-arabic-thal,
    $key-arabic-tehmarbuta,
    $key-arabic-teh,
    $key-arabic-tcheh,
    $key-arabic-tatweel,
    $key-arabic-tah,
    $key-arabic-switch,
    $key-arabic-superscript-alef,
    $key-arabic-sukun,
    $key-arabic-sheen,
    $key-arabic-shadda,
    $key-arabic-semicolon,
    $key-arabic-seen,
    $key-arabic-sad,
    $key-arabic-rreh,
    $key-arabic-ra,
    $key-arabic-question-mark,
    $key-arabic-qaf,
    $key-arabic-percent,
    $key-arabic-peh,
    $key-arabic-noon-ghunna,
    $key-arabic-noon,
    $key-arabic-meem,
    $key-arabic-maddaonalef,
    $key-arabic-madda-above,
    $key-arabic-lam,
    $key-arabic-khah,
    $key-arabic-keheh,
    $key-arabic-kasratan,
    $key-arabic-kasra,
    $key-arabic-kaf,
    $key-arabic-jeh,
    $key-arabic-jeem,
    $key-arabic-heh-goal,
    $key-arabic-heh-doachashmee,
    $key-arabic-heh,
    $key-arabic-hamzaunderalef,
    $key-arabic-hamzaonyeh,
    $key-arabic-hamzaonwaw,
    $key-arabic-hamzaonalef,
    $key-arabic-hamza-below,
    $key-arabic-hamza-above,
    $key-arabic-hamza,
    $key-arabic-hah,
    $key-arabic-ha,
    $key-arabic-ghain,
    $key-arabic-gaf,
    $key-arabic-fullstop,
    $key-arabic-feh,
    $key-arabic-fathatan,
    $key-arabic-fatha,
    $key-arabic-farsi-yeh,
    $key-arabic-ddal,
    $key-arabic-dammatan,
    $key-arabic-damma,
    $key-arabic-dal,
    $key-arabic-dad,
    $key-arabic-comma,
    $key-arabic-beh,
    $key-arabic-alefmaksura,
    $key-arabic-alef,
    $key-arabic-ain,
    $key-arabic-9,
    $key-arabic-8,
    $key-arabic-7,
    $key-arabic-6,
    $key-arabic-5,
    $key-arabic-4,
    $key-arabic-3,
    $key-arabic-2,
    $key-arabic-1,
    $key-arabic-0,
    $key-application-right,
    $key-application-left,
    $key-aogonek,
    $key-amacron,
    $key-alt-r,
    $key-alt-l,
    $key-ahook,
    $key-agrave,
    $key-adiaeresis,
    $key-add-favorite,
    $key-acircumflextilde,
    $key-acircumflexhook,
    $key-acircumflexgrave,
    $key-acircumflexbelowdot,
    $key-acircumflexacute,
    $key-acircumflex,
    $key-access-x-feedback-enable,
    $key-access-x-enable,
    $key-abrevetilde,
    $key-abrevehook,
    $key-abrevegrave,
    $key-abrevebelowdot,
    $key-abreveacute,
    $key-abreve,
    $key-abelowdot,
    $key-aacute,
    $key-ae,
    $key-a,
    $key-9,
    $key-8,
    $key-7,
    $key-6,
    $key-5,
    $key-4,
    $key-3270-test,
    $key-3270-setup,
    $key-3270-rule,
    $key-3270-right2,
    $key-3270-reset,
    $key-3270-record,
    $key-3270-quit,
    $key-3270-print-screen,
    $key-3270-play,
    $key-3270-pa3,
    $key-3270-pa2,
    $key-3270-pa1,
    $key-3270-left2,
    $key-3270-key-click,
    $key-3270-jump,
    $key-3270-ident,
    $key-3270-field-mark,
    $key-3270-ex-select,
    $key-3270-erase-input,
    $key-3270-erase-eof,
    $key-3270-enter,
    $key-3270-duplicate,
    $key-3270-delete-word,
    $key-3270-cursor-select,
    $key-3270-cursor-blink,
    $key-3270-copy,
    $key-3270-change-screen,
    $key-3270-back-tab,
    $key-3270-attn,
    $key-3270-alt-cursor,
    $key-3,
    $key-2,
    $key-1,
    $key-0,
    <GdkInputSource*>,
    <GdkInputSource>,
    $gdk-source-touchpad,
    $gdk-source-touchscreen,
    $gdk-source-keyboard,
    $gdk-source-cursor,
    $gdk-source-eraser,
    $gdk-source-pen,
    $gdk-source-mouse,
    <GdkInputMode*>,
    <GdkInputMode>,
    $gdk-mode-window,
    $gdk-mode-screen,
    $gdk-mode-disabled,
    <GdkGravity*>,
    <GdkGravity>,
    $gdk-gravity-static,
    $gdk-gravity-south-east,
    $gdk-gravity-south,
    $gdk-gravity-south-west,
    $gdk-gravity-east,
    $gdk-gravity-center,
    $gdk-gravity-west,
    $gdk-gravity-north-east,
    $gdk-gravity-north,
    $gdk-gravity-north-west,
    <GdkGrabStatus*>,
    <GdkGrabStatus>,
    $gdk-grab-frozen,
    $gdk-grab-not-viewable,
    $gdk-grab-invalid-time,
    $gdk-grab-already-grabbed,
    $gdk-grab-success,
    <GdkGrabOwnership*>,
    <GdkGrabOwnership>,
    $gdk-ownership-application,
    $gdk-ownership-window,
    $gdk-ownership-none,
    gdk-geometry-win-gravity-setter,
    gdk-geometry-win-gravity,
    gdk-geometry-max-aspect-setter,
    gdk-geometry-max-aspect,
    gdk-geometry-min-aspect-setter,
    gdk-geometry-min-aspect,
    gdk-geometry-height-inc-setter,
    gdk-geometry-height-inc,
    gdk-geometry-width-inc-setter,
    gdk-geometry-width-inc,
    gdk-geometry-base-height-setter,
    gdk-geometry-base-height,
    gdk-geometry-base-width-setter,
    gdk-geometry-base-width,
    gdk-geometry-max-height-setter,
    gdk-geometry-max-height,
    gdk-geometry-max-width-setter,
    gdk-geometry-max-width,
    gdk-geometry-min-height-setter,
    gdk-geometry-min-height,
    gdk-geometry-min-width-setter,
    gdk-geometry-min-width,
    <GdkGeometry>,
    <GdkFilterReturn*>,
    <GdkFilterReturn>,
    $gdk-filter-remove,
    $gdk-filter-translate,
    $gdk-filter-continue,
    gdk-event-window-state-new-window-state-setter,
    gdk-event-window-state-new-window-state,
    gdk-event-window-state-changed-mask-setter,
    gdk-event-window-state-changed-mask,
    gdk-event-window-state-send-event-setter,
    gdk-event-window-state-send-event,
    gdk-event-window-state-window-setter,
    gdk-event-window-state-window,
    gdk-event-window-state-type-setter,
    gdk-event-window-state-type,
    <GdkEventWindowState>,
    gdk-event-visibility-state-setter,
    gdk-event-visibility-state,
    gdk-event-visibility-send-event-setter,
    gdk-event-visibility-send-event,
    gdk-event-visibility-window-setter,
    gdk-event-visibility-window,
    gdk-event-visibility-type-setter,
    gdk-event-visibility-type,
    <GdkEventVisibility>,
    <GdkEventType*>,
    <GdkEventType>,
    $gdk-event-last,
    $gdk-touch-cancel,
    $gdk-touch-end,
    $gdk-touch-update,
    $gdk-touch-begin,
    $gdk-damage,
    $gdk-grab-broken,
    $gdk-owner-change,
    $gdk-setting,
    $gdk-window-state,
    $gdk-scroll,
    $gdk-visibility-notify,
    $gdk-client-event,
    $gdk-drop-finished,
    $gdk-drop-start,
    $gdk-drag-status,
    $gdk-drag-motion,
    $gdk-drag-leave,
    $gdk-drag-enter,
    $gdk-proximity-out,
    $gdk-proximity-in,
    $gdk-selection-notify,
    $gdk-selection-request,
    $gdk-selection-clear,
    $gdk-property-notify,
    $gdk-unmap,
    $gdk-map,
    $gdk-configure,
    $gdk-focus-change,
    $gdk-leave-notify,
    $gdk-enter-notify,
    $gdk-key-release,
    $gdk-key-press,
    $gdk-button-release,
    $gdk-3button-press,
    $gdk-2button-press,
    $gdk-button-press,
    $gdk-motion-notify,
    $gdk-expose,
    $gdk-destroy,
    $gdk-delete,
    $gdk-nothing,
    gdk-event-touch-y-root-setter,
    gdk-event-touch-y-root,
    gdk-event-touch-x-root-setter,
    gdk-event-touch-x-root,
    gdk-event-touch-device-setter,
    gdk-event-touch-device,
    gdk-event-touch-emulating-pointer-setter,
    gdk-event-touch-emulating-pointer,
    gdk-event-touch-sequence-setter,
    gdk-event-touch-sequence,
    gdk-event-touch-state-setter,
    gdk-event-touch-state,
    gdk-event-touch-axes-setter,
    gdk-event-touch-axes,
    gdk-event-touch-y-setter,
    gdk-event-touch-y,
    gdk-event-touch-x-setter,
    gdk-event-touch-x,
    gdk-event-touch-time-setter,
    gdk-event-touch-time,
    gdk-event-touch-send-event-setter,
    gdk-event-touch-send-event,
    gdk-event-touch-window-setter,
    gdk-event-touch-window,
    gdk-event-touch-type-setter,
    gdk-event-touch-type,
    <GdkEventTouch>,
    gdk-event-setting-name-setter,
    gdk-event-setting-name,
    gdk-event-setting-action-setter,
    gdk-event-setting-action,
    gdk-event-setting-send-event-setter,
    gdk-event-setting-send-event,
    gdk-event-setting-window-setter,
    gdk-event-setting-window,
    gdk-event-setting-type-setter,
    gdk-event-setting-type,
    <GdkEventSetting>,
    <GdkEventSequence>,
    gdk-event-selection-requestor-setter,
    gdk-event-selection-requestor,
    gdk-event-selection-time-setter,
    gdk-event-selection-time,
    gdk-event-selection-property-setter,
    gdk-event-selection-property,
    gdk-event-selection-target-setter,
    gdk-event-selection-target,
    gdk-event-selection-selection-setter,
    gdk-event-selection-selection,
    gdk-event-selection-send-event-setter,
    gdk-event-selection-send-event,
    gdk-event-selection-window-setter,
    gdk-event-selection-window,
    gdk-event-selection-type-setter,
    gdk-event-selection-type,
    <GdkEventSelection>,
    gdk-event-scroll-delta-y-setter,
    gdk-event-scroll-delta-y,
    gdk-event-scroll-delta-x-setter,
    gdk-event-scroll-delta-x,
    gdk-event-scroll-y-root-setter,
    gdk-event-scroll-y-root,
    gdk-event-scroll-x-root-setter,
    gdk-event-scroll-x-root,
    gdk-event-scroll-device-setter,
    gdk-event-scroll-device,
    gdk-event-scroll-direction-setter,
    gdk-event-scroll-direction,
    gdk-event-scroll-state-setter,
    gdk-event-scroll-state,
    gdk-event-scroll-y-setter,
    gdk-event-scroll-y,
    gdk-event-scroll-x-setter,
    gdk-event-scroll-x,
    gdk-event-scroll-time-setter,
    gdk-event-scroll-time,
    gdk-event-scroll-send-event-setter,
    gdk-event-scroll-send-event,
    gdk-event-scroll-window-setter,
    gdk-event-scroll-window,
    gdk-event-scroll-type-setter,
    gdk-event-scroll-type,
    <GdkEventScroll>,
    gdk-event-proximity-device-setter,
    gdk-event-proximity-device,
    gdk-event-proximity-time-setter,
    gdk-event-proximity-time,
    gdk-event-proximity-send-event-setter,
    gdk-event-proximity-send-event,
    gdk-event-proximity-window-setter,
    gdk-event-proximity-window,
    gdk-event-proximity-type-setter,
    gdk-event-proximity-type,
    <GdkEventProximity>,
    gdk-event-property-state-setter,
    gdk-event-property-state,
    gdk-event-property-time-setter,
    gdk-event-property-time,
    gdk-event-property-atom-setter,
    gdk-event-property-atom,
    gdk-event-property-send-event-setter,
    gdk-event-property-send-event,
    gdk-event-property-window-setter,
    gdk-event-property-window,
    gdk-event-property-type-setter,
    gdk-event-property-type,
    <GdkEventProperty>,
    gdk-event-owner-change-selection-time-setter,
    gdk-event-owner-change-selection-time,
    gdk-event-owner-change-time-setter,
    gdk-event-owner-change-time,
    gdk-event-owner-change-selection-setter,
    gdk-event-owner-change-selection,
    gdk-event-owner-change-reason-setter,
    gdk-event-owner-change-reason,
    gdk-event-owner-change-owner-setter,
    gdk-event-owner-change-owner,
    gdk-event-owner-change-send-event-setter,
    gdk-event-owner-change-send-event,
    gdk-event-owner-change-window-setter,
    gdk-event-owner-change-window,
    gdk-event-owner-change-type-setter,
    gdk-event-owner-change-type,
    <GdkEventOwnerChange>,
    gdk-event-motion-y-root-setter,
    gdk-event-motion-y-root,
    gdk-event-motion-x-root-setter,
    gdk-event-motion-x-root,
    gdk-event-motion-device-setter,
    gdk-event-motion-device,
    gdk-event-motion-is-hint-setter,
    gdk-event-motion-is-hint,
    gdk-event-motion-state-setter,
    gdk-event-motion-state,
    gdk-event-motion-axes-setter,
    gdk-event-motion-axes,
    gdk-event-motion-y-setter,
    gdk-event-motion-y,
    gdk-event-motion-x-setter,
    gdk-event-motion-x,
    gdk-event-motion-time-setter,
    gdk-event-motion-time,
    gdk-event-motion-send-event-setter,
    gdk-event-motion-send-event,
    gdk-event-motion-window-setter,
    gdk-event-motion-window,
    gdk-event-motion-type-setter,
    gdk-event-motion-type,
    <GdkEventMotion>,
    <GdkEventMask*>,
    <GdkEventMask>,
    $gdk-all-events-mask,
    $gdk-smooth-scroll-mask,
    $gdk-touch-mask,
    $gdk-scroll-mask,
    $gdk-substructure-mask,
    $gdk-proximity-out-mask,
    $gdk-proximity-in-mask,
    $gdk-visibility-notify-mask,
    $gdk-property-change-mask,
    $gdk-structure-mask,
    $gdk-focus-change-mask,
    $gdk-leave-notify-mask,
    $gdk-enter-notify-mask,
    $gdk-key-release-mask,
    $gdk-key-press-mask,
    $gdk-button-release-mask,
    $gdk-button-press-mask,
    $gdk-button3-motion-mask,
    $gdk-button2-motion-mask,
    $gdk-button1-motion-mask,
    $gdk-button-motion-mask,
    $gdk-pointer-motion-hint-mask,
    $gdk-pointer-motion-mask,
    $gdk-exposure-mask,
    gdk-event-key-is-modifier-setter,
    gdk-event-key-is-modifier,
    gdk-event-key-group-setter,
    gdk-event-key-group,
    gdk-event-key-hardware-keycode-setter,
    gdk-event-key-hardware-keycode,
    gdk-event-key-string-setter,
    gdk-event-key-string,
    gdk-event-key-length-setter,
    gdk-event-key-length,
    gdk-event-key-keyval-setter,
    gdk-event-key-keyval,
    gdk-event-key-state-setter,
    gdk-event-key-state,
    gdk-event-key-time-setter,
    gdk-event-key-time,
    gdk-event-key-send-event-setter,
    gdk-event-key-send-event,
    gdk-event-key-window-setter,
    gdk-event-key-window,
    gdk-event-key-type-setter,
    gdk-event-key-type,
    <GdkEventKey>,
    gdk-event-grab-broken-grab-window-setter,
    gdk-event-grab-broken-grab-window,
    gdk-event-grab-broken-implicit-setter,
    gdk-event-grab-broken-implicit,
    gdk-event-grab-broken-keyboard-setter,
    gdk-event-grab-broken-keyboard,
    gdk-event-grab-broken-send-event-setter,
    gdk-event-grab-broken-send-event,
    gdk-event-grab-broken-window-setter,
    gdk-event-grab-broken-window,
    gdk-event-grab-broken-type-setter,
    gdk-event-grab-broken-type,
    <GdkEventGrabBroken>,
    gdk-event-focus-in-setter,
    gdk-event-focus-in,
    gdk-event-focus-send-event-setter,
    gdk-event-focus-send-event,
    gdk-event-focus-window-setter,
    gdk-event-focus-window,
    gdk-event-focus-type-setter,
    gdk-event-focus-type,
    <GdkEventFocus>,
    gdk-event-expose-count-setter,
    gdk-event-expose-count,
    gdk-event-expose-region-setter,
    gdk-event-expose-region,
    gdk-event-expose-area-setter,
    gdk-event-expose-area,
    gdk-event-expose-send-event-setter,
    gdk-event-expose-send-event,
    gdk-event-expose-window-setter,
    gdk-event-expose-window,
    gdk-event-expose-type-setter,
    gdk-event-expose-type,
    <GdkEventExpose>,
    gdk-event-dnd-y-root-setter,
    gdk-event-dnd-y-root,
    gdk-event-dnd-x-root-setter,
    gdk-event-dnd-x-root,
    gdk-event-dnd-time-setter,
    gdk-event-dnd-time,
    gdk-event-dnd-context-setter,
    gdk-event-dnd-context,
    gdk-event-dnd-send-event-setter,
    gdk-event-dnd-send-event,
    gdk-event-dnd-window-setter,
    gdk-event-dnd-window,
    gdk-event-dnd-type-setter,
    gdk-event-dnd-type,
    <GdkEventDND>,
    gdk-event-crossing-state-setter,
    gdk-event-crossing-state,
    gdk-event-crossing-focus-setter,
    gdk-event-crossing-focus,
    gdk-event-crossing-detail-setter,
    gdk-event-crossing-detail,
    gdk-event-crossing-mode-setter,
    gdk-event-crossing-mode,
    gdk-event-crossing-y-root-setter,
    gdk-event-crossing-y-root,
    gdk-event-crossing-x-root-setter,
    gdk-event-crossing-x-root,
    gdk-event-crossing-y-setter,
    gdk-event-crossing-y,
    gdk-event-crossing-x-setter,
    gdk-event-crossing-x,
    gdk-event-crossing-time-setter,
    gdk-event-crossing-time,
    gdk-event-crossing-subwindow-setter,
    gdk-event-crossing-subwindow,
    gdk-event-crossing-send-event-setter,
    gdk-event-crossing-send-event,
    gdk-event-crossing-window-setter,
    gdk-event-crossing-window,
    gdk-event-crossing-type-setter,
    gdk-event-crossing-type,
    <GdkEventCrossing>,
    gdk-event-configure-height-setter,
    gdk-event-configure-height,
    gdk-event-configure-width-setter,
    gdk-event-configure-width,
    gdk-event-configure-y-setter,
    gdk-event-configure-y,
    gdk-event-configure-x-setter,
    gdk-event-configure-x,
    gdk-event-configure-send-event-setter,
    gdk-event-configure-send-event,
    gdk-event-configure-window-setter,
    gdk-event-configure-window,
    gdk-event-configure-type-setter,
    gdk-event-configure-type,
    <GdkEventConfigure>,
    gdk-event-button-y-root-setter,
    gdk-event-button-y-root,
    gdk-event-button-x-root-setter,
    gdk-event-button-x-root,
    gdk-event-button-device-setter,
    gdk-event-button-device,
    gdk-event-button-button-setter,
    gdk-event-button-button,
    gdk-event-button-state-setter,
    gdk-event-button-state,
    gdk-event-button-axes-setter,
    gdk-event-button-axes,
    gdk-event-button-y-setter,
    gdk-event-button-y,
    gdk-event-button-x-setter,
    gdk-event-button-x,
    gdk-event-button-time-setter,
    gdk-event-button-time,
    gdk-event-button-send-event-setter,
    gdk-event-button-send-event,
    gdk-event-button-window-setter,
    gdk-event-button-window,
    gdk-event-button-type-setter,
    gdk-event-button-type,
    <GdkEventButton>,
    gdk-event-any-send-event-setter,
    gdk-event-any-send-event,
    gdk-event-any-window-setter,
    gdk-event-any-window,
    gdk-event-any-type-setter,
    gdk-event-any-type,
    <GdkEventAny>,
    gdk-event-request-motions,
    gdk-event-peek,
    gdk-event-handler-set,
    gdk-event-get,
    gdk-event-triggers-context-menu,
    gdk-event-set-source-device,
    gdk-event-set-screen,
    gdk-event-set-device,
    gdk-event-put,
    gdk-event-get-time,
    gdk-event-get-state,
    gdk-event-get-source-device,
    gdk-event-get-scroll-direction,
    gdk-event-get-scroll-deltas,
    gdk-event-get-screen,
    gdk-event-get-root-coords,
    gdk-event-get-keyval,
    gdk-event-get-keycode,
    gdk-event-get-device,
    gdk-event-get-coords,
    gdk-event-get-click-count,
    gdk-event-get-button,
    gdk-event-get-axis,
    gdk-event-free,
    gdk-event-copy,
    gdk-events-get-distance,
    gdk-events-get-center,
    gdk-events-get-angle,
    gdk-event-new,
    gdk-event-grab-broken-setter,
    gdk-event-grab-broken,
    gdk-event-setting-setter,
    gdk-event-setting,
    gdk-event-window-state-setter,
    gdk-event-window-state,
    gdk-event-dnd-setter,
    gdk-event-dnd,
    gdk-event-proximity-setter,
    gdk-event-proximity,
    gdk-event-owner-change-setter,
    gdk-event-owner-change,
    gdk-event-selection-setter,
    gdk-event-selection,
    gdk-event-property-setter,
    gdk-event-property,
    gdk-event-configure-setter,
    gdk-event-configure,
    gdk-event-focus-change-setter,
    gdk-event-focus-change,
    gdk-event-crossing-setter,
    gdk-event-crossing,
    gdk-event-key-setter,
    gdk-event-key,
    gdk-event-scroll-setter,
    gdk-event-scroll,
    gdk-event-touch-setter,
    gdk-event-touch,
    gdk-event-button-setter,
    gdk-event-button,
    gdk-event-motion-setter,
    gdk-event-motion,
    gdk-event-visibility-setter,
    gdk-event-visibility,
    gdk-event-expose-setter,
    gdk-event-expose,
    gdk-event-any-setter,
    gdk-event-any,
    gdk-event-type-setter,
    gdk-event-type,
    <GdkEvent>,
    <_GdkEvent>,
    <GdkDragProtocol*>,
    <GdkDragProtocol>,
    $gdk-drag-proto-local,
    $gdk-drag-proto-ole2,
    $gdk-drag-proto-win32-dropfiles,
    $gdk-drag-proto-rootwin,
    $gdk-drag-proto-xdnd,
    $gdk-drag-proto-motif,
    $gdk-drag-proto-none,
    gdk-drag-context-set-device,
    gdk-drag-context-list-targets,
    gdk-drag-context-get-suggested-action,
    gdk-drag-context-get-source-window,
    gdk-drag-context-get-selected-action,
    gdk-drag-context-get-protocol,
    gdk-drag-context-get-device,
    gdk-drag-context-get-dest-window,
    gdk-drag-context-get-actions,
    <GdkDragContext*>,
    <GdkDragContext>,
    <GdkDragAction*>,
    <GdkDragAction>,
    $gdk-action-ask,
    $gdk-action-private,
    $gdk-action-link,
    $gdk-action-move,
    $gdk-action-copy,
    $gdk-action-default,
    gdk-display-manager-set-default-display,
    gdk-display-manager-open-display,
    gdk-display-manager-list-displays,
    gdk-display-manager-get-default-display,
    gdk-display-manager-get,
    <GdkDisplayManager*>,
    <GdkDisplayManager>,
    gdk-display-warp-pointer,
    gdk-display-sync,
    gdk-display-supports-shapes,
    gdk-display-supports-selection-notification,
    gdk-display-supports-input-shapes,
    gdk-display-supports-cursor-color,
    gdk-display-supports-cursor-alpha,
    gdk-display-supports-composite,
    gdk-display-supports-clipboard-persistence,
    gdk-display-store-clipboard,
    gdk-display-set-double-click-time,
    gdk-display-set-double-click-distance,
    gdk-display-request-selection-notification,
    gdk-display-put-event,
    gdk-display-pointer-ungrab,
    gdk-display-pointer-is-grabbed,
    gdk-display-peek-event,
    gdk-display-notify-startup-complete,
    gdk-display-list-devices,
    gdk-display-keyboard-ungrab,
    gdk-display-is-closed,
    gdk-display-has-pending,
    gdk-display-get-window-at-pointer,
    gdk-display-get-screen,
    gdk-display-get-pointer,
    gdk-display-get-name,
    gdk-display-get-n-screens,
    gdk-display-get-maximal-cursor-size,
    gdk-display-get-event,
    gdk-display-get-device-manager,
    gdk-display-get-default-screen,
    gdk-display-get-default-group,
    gdk-display-get-default-cursor-size,
    gdk-display-get-app-launch-context,
    gdk-display-flush,
    gdk-display-device-is-grabbed,
    gdk-display-close,
    gdk-display-beep,
    gdk-display-open-default-libgtk-only,
    gdk-display-open,
    gdk-display-get-default,
    <GdkDisplay*>,
    <GdkDisplay>,
    <GdkDeviceType*>,
    <GdkDeviceType>,
    $gdk-device-type-floating,
    $gdk-device-type-slave,
    $gdk-device-type-master,
    gdk-device-manager-list-devices,
    gdk-device-manager-get-display,
    gdk-device-manager-get-client-pointer,
    <GdkDeviceManager*>,
    <GdkDeviceManager>,
    gdk-device-warp,
    gdk-device-ungrab,
    gdk-device-set-mode,
    gdk-device-set-key,
    gdk-device-set-axis-use,
    gdk-device-list-slave-devices,
    gdk-device-list-axes,
    gdk-device-grab,
    gdk-device-get-window-at-position,
    gdk-device-get-source,
    gdk-device-get-position,
    gdk-device-get-name,
    gdk-device-get-n-keys,
    gdk-device-get-n-axes,
    gdk-device-get-mode,
    gdk-device-get-key,
    gdk-device-get-has-cursor,
    gdk-device-get-display,
    gdk-device-get-device-type,
    gdk-device-get-axis-use,
    gdk-device-get-associated-device,
    gdk-device-grab-info-libgtk-only,
    <GdkDevice*>,
    <GdkDevice>,
    <GdkCursorType*>,
    <GdkCursorType>,
    $gdk-cursor-is-pixmap,
    $gdk-blank-cursor,
    $gdk-last-cursor,
    $gdk-xterm,
    $gdk-watch,
    $gdk-ur-angle,
    $gdk-umbrella,
    $gdk-ul-angle,
    $gdk-trek,
    $gdk-top-tee,
    $gdk-top-side,
    $gdk-top-right-corner,
    $gdk-top-left-corner,
    $gdk-top-left-arrow,
    $gdk-tcross,
    $gdk-target,
    $gdk-star,
    $gdk-spraycan,
    $gdk-spider,
    $gdk-sizing,
    $gdk-shuttle,
    $gdk-sb-v-double-arrow,
    $gdk-sb-up-arrow,
    $gdk-sb-right-arrow,
    $gdk-sb-left-arrow,
    $gdk-sb-h-double-arrow,
    $gdk-sb-down-arrow,
    $gdk-sailboat,
    $gdk-rtl-logo,
    $gdk-rightbutton,
    $gdk-right-tee,
    $gdk-right-side,
    $gdk-right-ptr,
    $gdk-question-arrow,
    $gdk-plus,
    $gdk-pirate,
    $gdk-pencil,
    $gdk-mouse,
    $gdk-middlebutton,
    $gdk-man,
    $gdk-lr-angle,
    $gdk-ll-angle,
    $gdk-leftbutton,
    $gdk-left-tee,
    $gdk-left-side,
    $gdk-left-ptr,
    $gdk-iron-cross,
    $gdk-icon,
    $gdk-heart,
    $gdk-hand2,
    $gdk-hand1,
    $gdk-gumby,
    $gdk-gobbler,
    $gdk-fleur,
    $gdk-exchange,
    $gdk-draped-box,
    $gdk-draft-small,
    $gdk-draft-large,
    $gdk-double-arrow,
    $gdk-dotbox,
    $gdk-dot,
    $gdk-diamond-cross,
    $gdk-crosshair,
    $gdk-cross-reverse,
    $gdk-cross,
    $gdk-coffee-mug,
    $gdk-clock,
    $gdk-circle,
    $gdk-center-ptr,
    $gdk-box-spiral,
    $gdk-bottom-tee,
    $gdk-bottom-side,
    $gdk-bottom-right-corner,
    $gdk-bottom-left-corner,
    $gdk-bogosity,
    $gdk-boat,
    $gdk-based-arrow-up,
    $gdk-based-arrow-down,
    $gdk-arrow,
    $gdk-x-cursor,
    gdk-cursor-unref,
    gdk-cursor-ref,
    gdk-cursor-get-image,
    gdk-cursor-get-display,
    gdk-cursor-get-cursor-type,
    gdk-cursor-new-from-pixbuf,
    gdk-cursor-new-from-name,
    gdk-cursor-new-for-display,
    gdk-cursor-new,
    <GdkCursor*>,
    <GdkCursor>,
    <GdkCrossingMode*>,
    <GdkCrossingMode>,
    $gdk-crossing-device-switch,
    $gdk-crossing-touch-end,
    $gdk-crossing-touch-begin,
    $gdk-crossing-state-changed,
    $gdk-crossing-gtk-ungrab,
    $gdk-crossing-gtk-grab,
    $gdk-crossing-ungrab,
    $gdk-crossing-grab,
    $gdk-crossing-normal,
    gdk-color-parse,
    gdk-color-to-string,
    gdk-color-hash,
    gdk-color-free,
    gdk-color-equal,
    gdk-color-copy,
    gdk-color-blue-setter,
    gdk-color-blue,
    gdk-color-green-setter,
    gdk-color-green,
    gdk-color-red-setter,
    gdk-color-red,
    gdk-color-pixel-setter,
    gdk-color-pixel,
    <GdkColor>,
    $current-time,
    <GdkByteOrder*>,
    <GdkByteOrder>,
    $gdk-msb-first,
    $gdk-lsb-first,
    $button-secondary,
    $button-primary,
    $button-middle,
    <GdkAxisUse*>,
    <GdkAxisUse>,
    $gdk-axis-last,
    $gdk-axis-wheel,
    $gdk-axis-ytilt,
    $gdk-axis-xtilt,
    $gdk-axis-pressure,
    $gdk-axis-y,
    $gdk-axis-x,
    $gdk-axis-ignore,
    gdk-atom-intern-static-string,
    gdk-atom-intern,
    gdk-atom-name,
    <GdkAtom>,
    gdk-app-launch-context-set-timestamp,
    gdk-app-launch-context-set-screen,
    gdk-app-launch-context-set-icon-name,
    gdk-app-launch-context-set-icon,
    gdk-app-launch-context-set-display,
    gdk-app-launch-context-set-desktop,
    gdk-app-launch-context-new,
    <GdkAppLaunchContext*>,
    <GdkAppLaunchContext>;
end module;

define module gdk-properties
  use gdk;
  use gobject-glue;

  export
    @cursor-setter,
    @cursor,
    @resolution-setter,
    @resolution,
    @font-options-setter,
    @font-options,
    @default-display-setter,
    @default-display,
    @display-setter,
    @display,
    @type-setter,
    @type,
    @name-setter,
    @name,
    @n-axes,
    @input-source-setter,
    @input-source,
    @input-mode-setter,
    @input-mode,
    @has-cursor-setter,
    @has-cursor,
    @display-setter,
    @display,
    @device-manager-setter,
    @device-manager,
    @associated-device,
    @display-setter,
    @display,
    @cursor-type-setter,
    @cursor-type,
    @display-setter,
    @display;
end module;
