module: dylan-user
copyright: See LICENSE file in this distribution.

define library gio
  use dylan;
  use common-dylan;
  use c-ffi;
  use glib;
  use gobject;
  use glib;

  export gio;
  export gio-properties;
end library;

define module gio
  use dylan;
  use common-dylan;
  use c-ffi;
  use gobject-glue;
  use glib;
  use gobject;
  use glib;

  export
    g-unix-mounts-changed-since,
    g-unix-mount-points-changed-since,
    g-unix-mount-is-system-internal,
    g-unix-mount-is-readonly,
    g-unix-mount-guess-should-display,
    g-unix-mount-guess-name,
    g-unix-mount-guess-icon,
    g-unix-mount-guess-can-eject,
    g-unix-mount-get-mount-path,
    g-unix-mount-get-fs-type,
    g-unix-mount-get-device-path,
    g-unix-mount-free,
    g-unix-mount-compare,
    g-unix-is-mount-path-system-internal,
    g-tls-error-quark,
    g-simple-async-report-gerror-in-idle,
    g-resources-open-stream,
    g-resources-lookup-data,
    g-resources-get-info,
    g-resources-enumerate-children,
    g-resource-error-quark,
    g-resolver-error-quark,
    g-pollable-source-new,
    g-io-scheduler-push-job,
    g-io-scheduler-cancel-all-jobs,
    g-io-modules-scan-all-in-directory-with-scope,
    g-io-modules-scan-all-in-directory,
    g-io-modules-load-all-in-directory-with-scope,
    g-io-modules-load-all-in-directory,
    g-io-error-quark,
    g-io-error-from-errno,
    g-dbus-is-unique-name,
    g-dbus-is-supported-address,
    g-dbus-is-name,
    g-dbus-is-member-name,
    g-dbus-is-interface-name,
    g-dbus-is-guid,
    g-dbus-is-address,
    g-dbus-gvariant-to-gvalue,
    g-dbus-gvalue-to-gvariant,
    g-dbus-generate-guid,
    g-dbus-error-unregister-error,
    g-dbus-error-strip-remote-error,
    g-dbus-error-register-error-domain,
    g-dbus-error-register-error,
    g-dbus-error-quark,
    g-dbus-error-new-for-dbus-error,
    g-dbus-error-is-remote-error,
    g-dbus-error-get-remote-error,
    g-dbus-error-encode-gerror,
    g-dbus-address-get-stream-sync,
    g-dbus-address-get-stream-finish,
    g-dbus-address-get-stream,
    g-dbus-address-get-for-bus-sync,
    g-content-types-get-registered,
    g-content-type-is-unknown,
    g-content-type-is-a,
    g-content-type-guess-for-tree,
    g-content-type-guess,
    g-content-type-get-mime-type,
    g-content-type-get-icon,
    g-content-type-get-description,
    g-content-type-from-mime-type,
    g-content-type-equals,
    g-content-type-can-be-executable,
    g-bus-watch-name-with-closures,
    g-bus-watch-name-on-connection-with-closures,
    g-bus-unwatch-name,
    g-bus-unown-name,
    g-bus-own-name-with-closures,
    g-bus-own-name-on-connection-with-closures,
    g-bus-get-sync,
    g-bus-get-finish,
    g-bus-get,
    g-zlib-decompressor-class-parent-class,
    <GZlibDecompressorClass>,
    g-zlib-decompressor-get-file-info,
    g-zlib-decompressor-new,
    <GZlibDecompressor*>,
    <GZlibDecompressor>,
    <GZlibCompressorFormat*>,
    <GZlibCompressorFormat>,
    $g-zlib-compressor-format-raw,
    $g-zlib-compressor-format-gzip,
    $g-zlib-compressor-format-zlib,
    g-zlib-compressor-class-parent-class,
    <GZlibCompressorClass>,
    g-zlib-compressor-set-file-info,
    g-zlib-compressor-get-file-info,
    g-zlib-compressor-new,
    <GZlibCompressor*>,
    <GZlibCompressor>,
    g-volume-monitor-class-_g-reserved6,
    g-volume-monitor-class-_g-reserved5,
    g-volume-monitor-class-_g-reserved4,
    g-volume-monitor-class-_g-reserved3,
    g-volume-monitor-class-_g-reserved2,
    g-volume-monitor-class-_g-reserved1,
    g-volume-monitor-class-drive-stop-button,
    g-volume-monitor-class-drive-eject-button,
    g-volume-monitor-class-adopt-orphan-mount,
    g-volume-monitor-class-get-mount-for-uuid,
    g-volume-monitor-class-get-volume-for-uuid,
    g-volume-monitor-class-get-mounts,
    g-volume-monitor-class-get-volumes,
    g-volume-monitor-class-get-connected-drives,
    g-volume-monitor-class-is-supported,
    g-volume-monitor-class-drive-changed,
    g-volume-monitor-class-drive-disconnected,
    g-volume-monitor-class-drive-connected,
    g-volume-monitor-class-mount-changed,
    g-volume-monitor-class-mount-pre-unmount,
    g-volume-monitor-class-mount-removed,
    g-volume-monitor-class-mount-added,
    g-volume-monitor-class-volume-changed,
    g-volume-monitor-class-volume-removed,
    g-volume-monitor-class-volume-added,
    g-volume-monitor-class-parent-class,
    <GVolumeMonitorClass>,
    g-volume-monitor-get-volumes,
    g-volume-monitor-get-volume-for-uuid,
    g-volume-monitor-get-mounts,
    g-volume-monitor-get-mount-for-uuid,
    g-volume-monitor-get-connected-drives,
    g-volume-monitor-get,
    g-volume-monitor-adopt-orphan-mount,
    <GVolumeMonitor*>,
    g-volume-monitor-priv,
    g-volume-monitor-parent-instance,
    <GVolumeMonitor>,
    g-volume-iface-get-sort-key,
    g-volume-iface-eject-with-operation-finish,
    g-volume-iface-eject-with-operation,
    g-volume-iface-get-activation-root,
    g-volume-iface-should-automount,
    g-volume-iface-enumerate-identifiers,
    g-volume-iface-get-identifier,
    g-volume-iface-eject-finish,
    g-volume-iface-eject,
    g-volume-iface-mount-finish,
    g-volume-iface-mount-fn,
    g-volume-iface-can-eject,
    g-volume-iface-can-mount,
    g-volume-iface-get-mount,
    g-volume-iface-get-drive,
    g-volume-iface-get-uuid,
    g-volume-iface-get-icon,
    g-volume-iface-get-name,
    g-volume-iface-removed,
    g-volume-iface-changed,
    g-volume-iface-g-iface,
    <GVolumeIface>,
    g-volume-should-automount,
    g-volume-mount-finish,
    g-volume-mount,
    g-volume-get-uuid,
    g-volume-get-sort-key,
    g-volume-get-name,
    g-volume-get-mount,
    g-volume-get-identifier,
    g-volume-get-icon,
    g-volume-get-drive,
    g-volume-get-activation-root,
    g-volume-enumerate-identifiers,
    g-volume-eject-with-operation-finish,
    g-volume-eject-with-operation,
    g-volume-eject-finish,
    g-volume-eject,
    g-volume-can-mount,
    g-volume-can-eject,
    <GVolume*>,
    <GVolume>,
    g-vfs-class-_g-reserved7,
    g-vfs-class-_g-reserved6,
    g-vfs-class-_g-reserved5,
    g-vfs-class-_g-reserved4,
    g-vfs-class-_g-reserved3,
    g-vfs-class-_g-reserved2,
    g-vfs-class-_g-reserved1,
    g-vfs-class-local-file-moved,
    g-vfs-class-local-file-removed,
    g-vfs-class-local-file-set-attributes,
    g-vfs-class-add-writable-namespaces,
    g-vfs-class-local-file-add-info,
    g-vfs-class-parse-name,
    g-vfs-class-get-supported-uri-schemes,
    g-vfs-class-get-file-for-uri,
    g-vfs-class-get-file-for-path,
    g-vfs-class-is-active,
    g-vfs-class-parent-class,
    <GVfsClass>,
    g-vfs-parse-name,
    g-vfs-is-active,
    g-vfs-get-supported-uri-schemes,
    g-vfs-get-file-for-uri,
    g-vfs-get-file-for-path,
    g-vfs-get-local,
    g-vfs-get-default,
    <GVfs*>,
    g-vfs-parent-instance,
    <GVfs>,
    $volume-monitor-extension-point-name,
    $volume-identifier-kind-uuid,
    $volume-identifier-kind-unix-device,
    $volume-identifier-kind-nfs-mount,
    $volume-identifier-kind-label,
    $volume-identifier-kind-hal-udi,
    $volume-identifier-kind-class,
    $vfs-extension-point-name,
    <GUnixSocketAddressType*>,
    <GUnixSocketAddressType>,
    $g-unix-socket-address-abstract-padded,
    $g-unix-socket-address-abstract,
    $g-unix-socket-address-path,
    $g-unix-socket-address-anonymous,
    $g-unix-socket-address-invalid,
    <GUnixSocketAddressPrivate>,
    g-unix-socket-address-class-parent-class,
    <GUnixSocketAddressClass>,
    g-unix-socket-address-get-path-len,
    g-unix-socket-address-get-path,
    g-unix-socket-address-get-is-abstract,
    g-unix-socket-address-get-address-type,
    g-unix-socket-address-abstract-names-supported,
    g-unix-socket-address-new-with-type,
    g-unix-socket-address-new-abstract,
    g-unix-socket-address-new,
    <GUnixSocketAddress*>,
    g-unix-socket-address-priv,
    g-unix-socket-address-parent-instance,
    <GUnixSocketAddress>,
    <GUnixOutputStreamPrivate>,
    g-unix-output-stream-class-_g-reserved5,
    g-unix-output-stream-class-_g-reserved4,
    g-unix-output-stream-class-_g-reserved3,
    g-unix-output-stream-class-_g-reserved2,
    g-unix-output-stream-class-_g-reserved1,
    g-unix-output-stream-class-parent-class,
    <GUnixOutputStreamClass>,
    g-unix-output-stream-set-close-fd,
    g-unix-output-stream-get-fd,
    g-unix-output-stream-get-close-fd,
    g-unix-output-stream-new,
    <GUnixOutputStream*>,
    g-unix-output-stream-priv,
    g-unix-output-stream-parent-instance,
    <GUnixOutputStream>,
    g-unix-mount-point-is-user-mountable,
    g-unix-mount-point-is-readonly,
    g-unix-mount-point-is-loopback,
    g-unix-mount-point-guess-name,
    g-unix-mount-point-guess-icon,
    g-unix-mount-point-guess-can-eject,
    g-unix-mount-point-get-options,
    g-unix-mount-point-get-mount-path,
    g-unix-mount-point-get-fs-type,
    g-unix-mount-point-get-device-path,
    g-unix-mount-point-free,
    g-unix-mount-point-compare,
    <GUnixMountPoint>,
    <GUnixMountMonitorClass>,
    g-unix-mount-monitor-set-rate-limit,
    g-unix-mount-monitor-new,
    <GUnixMountMonitor*>,
    <GUnixMountMonitor>,
    <GUnixMountEntry>,
    <GUnixInputStreamPrivate>,
    g-unix-input-stream-class-_g-reserved5,
    g-unix-input-stream-class-_g-reserved4,
    g-unix-input-stream-class-_g-reserved3,
    g-unix-input-stream-class-_g-reserved2,
    g-unix-input-stream-class-_g-reserved1,
    g-unix-input-stream-class-parent-class,
    <GUnixInputStreamClass>,
    g-unix-input-stream-set-close-fd,
    g-unix-input-stream-get-fd,
    g-unix-input-stream-get-close-fd,
    g-unix-input-stream-new,
    <GUnixInputStream*>,
    g-unix-input-stream-priv,
    g-unix-input-stream-parent-instance,
    <GUnixInputStream>,
    <GUnixFDMessagePrivate>,
    g-unix-fd-message-class-_g-reserved2,
    g-unix-fd-message-class-_g-reserved1,
    g-unix-fd-message-class-parent-class,
    <GUnixFDMessageClass>,
    g-unix-fd-message-steal-fds,
    g-unix-fd-message-get-fd-list,
    g-unix-fd-message-append-fd,
    g-unix-fd-message-new-with-fd-list,
    g-unix-fd-message-new,
    <GUnixFDMessage*>,
    g-unix-fd-message-priv,
    g-unix-fd-message-parent-instance,
    <GUnixFDMessage>,
    <GUnixFDListPrivate>,
    g-unix-fd-list-class-_g-reserved5,
    g-unix-fd-list-class-_g-reserved4,
    g-unix-fd-list-class-_g-reserved3,
    g-unix-fd-list-class-_g-reserved2,
    g-unix-fd-list-class-_g-reserved1,
    g-unix-fd-list-class-parent-class,
    <GUnixFDListClass>,
    g-unix-fd-list-steal-fds,
    g-unix-fd-list-peek-fds,
    g-unix-fd-list-get-length,
    g-unix-fd-list-get,
    g-unix-fd-list-append,
    g-unix-fd-list-new-from-array,
    g-unix-fd-list-new,
    <GUnixFDList*>,
    g-unix-fd-list-priv,
    g-unix-fd-list-parent-instance,
    <GUnixFDList>,
    <GUnixCredentialsMessagePrivate>,
    g-unix-credentials-message-class-_g-reserved2,
    g-unix-credentials-message-class-_g-reserved1,
    g-unix-credentials-message-class-parent-class,
    <GUnixCredentialsMessageClass>,
    g-unix-credentials-message-get-credentials,
    g-unix-credentials-message-is-supported,
    g-unix-credentials-message-new-with-credentials,
    g-unix-credentials-message-new,
    <GUnixCredentialsMessage*>,
    g-unix-credentials-message-priv,
    g-unix-credentials-message-parent-instance,
    <GUnixCredentialsMessage>,
    <GUnixConnectionPrivate>,
    g-unix-connection-class-parent-class,
    <GUnixConnectionClass>,
    g-unix-connection-send-fd,
    g-unix-connection-send-credentials-finish,
    g-unix-connection-send-credentials-async,
    g-unix-connection-send-credentials,
    g-unix-connection-receive-fd,
    g-unix-connection-receive-credentials-finish,
    g-unix-connection-receive-credentials-async,
    g-unix-connection-receive-credentials,
    <GUnixConnection*>,
    g-unix-connection-priv,
    g-unix-connection-parent-instance,
    <GUnixConnection>,
    g-tls-server-connection-interface-g-iface,
    <GTlsServerConnectionInterface>,
    g-tls-server-connection-new,
    <GTlsServerConnection*>,
    <GTlsServerConnection>,
    <GTlsRehandshakeMode*>,
    <GTlsRehandshakeMode>,
    $g-tls-rehandshake-unsafely,
    $g-tls-rehandshake-safely,
    $g-tls-rehandshake-never,
    <GTlsPasswordPrivate>,
    <GTlsPasswordFlags*>,
    <GTlsPasswordFlags>,
    $g-tls-password-final-try,
    $g-tls-password-many-tries,
    $g-tls-password-retry,
    $g-tls-password-none,
    g-tls-password-class-padding,
    g-tls-password-class-get-default-warning,
    g-tls-password-class-set-value,
    g-tls-password-class-get-value,
    g-tls-password-class-parent-class,
    <GTlsPasswordClass>,
    g-tls-password-set-warning,
    g-tls-password-set-value-full,
    g-tls-password-set-value,
    g-tls-password-set-flags,
    g-tls-password-set-description,
    g-tls-password-get-warning,
    g-tls-password-get-value,
    g-tls-password-get-flags,
    g-tls-password-get-description,
    g-tls-password-new,
    <GTlsPassword*>,
    g-tls-password-priv,
    g-tls-password-parent-instance,
    <GTlsPassword>,
    <GTlsInteractionResult*>,
    <GTlsInteractionResult>,
    $g-tls-interaction-failed,
    $g-tls-interaction-handled,
    $g-tls-interaction-unhandled,
    <GTlsInteractionPrivate>,
    g-tls-interaction-class-padding,
    g-tls-interaction-class-ask-password-finish,
    g-tls-interaction-class-ask-password-async,
    g-tls-interaction-class-ask-password,
    g-tls-interaction-class-parent-class,
    <GTlsInteractionClass>,
    g-tls-interaction-invoke-ask-password,
    g-tls-interaction-ask-password-finish,
    g-tls-interaction-ask-password-async,
    g-tls-interaction-ask-password,
    <GTlsInteraction*>,
    g-tls-interaction-priv,
    g-tls-interaction-parent-instance,
    <GTlsInteraction>,
    g-tls-file-database-interface-padding,
    g-tls-file-database-interface-g-iface,
    <GTlsFileDatabaseInterface>,
    g-tls-file-database-new,
    <GTlsFileDatabase*>,
    <GTlsFileDatabase>,
    <GTlsError*>,
    <GTlsError>,
    $g-tls-error-eof,
    $g-tls-error-certificate-required,
    $g-tls-error-handshake,
    $g-tls-error-not-tls,
    $g-tls-error-bad-certificate,
    $g-tls-error-misc,
    $g-tls-error-unavailable,
    <GTlsDatabaseVerifyFlags*>,
    <GTlsDatabaseVerifyFlags>,
    $g-tls-database-verify-none,
    <GTlsDatabasePrivate>,
    <GTlsDatabaseLookupFlags*>,
    <GTlsDatabaseLookupFlags>,
    $g-tls-database-lookup-keypair,
    $g-tls-database-lookup-none,
    g-tls-database-class-padding,
    g-tls-database-class-lookup-certificates-issued-by-finish,
    g-tls-database-class-lookup-certificates-issued-by-async,
    g-tls-database-class-lookup-certificates-issued-by,
    g-tls-database-class-lookup-certificate-issuer-finish,
    g-tls-database-class-lookup-certificate-issuer-async,
    g-tls-database-class-lookup-certificate-issuer,
    g-tls-database-class-lookup-certificate-for-handle-finish,
    g-tls-database-class-lookup-certificate-for-handle-async,
    g-tls-database-class-lookup-certificate-for-handle,
    g-tls-database-class-create-certificate-handle,
    g-tls-database-class-verify-chain-finish,
    g-tls-database-class-verify-chain-async,
    g-tls-database-class-verify-chain,
    g-tls-database-class-parent-class,
    <GTlsDatabaseClass>,
    g-tls-database-verify-chain-finish,
    g-tls-database-verify-chain-async,
    g-tls-database-verify-chain,
    g-tls-database-lookup-certificates-issued-by-async,
    g-tls-database-lookup-certificates-issued-by,
    g-tls-database-lookup-certificate-issuer-finish,
    g-tls-database-lookup-certificate-issuer-async,
    g-tls-database-lookup-certificate-issuer,
    g-tls-database-lookup-certificate-for-handle-finish,
    g-tls-database-lookup-certificate-for-handle-async,
    g-tls-database-lookup-certificate-for-handle,
    g-tls-database-create-certificate-handle,
    <GTlsDatabase*>,
    g-tls-database-priv,
    g-tls-database-parent-instance,
    <GTlsDatabase>,
    <GTlsConnectionPrivate>,
    g-tls-connection-class-padding,
    g-tls-connection-class-handshake-finish,
    g-tls-connection-class-handshake-async,
    g-tls-connection-class-handshake,
    g-tls-connection-class-accept-certificate,
    g-tls-connection-class-parent-class,
    <GTlsConnectionClass>,
    g-tls-connection-set-use-system-certdb,
    g-tls-connection-set-require-close-notify,
    g-tls-connection-set-rehandshake-mode,
    g-tls-connection-set-interaction,
    g-tls-connection-set-database,
    g-tls-connection-set-certificate,
    g-tls-connection-handshake-finish,
    g-tls-connection-handshake-async,
    g-tls-connection-handshake,
    g-tls-connection-get-use-system-certdb,
    g-tls-connection-get-require-close-notify,
    g-tls-connection-get-rehandshake-mode,
    g-tls-connection-get-peer-certificate-errors,
    g-tls-connection-get-peer-certificate,
    g-tls-connection-get-interaction,
    g-tls-connection-get-database,
    g-tls-connection-get-certificate,
    g-tls-connection-emit-accept-certificate,
    <GTlsConnection*>,
    g-tls-connection-priv,
    g-tls-connection-parent-instance,
    <GTlsConnection>,
    g-tls-client-connection-interface-g-iface,
    <GTlsClientConnectionInterface>,
    g-tls-client-connection-set-validation-flags,
    g-tls-client-connection-set-use-ssl3,
    g-tls-client-connection-set-server-identity,
    g-tls-client-connection-get-validation-flags,
    g-tls-client-connection-get-use-ssl3,
    g-tls-client-connection-get-server-identity,
    g-tls-client-connection-get-accepted-cas,
    g-tls-client-connection-new,
    <GTlsClientConnection*>,
    <GTlsClientConnection>,
    <GTlsCertificatePrivate>,
    <GTlsCertificateFlags*>,
    <GTlsCertificateFlags>,
    $g-tls-certificate-validate-all,
    $g-tls-certificate-generic-error,
    $g-tls-certificate-insecure,
    $g-tls-certificate-revoked,
    $g-tls-certificate-expired,
    $g-tls-certificate-not-activated,
    $g-tls-certificate-bad-identity,
    $g-tls-certificate-unknown-ca,
    g-tls-certificate-class-padding,
    g-tls-certificate-class-verify,
    g-tls-certificate-class-parent-class,
    <GTlsCertificateClass>,
    g-tls-certificate-verify,
    g-tls-certificate-get-issuer,
    g-tls-certificate-list-new-from-file,
    g-tls-certificate-new-from-pem,
    g-tls-certificate-new-from-files,
    g-tls-certificate-new-from-file,
    <GTlsCertificate*>,
    g-tls-certificate-priv,
    g-tls-certificate-parent-instance,
    <GTlsCertificate>,
    g-tls-backend-interface-get-default-database,
    g-tls-backend-interface-get-file-database-type,
    g-tls-backend-interface-get-server-connection-type,
    g-tls-backend-interface-get-client-connection-type,
    g-tls-backend-interface-get-certificate-type,
    g-tls-backend-interface-supports-tls,
    g-tls-backend-interface-g-iface,
    <GTlsBackendInterface>,
    g-tls-backend-supports-tls,
    g-tls-backend-get-server-connection-type,
    g-tls-backend-get-file-database-type,
    g-tls-backend-get-default-database,
    g-tls-backend-get-client-connection-type,
    g-tls-backend-get-certificate-type,
    g-tls-backend-get-default,
    <GTlsBackend*>,
    <GTlsBackend>,
    <GTlsAuthenticationMode*>,
    <GTlsAuthenticationMode>,
    $g-tls-authentication-required,
    $g-tls-authentication-requested,
    $g-tls-authentication-none,
    <GThreadedSocketServicePrivate>,
    g-threaded-socket-service-class-_g-reserved5,
    g-threaded-socket-service-class-_g-reserved4,
    g-threaded-socket-service-class-_g-reserved3,
    g-threaded-socket-service-class-_g-reserved2,
    g-threaded-socket-service-class-_g-reserved1,
    g-threaded-socket-service-class-run,
    g-threaded-socket-service-class-parent-class,
    <GThreadedSocketServiceClass>,
    g-threaded-socket-service-new,
    <GThreadedSocketService*>,
    g-threaded-socket-service-priv,
    g-threaded-socket-service-parent-instance,
    <GThreadedSocketService>,
    <GThemedIconClass>,
    g-themed-icon-prepend-name,
    g-themed-icon-get-names,
    g-themed-icon-append-name,
    g-themed-icon-new-with-default-fallbacks,
    g-themed-icon-new-from-names,
    g-themed-icon-new,
    <GThemedIcon*>,
    <GThemedIcon>,
    <GTcpWrapperConnectionPrivate>,
    g-tcp-wrapper-connection-class-parent-class,
    <GTcpWrapperConnectionClass>,
    g-tcp-wrapper-connection-get-base-io-stream,
    g-tcp-wrapper-connection-new,
    <GTcpWrapperConnection*>,
    g-tcp-wrapper-connection-priv,
    g-tcp-wrapper-connection-parent-instance,
    <GTcpWrapperConnection>,
    <GTcpConnectionPrivate>,
    g-tcp-connection-class-parent-class,
    <GTcpConnectionClass>,
    g-tcp-connection-set-graceful-disconnect,
    g-tcp-connection-get-graceful-disconnect,
    <GTcpConnection*>,
    g-tcp-connection-priv,
    g-tcp-connection-parent-instance,
    <GTcpConnection>,
    $tls-database-purpose-authenticate-server,
    $tls-database-purpose-authenticate-client,
    $tls-backend-extension-point-name,
    g-static-resource-init,
    g-static-resource-get-resource,
    g-static-resource-fini,
    g-static-resource-padding-setter,
    g-static-resource-padding,
    g-static-resource-next-setter,
    g-static-resource-next,
    g-static-resource-resource-setter,
    g-static-resource-resource,
    g-static-resource-data-len-setter,
    g-static-resource-data-len,
    g-static-resource-data-setter,
    g-static-resource-data,
    <GStaticResource>,
    g-srv-target-get-weight,
    g-srv-target-get-priority,
    g-srv-target-get-port,
    g-srv-target-get-hostname,
    g-srv-target-free,
    g-srv-target-copy,
    g-srv-target-new,
    <GSrvTarget>,
    <GSocketType*>,
    <GSocketType>,
    $g-socket-type-seqpacket,
    $g-socket-type-datagram,
    $g-socket-type-stream,
    $g-socket-type-invalid,
    <GSocketServicePrivate>,
    g-socket-service-class-_g-reserved6,
    g-socket-service-class-_g-reserved5,
    g-socket-service-class-_g-reserved4,
    g-socket-service-class-_g-reserved3,
    g-socket-service-class-_g-reserved2,
    g-socket-service-class-_g-reserved1,
    g-socket-service-class-incoming,
    g-socket-service-class-parent-class,
    <GSocketServiceClass>,
    g-socket-service-stop,
    g-socket-service-start,
    g-socket-service-is-active,
    g-socket-service-new,
    <GSocketService*>,
    g-socket-service-priv,
    g-socket-service-parent-instance,
    <GSocketService>,
    <GSocketProtocol*>,
    <GSocketProtocol>,
    $g-socket-protocol-sctp,
    $g-socket-protocol-udp,
    $g-socket-protocol-tcp,
    $g-socket-protocol-default,
    $g-socket-protocol-unknown,
    <GSocketPrivate>,
    <GSocketMsgFlags*>,
    <GSocketMsgFlags>,
    $g-socket-msg-dontroute,
    $g-socket-msg-peek,
    $g-socket-msg-oob,
    $g-socket-msg-none,
    <GSocketListenerPrivate>,
    g-socket-listener-class-_g-reserved6,
    g-socket-listener-class-_g-reserved5,
    g-socket-listener-class-_g-reserved4,
    g-socket-listener-class-_g-reserved3,
    g-socket-listener-class-_g-reserved2,
    g-socket-listener-class-_g-reserved1,
    g-socket-listener-class-changed,
    g-socket-listener-class-parent-class,
    <GSocketListenerClass>,
    g-socket-listener-set-backlog,
    g-socket-listener-close,
    g-socket-listener-add-socket,
    g-socket-listener-add-inet-port,
    g-socket-listener-add-any-inet-port,
    g-socket-listener-add-address,
    g-socket-listener-accept-socket-finish,
    g-socket-listener-accept-socket-async,
    g-socket-listener-accept-socket,
    g-socket-listener-accept-finish,
    g-socket-listener-accept-async,
    g-socket-listener-accept,
    g-socket-listener-new,
    <GSocketListener*>,
    g-socket-listener-priv,
    g-socket-listener-parent-instance,
    <GSocketListener>,
    <GSocketFamily*>,
    <GSocketFamily>,
    $g-socket-family-ipv6,
    $g-socket-family-ipv4,
    $g-socket-family-unix,
    $g-socket-family-invalid,
    <GSocketControlMessagePrivate>,
    g-socket-control-message-class-_g-reserved5,
    g-socket-control-message-class-_g-reserved4,
    g-socket-control-message-class-_g-reserved3,
    g-socket-control-message-class-_g-reserved2,
    g-socket-control-message-class-_g-reserved1,
    g-socket-control-message-class-deserialize,
    g-socket-control-message-class-serialize,
    g-socket-control-message-class-get-type,
    g-socket-control-message-class-get-level,
    g-socket-control-message-class-get-size,
    g-socket-control-message-class-parent-class,
    <GSocketControlMessageClass>,
    g-socket-control-message-serialize,
    g-socket-control-message-get-size,
    g-socket-control-message-get-msg-type,
    g-socket-control-message-get-level,
    g-socket-control-message-deserialize,
    <GSocketControlMessage*>,
    g-socket-control-message-priv,
    g-socket-control-message-parent-instance,
    <GSocketControlMessage>,
    <GSocketConnectionPrivate>,
    g-socket-connection-class-_g-reserved6,
    g-socket-connection-class-_g-reserved5,
    g-socket-connection-class-_g-reserved4,
    g-socket-connection-class-_g-reserved3,
    g-socket-connection-class-_g-reserved2,
    g-socket-connection-class-_g-reserved1,
    g-socket-connection-class-parent-class,
    <GSocketConnectionClass>,
    g-socket-connection-is-connected,
    g-socket-connection-get-socket,
    g-socket-connection-get-remote-address,
    g-socket-connection-get-local-address,
    g-socket-connection-connect-finish,
    g-socket-connection-connect-async,
    g-socket-connection-connect,
    g-socket-connection-factory-register-type,
    g-socket-connection-factory-lookup-type,
    <GSocketConnection*>,
    g-socket-connection-priv,
    g-socket-connection-parent-instance,
    <GSocketConnection>,
    g-socket-connectable-iface-proxy-enumerate,
    g-socket-connectable-iface-enumerate,
    g-socket-connectable-iface-g-iface,
    <GSocketConnectableIface>,
    g-socket-connectable-proxy-enumerate,
    g-socket-connectable-enumerate,
    <GSocketConnectable*>,
    <GSocketConnectable>,
    <GSocketClientPrivate>,
    <GSocketClientEvent*>,
    <GSocketClientEvent>,
    $g-socket-client-complete,
    $g-socket-client-tls-handshaked,
    $g-socket-client-tls-handshaking,
    $g-socket-client-proxy-negotiated,
    $g-socket-client-proxy-negotiating,
    $g-socket-client-connected,
    $g-socket-client-connecting,
    $g-socket-client-resolved,
    $g-socket-client-resolving,
    g-socket-client-class-_g-reserved4,
    g-socket-client-class-_g-reserved3,
    g-socket-client-class-_g-reserved2,
    g-socket-client-class-_g-reserved1,
    g-socket-client-class-event,
    g-socket-client-class-parent-class,
    <GSocketClientClass>,
    g-socket-client-set-tls-validation-flags,
    g-socket-client-set-tls,
    g-socket-client-set-timeout,
    g-socket-client-set-socket-type,
    g-socket-client-set-protocol,
    g-socket-client-set-local-address,
    g-socket-client-set-family,
    g-socket-client-set-enable-proxy,
    g-socket-client-get-tls-validation-flags,
    g-socket-client-get-tls,
    g-socket-client-get-timeout,
    g-socket-client-get-socket-type,
    g-socket-client-get-protocol,
    g-socket-client-get-local-address,
    g-socket-client-get-family,
    g-socket-client-get-enable-proxy,
    g-socket-client-connect-to-uri-finish,
    g-socket-client-connect-to-uri-async,
    g-socket-client-connect-to-uri,
    g-socket-client-connect-to-service-finish,
    g-socket-client-connect-to-service-async,
    g-socket-client-connect-to-service,
    g-socket-client-connect-to-host-finish,
    g-socket-client-connect-to-host-async,
    g-socket-client-connect-to-host,
    g-socket-client-connect-finish,
    g-socket-client-connect-async,
    g-socket-client-connect,
    g-socket-client-add-application-proxy,
    g-socket-client-new,
    <GSocketClient*>,
    g-socket-client-priv,
    g-socket-client-parent-instance,
    <GSocketClient>,
    g-socket-class-_g-reserved10,
    g-socket-class-_g-reserved9,
    g-socket-class-_g-reserved8,
    g-socket-class-_g-reserved7,
    g-socket-class-_g-reserved6,
    g-socket-class-_g-reserved5,
    g-socket-class-_g-reserved4,
    g-socket-class-_g-reserved3,
    g-socket-class-_g-reserved2,
    g-socket-class-_g-reserved1,
    g-socket-class-parent-class,
    <GSocketClass>,
    g-socket-address-enumerator-class-next-finish,
    g-socket-address-enumerator-class-next-async,
    g-socket-address-enumerator-class-next,
    g-socket-address-enumerator-class-parent-class,
    <GSocketAddressEnumeratorClass>,
    g-socket-address-enumerator-next-finish,
    g-socket-address-enumerator-next-async,
    g-socket-address-enumerator-next,
    <GSocketAddressEnumerator*>,
    g-socket-address-enumerator-parent-instance,
    <GSocketAddressEnumerator>,
    g-socket-address-class-to-native,
    g-socket-address-class-get-native-size,
    g-socket-address-class-get-family,
    g-socket-address-class-parent-class,
    <GSocketAddressClass>,
    g-socket-address-to-native,
    g-socket-address-get-native-size,
    g-socket-address-get-family,
    g-socket-address-new-from-native,
    <GSocketAddress*>,
    g-socket-address-parent-instance,
    <GSocketAddress>,
    g-socket-speaks-ipv4,
    g-socket-shutdown,
    g-socket-set-ttl,
    g-socket-set-timeout,
    g-socket-set-multicast-ttl,
    g-socket-set-multicast-loopback,
    g-socket-set-listen-backlog,
    g-socket-set-keepalive,
    g-socket-set-broadcast,
    g-socket-set-blocking,
    g-socket-send-with-blocking,
    g-socket-send-to,
    g-socket-send-message,
    g-socket-send,
    g-socket-receive-with-blocking,
    g-socket-receive-message,
    g-socket-receive-from,
    g-socket-receive,
    g-socket-listen,
    g-socket-leave-multicast-group,
    g-socket-join-multicast-group,
    g-socket-is-connected,
    g-socket-is-closed,
    g-socket-get-ttl,
    g-socket-get-timeout,
    g-socket-get-socket-type,
    g-socket-get-remote-address,
    g-socket-get-protocol,
    g-socket-get-multicast-ttl,
    g-socket-get-multicast-loopback,
    g-socket-get-local-address,
    g-socket-get-listen-backlog,
    g-socket-get-keepalive,
    g-socket-get-fd,
    g-socket-get-family,
    g-socket-get-credentials,
    g-socket-get-broadcast,
    g-socket-get-blocking,
    g-socket-get-available-bytes,
    g-socket-connection-factory-create-connection,
    g-socket-connect,
    g-socket-condition-wait,
    g-socket-condition-timed-wait,
    g-socket-condition-check,
    g-socket-close,
    g-socket-check-connect-result,
    g-socket-bind,
    g-socket-accept,
    g-socket-new-from-fd,
    g-socket-new,
    <GSocket*>,
    g-socket-priv,
    g-socket-parent-instance,
    <GSocket>,
    g-simple-permission-new,
    <GSimplePermission*>,
    <GSimplePermission>,
    <GSimpleAsyncResultClass>,
    g-simple-async-result-set-op-res-gssize,
    g-simple-async-result-set-op-res-gboolean,
    g-simple-async-result-set-handle-cancellation,
    g-simple-async-result-set-from-error,
    g-simple-async-result-set-check-cancellable,
    g-simple-async-result-propagate-error,
    g-simple-async-result-get-op-res-gssize,
    g-simple-async-result-get-op-res-gboolean,
    g-simple-async-result-complete-in-idle,
    g-simple-async-result-complete,
    g-simple-async-result-is-valid,
    g-simple-async-result-new-from-error,
    g-simple-async-result-new,
    <GSimpleAsyncResult*>,
    <GSimpleAsyncResult>,
    <GSimpleActionGroupPrivate>,
    g-simple-action-group-class-padding,
    g-simple-action-group-class-parent-class,
    <GSimpleActionGroupClass>,
    g-simple-action-group-remove,
    g-simple-action-group-lookup,
    g-simple-action-group-insert,
    g-simple-action-group-add-entries,
    g-simple-action-group-new,
    <GSimpleActionGroup*>,
    g-simple-action-group-priv,
    g-simple-action-group-parent-instance,
    <GSimpleActionGroup>,
    g-simple-action-set-state,
    g-simple-action-set-enabled,
    g-simple-action-new-stateful,
    g-simple-action-new,
    <GSimpleAction*>,
    <GSimpleAction>,
    g-settings-schema-source-get-default,
    g-settings-schema-source-unref,
    g-settings-schema-source-ref,
    g-settings-schema-source-lookup,
    g-settings-schema-source-new-from-directory,
    <GSettingsSchemaSource>,
    g-settings-schema-unref,
    g-settings-schema-ref,
    g-settings-schema-get-path,
    g-settings-schema-get-id,
    <GSettingsSchema>,
    <GSettingsPrivate>,
    g-settings-class-padding,
    g-settings-class-change-event,
    g-settings-class-writable-change-event,
    g-settings-class-changed,
    g-settings-class-writable-changed,
    g-settings-class-parent-class,
    <GSettingsClass>,
    <GSettingsBindFlags*>,
    <GSettingsBindFlags>,
    $g-settings-bind-invert-boolean,
    $g-settings-bind-get-no-changes,
    $g-settings-bind-no-sensitivity,
    $g-settings-bind-set,
    $g-settings-bind-get,
    $g-settings-bind-default,
    <GSettingsBackend>,
    g-settings-set-value,
    g-settings-set-uint,
    g-settings-set-strv,
    g-settings-set-string,
    g-settings-set-int,
    g-settings-set-flags,
    g-settings-set-enum,
    g-settings-set-double,
    g-settings-set-boolean,
    g-settings-revert,
    g-settings-reset,
    g-settings-range-check,
    g-settings-list-keys,
    g-settings-list-children,
    g-settings-is-writable,
    g-settings-get-value,
    g-settings-get-uint,
    g-settings-get-strv,
    g-settings-get-string,
    g-settings-get-range,
    g-settings-get-mapped,
    g-settings-get-int,
    g-settings-get-has-unapplied,
    g-settings-get-flags,
    g-settings-get-enum,
    g-settings-get-double,
    g-settings-get-child,
    g-settings-get-boolean,
    g-settings-delay,
    g-settings-create-action,
    g-settings-bind-writable,
    g-settings-bind,
    g-settings-apply,
    g-settings-unbind,
    g-settings-sync,
    g-settings-list-schemas,
    g-settings-list-relocatable-schemas,
    g-settings-new-with-path,
    g-settings-new-with-backend-and-path,
    g-settings-new-with-backend,
    g-settings-new-full,
    g-settings-new,
    <GSettings*>,
    g-settings-priv,
    g-settings-parent-instance,
    <GSettings>,
    g-seekable-iface-truncate-fn,
    g-seekable-iface-can-truncate,
    g-seekable-iface-seek,
    g-seekable-iface-can-seek,
    g-seekable-iface-tell,
    g-seekable-iface-g-iface,
    <GSeekableIface>,
    g-seekable-truncate,
    g-seekable-tell,
    g-seekable-seek,
    g-seekable-can-truncate,
    g-seekable-can-seek,
    <GSeekable*>,
    <GSeekable>,
    <GResourceLookupFlags*>,
    <GResourceLookupFlags>,
    $g-resource-lookup-flags-none,
    <GResourceFlags*>,
    <GResourceFlags>,
    $g-resource-flags-compressed,
    $g-resource-flags-none,
    <GResourceError*>,
    <GResourceError>,
    $g-resource-error-internal,
    $g-resource-error-not-found,
    g-resource-load,
    g-resource-unref,
    g-resource-ref,
    g-resource-open-stream,
    g-resource-lookup-data,
    g-resource-get-info,
    g-resource-enumerate-children,
    g-resources-unregister,
    g-resources-register,
    g-resource-new-from-data,
    <GResource>,
    <GResolverPrivate>,
    <GResolverError*>,
    <GResolverError>,
    $g-resolver-error-internal,
    $g-resolver-error-temporary-failure,
    $g-resolver-error-not-found,
    g-resolver-class-_g-reserved6,
    g-resolver-class-_g-reserved5,
    g-resolver-class-_g-reserved4,
    g-resolver-class-_g-reserved3,
    g-resolver-class-_g-reserved2,
    g-resolver-class-_g-reserved1,
    g-resolver-class-lookup-service-finish,
    g-resolver-class-lookup-service-async,
    g-resolver-class-lookup-service,
    g-resolver-class-lookup-by-address-finish,
    g-resolver-class-lookup-by-address-async,
    g-resolver-class-lookup-by-address,
    g-resolver-class-lookup-by-name-finish,
    g-resolver-class-lookup-by-name-async,
    g-resolver-class-lookup-by-name,
    g-resolver-class-reload,
    g-resolver-class-parent-class,
    <GResolverClass>,
    g-resolver-set-default,
    g-resolver-lookup-service-finish,
    g-resolver-lookup-service-async,
    g-resolver-lookup-service,
    g-resolver-lookup-by-name-finish,
    g-resolver-lookup-by-name-async,
    g-resolver-lookup-by-name,
    g-resolver-lookup-by-address-finish,
    g-resolver-lookup-by-address-async,
    g-resolver-lookup-by-address,
    g-resolver-get-default,
    <GResolver*>,
    g-resolver-priv,
    g-resolver-parent-instance,
    <GResolver>,
    g-remote-action-group-interface-change-action-state-full,
    g-remote-action-group-interface-activate-action-full,
    g-remote-action-group-interface-g-iface,
    <GRemoteActionGroupInterface>,
    g-remote-action-group-change-action-state-full,
    g-remote-action-group-activate-action-full,
    <GRemoteActionGroup*>,
    <GRemoteActionGroup>,
    g-proxy-resolver-interface-lookup-finish,
    g-proxy-resolver-interface-lookup-async,
    g-proxy-resolver-interface-lookup,
    g-proxy-resolver-interface-is-supported,
    g-proxy-resolver-interface-g-iface,
    <GProxyResolverInterface>,
    g-proxy-resolver-lookup-finish,
    g-proxy-resolver-lookup-async,
    g-proxy-resolver-lookup,
    g-proxy-resolver-is-supported,
    g-proxy-resolver-get-default,
    <GProxyResolver*>,
    <GProxyResolver>,
    g-proxy-interface-supports-hostname,
    g-proxy-interface-connect-finish,
    g-proxy-interface-connect-async,
    g-proxy-interface-connect,
    g-proxy-interface-g-iface,
    <GProxyInterface>,
    <GProxyAddressPrivate>,
    <GProxyAddressEnumeratorPrivate>,
    g-proxy-address-enumerator-class-_g-reserved7,
    g-proxy-address-enumerator-class-_g-reserved6,
    g-proxy-address-enumerator-class-_g-reserved5,
    g-proxy-address-enumerator-class-_g-reserved4,
    g-proxy-address-enumerator-class-_g-reserved3,
    g-proxy-address-enumerator-class-_g-reserved2,
    g-proxy-address-enumerator-class-_g-reserved1,
    g-proxy-address-enumerator-class-parent-class,
    <GProxyAddressEnumeratorClass>,
    <GProxyAddressEnumerator*>,
    g-proxy-address-enumerator-priv,
    g-proxy-address-enumerator-parent-instance,
    <GProxyAddressEnumerator>,
    g-proxy-address-class-parent-class,
    <GProxyAddressClass>,
    g-proxy-address-get-username,
    g-proxy-address-get-protocol,
    g-proxy-address-get-password,
    g-proxy-address-get-destination-port,
    g-proxy-address-get-destination-hostname,
    g-proxy-address-new,
    <GProxyAddress*>,
    g-proxy-address-priv,
    g-proxy-address-parent-instance,
    <GProxyAddress>,
    g-proxy-supports-hostname,
    g-proxy-connect-finish,
    g-proxy-connect-async,
    g-proxy-connect,
    g-proxy-get-default-for-protocol,
    <GProxy*>,
    <GProxy>,
    g-pollable-output-stream-interface-write-nonblocking,
    g-pollable-output-stream-interface-create-source,
    g-pollable-output-stream-interface-is-writable,
    g-pollable-output-stream-interface-can-poll,
    g-pollable-output-stream-interface-g-iface,
    <GPollableOutputStreamInterface>,
    g-pollable-output-stream-write-nonblocking,
    g-pollable-output-stream-is-writable,
    g-pollable-output-stream-create-source,
    g-pollable-output-stream-can-poll,
    <GPollableOutputStream*>,
    <GPollableOutputStream>,
    g-pollable-input-stream-interface-read-nonblocking,
    g-pollable-input-stream-interface-create-source,
    g-pollable-input-stream-interface-is-readable,
    g-pollable-input-stream-interface-can-poll,
    g-pollable-input-stream-interface-g-iface,
    <GPollableInputStreamInterface>,
    g-pollable-input-stream-read-nonblocking,
    g-pollable-input-stream-is-readable,
    g-pollable-input-stream-create-source,
    g-pollable-input-stream-can-poll,
    <GPollableInputStream*>,
    <GPollableInputStream>,
    <GPermissionPrivate>,
    g-permission-class-reserved,
    g-permission-class-release-finish,
    g-permission-class-release-async,
    g-permission-class-release,
    g-permission-class-acquire-finish,
    g-permission-class-acquire-async,
    g-permission-class-acquire,
    g-permission-class-parent-class,
    <GPermissionClass>,
    g-permission-release-finish,
    g-permission-release-async,
    g-permission-release,
    g-permission-impl-update,
    g-permission-get-can-release,
    g-permission-get-can-acquire,
    g-permission-get-allowed,
    g-permission-acquire-finish,
    g-permission-acquire-async,
    g-permission-acquire,
    <GPermission*>,
    g-permission-priv,
    g-permission-parent-instance,
    <GPermission>,
    <GPasswordSave*>,
    <GPasswordSave>,
    $g-password-save-permanently,
    $g-password-save-for-session,
    $g-password-save-never,
    $proxy-resolver-extension-point-name,
    $proxy-extension-point-name,
    g-output-vector-size-setter,
    g-output-vector-size,
    g-output-vector-buffer-setter,
    g-output-vector-buffer,
    <GOutputVector>,
    <GOutputStreamSpliceFlags*>,
    <GOutputStreamSpliceFlags>,
    $g-output-stream-splice-close-target,
    $g-output-stream-splice-close-source,
    $g-output-stream-splice-none,
    <GOutputStreamPrivate>,
    g-output-stream-class-_g-reserved8,
    g-output-stream-class-_g-reserved7,
    g-output-stream-class-_g-reserved6,
    g-output-stream-class-_g-reserved5,
    g-output-stream-class-_g-reserved4,
    g-output-stream-class-_g-reserved3,
    g-output-stream-class-_g-reserved2,
    g-output-stream-class-_g-reserved1,
    g-output-stream-class-close-finish,
    g-output-stream-class-close-async,
    g-output-stream-class-flush-finish,
    g-output-stream-class-flush-async,
    g-output-stream-class-splice-finish,
    g-output-stream-class-splice-async,
    g-output-stream-class-write-finish,
    g-output-stream-class-write-async,
    g-output-stream-class-close-fn,
    g-output-stream-class-flush,
    g-output-stream-class-splice,
    g-output-stream-class-write-fn,
    g-output-stream-class-parent-class,
    <GOutputStreamClass>,
    g-output-stream-write-finish,
    g-output-stream-write-async,
    g-output-stream-write-all,
    g-output-stream-write,
    g-output-stream-splice-finish,
    g-output-stream-splice-async,
    g-output-stream-splice,
    g-output-stream-set-pending,
    g-output-stream-is-closing,
    g-output-stream-is-closed,
    g-output-stream-has-pending,
    g-output-stream-flush-finish,
    g-output-stream-flush-async,
    g-output-stream-flush,
    g-output-stream-close-finish,
    g-output-stream-close-async,
    g-output-stream-close,
    g-output-stream-clear-pending,
    <GOutputStream*>,
    g-output-stream-priv,
    g-output-stream-parent-instance,
    <GOutputStream>,
    <GNetworkServicePrivate>,
    g-network-service-class-parent-class,
    <GNetworkServiceClass>,
    g-network-service-set-scheme,
    g-network-service-get-service,
    g-network-service-get-scheme,
    g-network-service-get-protocol,
    g-network-service-get-domain,
    g-network-service-new,
    <GNetworkService*>,
    g-network-service-priv,
    g-network-service-parent-instance,
    <GNetworkService>,
    g-network-monitor-interface-can-reach-finish,
    g-network-monitor-interface-can-reach-async,
    g-network-monitor-interface-can-reach,
    g-network-monitor-interface-network-changed,
    g-network-monitor-interface-g-iface,
    <GNetworkMonitorInterface>,
    g-network-monitor-get-network-available,
    g-network-monitor-can-reach-finish,
    g-network-monitor-can-reach-async,
    g-network-monitor-can-reach,
    g-network-monitor-get-default,
    <GNetworkMonitor*>,
    <GNetworkMonitor>,
    <GNetworkAddressPrivate>,
    g-network-address-class-parent-class,
    <GNetworkAddressClass>,
    g-network-address-get-scheme,
    g-network-address-get-port,
    g-network-address-get-hostname,
    g-network-address-parse-uri,
    g-network-address-parse,
    g-network-address-new,
    <GNetworkAddress*>,
    g-network-address-priv,
    g-network-address-parent-instance,
    <GNetworkAddress>,
    g-native-volume-monitor-class-get-mount-for-mount-path,
    g-native-volume-monitor-class-parent-class,
    <GNativeVolumeMonitorClass>,
    <GNativeVolumeMonitor*>,
    g-native-volume-monitor-parent-instance,
    <GNativeVolumeMonitor>,
    $network-monitor-extension-point-name,
    $native-volume-monitor-extension-point-name,
    <GMountUnmountFlags*>,
    <GMountUnmountFlags>,
    $g-mount-unmount-force,
    $g-mount-unmount-none,
    <GMountOperationResult*>,
    <GMountOperationResult>,
    $g-mount-operation-unhandled,
    $g-mount-operation-aborted,
    $g-mount-operation-handled,
    <GMountOperationPrivate>,
    g-mount-operation-class-_g-reserved10,
    g-mount-operation-class-_g-reserved9,
    g-mount-operation-class-_g-reserved8,
    g-mount-operation-class-_g-reserved7,
    g-mount-operation-class-_g-reserved6,
    g-mount-operation-class-_g-reserved5,
    g-mount-operation-class-_g-reserved4,
    g-mount-operation-class-_g-reserved3,
    g-mount-operation-class-_g-reserved2,
    g-mount-operation-class-_g-reserved1,
    g-mount-operation-class-show-processes,
    g-mount-operation-class-aborted,
    g-mount-operation-class-reply,
    g-mount-operation-class-ask-question,
    g-mount-operation-class-ask-password,
    g-mount-operation-class-parent-class,
    <GMountOperationClass>,
    g-mount-operation-set-username,
    g-mount-operation-set-password-save,
    g-mount-operation-set-password,
    g-mount-operation-set-domain,
    g-mount-operation-set-choice,
    g-mount-operation-set-anonymous,
    g-mount-operation-reply,
    g-mount-operation-get-username,
    g-mount-operation-get-password-save,
    g-mount-operation-get-password,
    g-mount-operation-get-domain,
    g-mount-operation-get-choice,
    g-mount-operation-get-anonymous,
    g-mount-operation-new,
    <GMountOperation*>,
    g-mount-operation-priv,
    g-mount-operation-parent-instance,
    <GMountOperation>,
    <GMountMountFlags*>,
    <GMountMountFlags>,
    $g-mount-mount-none,
    g-mount-iface-get-sort-key,
    g-mount-iface-get-default-location,
    g-mount-iface-eject-with-operation-finish,
    g-mount-iface-eject-with-operation,
    g-mount-iface-unmount-with-operation-finish,
    g-mount-iface-unmount-with-operation,
    g-mount-iface-pre-unmount,
    g-mount-iface-guess-content-type-sync,
    g-mount-iface-guess-content-type-finish,
    g-mount-iface-guess-content-type,
    g-mount-iface-remount-finish,
    g-mount-iface-remount,
    g-mount-iface-eject-finish,
    g-mount-iface-eject,
    g-mount-iface-unmount-finish,
    g-mount-iface-unmount,
    g-mount-iface-can-eject,
    g-mount-iface-can-unmount,
    g-mount-iface-get-drive,
    g-mount-iface-get-volume,
    g-mount-iface-get-uuid,
    g-mount-iface-get-icon,
    g-mount-iface-get-name,
    g-mount-iface-get-root,
    g-mount-iface-unmounted,
    g-mount-iface-changed,
    g-mount-iface-g-iface,
    <GMountIface>,
    g-mount-unshadow,
    g-mount-unmount-with-operation-finish,
    g-mount-unmount-with-operation,
    g-mount-unmount-finish,
    g-mount-unmount,
    g-mount-shadow,
    g-mount-remount-finish,
    g-mount-remount,
    g-mount-is-shadowed,
    g-mount-guess-content-type-sync,
    g-mount-guess-content-type-finish,
    g-mount-guess-content-type,
    g-mount-get-volume,
    g-mount-get-uuid,
    g-mount-get-sort-key,
    g-mount-get-root,
    g-mount-get-name,
    g-mount-get-icon,
    g-mount-get-drive,
    g-mount-get-default-location,
    g-mount-eject-with-operation-finish,
    g-mount-eject-with-operation,
    g-mount-eject-finish,
    g-mount-eject,
    g-mount-can-unmount,
    g-mount-can-eject,
    <GMount*>,
    <GMount>,
    <GMenuModelPrivate>,
    g-menu-model-class-get-item-link,
    g-menu-model-class-iterate-item-links,
    g-menu-model-class-get-item-links,
    g-menu-model-class-get-item-attribute-value,
    g-menu-model-class-iterate-item-attributes,
    g-menu-model-class-get-item-attributes,
    g-menu-model-class-get-n-items,
    g-menu-model-class-is-mutable,
    g-menu-model-class-parent-class,
    <GMenuModelClass>,
    g-menu-model-iterate-item-links,
    g-menu-model-iterate-item-attributes,
    g-menu-model-items-changed,
    g-menu-model-is-mutable,
    g-menu-model-get-n-items,
    g-menu-model-get-item-link,
    g-menu-model-get-item-attribute-value,
    <GMenuModel*>,
    g-menu-model-priv,
    g-menu-model-parent-instance,
    <GMenuModel>,
    <GMenuLinkIterPrivate>,
    g-menu-link-iter-class-get-next,
    g-menu-link-iter-class-parent-class,
    <GMenuLinkIterClass>,
    g-menu-link-iter-next,
    g-menu-link-iter-get-value,
    g-menu-link-iter-get-next,
    g-menu-link-iter-get-name,
    <GMenuLinkIter*>,
    g-menu-link-iter-priv,
    g-menu-link-iter-parent-instance,
    <GMenuLinkIter>,
    g-menu-item-set-submenu,
    g-menu-item-set-section,
    g-menu-item-set-link,
    g-menu-item-set-label,
    g-menu-item-set-detailed-action,
    g-menu-item-set-attribute-value,
    g-menu-item-set-action-and-target-value,
    g-menu-item-new-submenu,
    g-menu-item-new-section,
    g-menu-item-new,
    <GMenuItem*>,
    <GMenuItem>,
    <GMenuAttributeIterPrivate>,
    g-menu-attribute-iter-class-get-next,
    g-menu-attribute-iter-class-parent-class,
    <GMenuAttributeIterClass>,
    g-menu-attribute-iter-next,
    g-menu-attribute-iter-get-value,
    g-menu-attribute-iter-get-next,
    g-menu-attribute-iter-get-name,
    <GMenuAttributeIter*>,
    g-menu-attribute-iter-priv,
    g-menu-attribute-iter-parent-instance,
    <GMenuAttributeIter>,
    g-menu-remove,
    g-menu-prepend-submenu,
    g-menu-prepend-section,
    g-menu-prepend-item,
    g-menu-prepend,
    g-menu-insert-submenu,
    g-menu-insert-section,
    g-menu-insert-item,
    g-menu-insert,
    g-menu-freeze,
    g-menu-append-submenu,
    g-menu-append-section,
    g-menu-append-item,
    g-menu-append,
    g-menu-new,
    <GMenu*>,
    <GMenu>,
    <GMemoryOutputStreamPrivate>,
    g-memory-output-stream-class-_g-reserved5,
    g-memory-output-stream-class-_g-reserved4,
    g-memory-output-stream-class-_g-reserved3,
    g-memory-output-stream-class-_g-reserved2,
    g-memory-output-stream-class-_g-reserved1,
    g-memory-output-stream-class-parent-class,
    <GMemoryOutputStreamClass>,
    g-memory-output-stream-steal-data,
    g-memory-output-stream-get-size,
    g-memory-output-stream-get-data-size,
    g-memory-output-stream-get-data,
    <GMemoryOutputStream*>,
    g-memory-output-stream-priv,
    g-memory-output-stream-parent-instance,
    <GMemoryOutputStream>,
    <GMemoryInputStreamPrivate>,
    g-memory-input-stream-class-_g-reserved5,
    g-memory-input-stream-class-_g-reserved4,
    g-memory-input-stream-class-_g-reserved3,
    g-memory-input-stream-class-_g-reserved2,
    g-memory-input-stream-class-_g-reserved1,
    g-memory-input-stream-class-parent-class,
    <GMemoryInputStreamClass>,
    g-memory-input-stream-add-data,
    g-memory-input-stream-new-from-data,
    g-memory-input-stream-new,
    <GMemoryInputStream*>,
    g-memory-input-stream-priv,
    g-memory-input-stream-parent-instance,
    <GMemoryInputStream>,
    $menu-link-submenu,
    $menu-link-section,
    $menu-attribute-target,
    $menu-attribute-label,
    $menu-attribute-action,
    g-loadable-icon-iface-load-finish,
    g-loadable-icon-iface-load-async,
    g-loadable-icon-iface-load,
    g-loadable-icon-iface-g-iface,
    <GLoadableIconIface>,
    g-loadable-icon-load-finish,
    g-loadable-icon-load-async,
    g-loadable-icon-load,
    <GLoadableIcon*>,
    <GLoadableIcon>,
    g-input-vector-size-setter,
    g-input-vector-size,
    g-input-vector-buffer-setter,
    g-input-vector-buffer,
    <GInputVector>,
    <GInputStreamPrivate>,
    g-input-stream-class-_g-reserved5,
    g-input-stream-class-_g-reserved4,
    g-input-stream-class-_g-reserved3,
    g-input-stream-class-_g-reserved2,
    g-input-stream-class-_g-reserved1,
    g-input-stream-class-close-finish,
    g-input-stream-class-close-async,
    g-input-stream-class-skip-finish,
    g-input-stream-class-skip-async,
    g-input-stream-class-read-finish,
    g-input-stream-class-read-async,
    g-input-stream-class-close-fn,
    g-input-stream-class-skip,
    g-input-stream-class-read-fn,
    g-input-stream-class-parent-class,
    <GInputStreamClass>,
    g-input-stream-skip-finish,
    g-input-stream-skip-async,
    g-input-stream-skip,
    g-input-stream-set-pending,
    g-input-stream-read-finish,
    g-input-stream-read-async,
    g-input-stream-read-all,
    g-input-stream-read,
    g-input-stream-is-closed,
    g-input-stream-has-pending,
    g-input-stream-close-finish,
    g-input-stream-close-async,
    g-input-stream-close,
    g-input-stream-clear-pending,
    <GInputStream*>,
    g-input-stream-priv,
    g-input-stream-parent-instance,
    <GInputStream>,
    g-initable-iface-init,
    g-initable-iface-g-iface,
    <GInitableIface>,
    g-initable-init,
    g-initable-newv,
    <GInitable*>,
    <GInitable>,
    <GInetSocketAddressPrivate>,
    g-inet-socket-address-class-parent-class,
    <GInetSocketAddressClass>,
    g-inet-socket-address-get-scope-id,
    g-inet-socket-address-get-port,
    g-inet-socket-address-get-flowinfo,
    g-inet-socket-address-get-address,
    g-inet-socket-address-new,
    <GInetSocketAddress*>,
    g-inet-socket-address-priv,
    g-inet-socket-address-parent-instance,
    <GInetSocketAddress>,
    <GInetAddressPrivate>,
    <GInetAddressMaskPrivate>,
    g-inet-address-mask-class-parent-class,
    <GInetAddressMaskClass>,
    g-inet-address-mask-to-string,
    g-inet-address-mask-matches,
    g-inet-address-mask-get-length,
    g-inet-address-mask-get-family,
    g-inet-address-mask-get-address,
    g-inet-address-mask-equal,
    g-inet-address-mask-new-from-string,
    g-inet-address-mask-new,
    <GInetAddressMask*>,
    g-inet-address-mask-priv,
    g-inet-address-mask-parent-instance,
    <GInetAddressMask>,
    g-inet-address-class-to-bytes,
    g-inet-address-class-to-string,
    g-inet-address-class-parent-class,
    <GInetAddressClass>,
    g-inet-address-to-string,
    g-inet-address-get-native-size,
    g-inet-address-get-is-site-local,
    g-inet-address-get-is-multicast,
    g-inet-address-get-is-mc-site-local,
    g-inet-address-get-is-mc-org-local,
    g-inet-address-get-is-mc-node-local,
    g-inet-address-get-is-mc-link-local,
    g-inet-address-get-is-mc-global,
    g-inet-address-get-is-loopback,
    g-inet-address-get-is-link-local,
    g-inet-address-get-is-any,
    g-inet-address-get-family,
    g-inet-address-equal,
    g-inet-address-new-loopback,
    g-inet-address-new-from-string,
    g-inet-address-new-from-bytes,
    g-inet-address-new-any,
    <GInetAddress*>,
    g-inet-address-priv,
    g-inet-address-parent-instance,
    <GInetAddress>,
    g-icon-iface-from-tokens,
    g-icon-iface-to-tokens,
    g-icon-iface-equal,
    g-icon-iface-hash,
    g-icon-iface-g-iface,
    <GIconIface>,
    g-icon-to-string,
    g-icon-equal,
    g-icon-new-for-string,
    g-icon-hash,
    <GIcon*>,
    <GIcon>,
    <GIOStreamSpliceFlags*>,
    <GIOStreamSpliceFlags>,
    $g-io-stream-splice-wait-for-both,
    $g-io-stream-splice-close-stream2,
    $g-io-stream-splice-close-stream1,
    $g-io-stream-splice-none,
    <GIOStreamPrivate>,
    g-io-stream-class-_g-reserved10,
    g-io-stream-class-_g-reserved9,
    g-io-stream-class-_g-reserved8,
    g-io-stream-class-_g-reserved7,
    g-io-stream-class-_g-reserved6,
    g-io-stream-class-_g-reserved5,
    g-io-stream-class-_g-reserved4,
    g-io-stream-class-_g-reserved3,
    g-io-stream-class-_g-reserved2,
    g-io-stream-class-_g-reserved1,
    g-io-stream-class-close-finish,
    g-io-stream-class-close-async,
    g-io-stream-class-close-fn,
    g-io-stream-class-get-output-stream,
    g-io-stream-class-get-input-stream,
    g-io-stream-class-parent-class,
    <GIOStreamClass>,
    <GIOStreamAdapter>,
    g-io-stream-splice-async,
    g-io-stream-set-pending,
    g-io-stream-is-closed,
    g-io-stream-has-pending,
    g-io-stream-get-output-stream,
    g-io-stream-get-input-stream,
    g-io-stream-close-finish,
    g-io-stream-close-async,
    g-io-stream-close,
    g-io-stream-clear-pending,
    g-io-stream-splice-finish,
    <GIOStream*>,
    g-io-stream-priv,
    g-io-stream-parent-instance,
    <GIOStream>,
    g-io-scheduler-job-send-to-mainloop-async,
    g-io-scheduler-job-send-to-mainloop,
    <GIOSchedulerJob>,
    <GIOModuleScopeFlags*>,
    <GIOModuleScopeFlags>,
    $g-io-module-scope-block-duplicates,
    $g-io-module-scope-none,
    g-io-module-scope-free,
    g-io-module-scope-block,
    <GIOModuleScope>,
    <GIOModuleClass>,
    g-io-module-new,
    <GIOModule*>,
    <GIOModule>,
    g-io-extension-point-register,
    g-io-extension-point-lookup,
    g-io-extension-point-implement,
    g-io-extension-point-set-required-type,
    g-io-extension-point-get-required-type,
    g-io-extension-point-get-extensions,
    g-io-extension-point-get-extension-by-name,
    <GIOExtensionPoint>,
    g-io-extension-get-type,
    g-io-extension-get-priority,
    g-io-extension-get-name,
    <GIOExtension>,
    <GIOErrorEnum*>,
    <GIOErrorEnum>,
    $g-io-error-proxy-not-allowed,
    $g-io-error-proxy-need-auth,
    $g-io-error-proxy-auth-failed,
    $g-io-error-proxy-failed,
    $g-io-error-connection-refused,
    $g-io-error-network-unreachable,
    $g-io-error-host-unreachable,
    $g-io-error-dbus-error,
    $g-io-error-invalid-data,
    $g-io-error-partial-input,
    $g-io-error-address-in-use,
    $g-io-error-not-initialized,
    $g-io-error-too-many-open-files,
    $g-io-error-failed-handled,
    $g-io-error-would-merge,
    $g-io-error-host-not-found,
    $g-io-error-would-block,
    $g-io-error-busy,
    $g-io-error-would-recurse,
    $g-io-error-timed-out,
    $g-io-error-wrong-etag,
    $g-io-error-cant-create-backup,
    $g-io-error-read-only,
    $g-io-error-pending,
    $g-io-error-cancelled,
    $g-io-error-closed,
    $g-io-error-already-mounted,
    $g-io-error-not-mounted,
    $g-io-error-not-supported,
    $g-io-error-permission-denied,
    $g-io-error-invalid-argument,
    $g-io-error-no-space,
    $g-io-error-too-many-links,
    $g-io-error-invalid-filename,
    $g-io-error-filename-too-long,
    $g-io-error-not-mountable-file,
    $g-io-error-not-symbolic-link,
    $g-io-error-not-regular-file,
    $g-io-error-not-empty,
    $g-io-error-not-directory,
    $g-io-error-is-directory,
    $g-io-error-exists,
    $g-io-error-not-found,
    $g-io-error-failed,
    g-filter-output-stream-class-_g-reserved3,
    g-filter-output-stream-class-_g-reserved2,
    g-filter-output-stream-class-_g-reserved1,
    g-filter-output-stream-class-parent-class,
    <GFilterOutputStreamClass>,
    g-filter-output-stream-set-close-base-stream,
    g-filter-output-stream-get-close-base-stream,
    g-filter-output-stream-get-base-stream,
    <GFilterOutputStream*>,
    g-filter-output-stream-base-stream,
    g-filter-output-stream-parent-instance,
    <GFilterOutputStream>,
    g-filter-input-stream-class-_g-reserved3,
    g-filter-input-stream-class-_g-reserved2,
    g-filter-input-stream-class-_g-reserved1,
    g-filter-input-stream-class-parent-class,
    <GFilterInputStreamClass>,
    g-filter-input-stream-set-close-base-stream,
    g-filter-input-stream-get-close-base-stream,
    g-filter-input-stream-get-base-stream,
    <GFilterInputStream*>,
    g-filter-input-stream-base-stream,
    g-filter-input-stream-parent-instance,
    <GFilterInputStream>,
    <GFilesystemPreviewType*>,
    <GFilesystemPreviewType>,
    $g-filesystem-preview-type-never,
    $g-filesystem-preview-type-if-local,
    $g-filesystem-preview-type-if-always,
    g-filename-completer-class-_g-reserved3,
    g-filename-completer-class-_g-reserved2,
    g-filename-completer-class-_g-reserved1,
    g-filename-completer-class-got-completion-data,
    g-filename-completer-class-parent-class,
    <GFilenameCompleterClass>,
    g-filename-completer-set-dirs-only,
    g-filename-completer-get-completions,
    g-filename-completer-get-completion-suffix,
    g-filename-completer-new,
    <GFilenameCompleter*>,
    <GFilenameCompleter>,
    <GFileType*>,
    <GFileType>,
    $g-file-type-mountable,
    $g-file-type-shortcut,
    $g-file-type-special,
    $g-file-type-symbolic-link,
    $g-file-type-directory,
    $g-file-type-regular,
    $g-file-type-unknown,
    <GFileQueryInfoFlags*>,
    <GFileQueryInfoFlags>,
    $g-file-query-info-nofollow-symlinks,
    $g-file-query-info-none,
    <GFileOutputStreamPrivate>,
    g-file-output-stream-class-_g-reserved5,
    g-file-output-stream-class-_g-reserved4,
    g-file-output-stream-class-_g-reserved3,
    g-file-output-stream-class-_g-reserved2,
    g-file-output-stream-class-_g-reserved1,
    g-file-output-stream-class-get-etag,
    g-file-output-stream-class-query-info-finish,
    g-file-output-stream-class-query-info-async,
    g-file-output-stream-class-query-info,
    g-file-output-stream-class-truncate-fn,
    g-file-output-stream-class-can-truncate,
    g-file-output-stream-class-seek,
    g-file-output-stream-class-can-seek,
    g-file-output-stream-class-tell,
    g-file-output-stream-class-parent-class,
    <GFileOutputStreamClass>,
    g-file-output-stream-query-info-finish,
    g-file-output-stream-query-info-async,
    g-file-output-stream-query-info,
    g-file-output-stream-get-etag,
    <GFileOutputStream*>,
    g-file-output-stream-priv,
    g-file-output-stream-parent-instance,
    <GFileOutputStream>,
    <GFileMonitorPrivate>,
    <GFileMonitorFlags*>,
    <GFileMonitorFlags>,
    $g-file-monitor-send-moved,
    $g-file-monitor-watch-mounts,
    $g-file-monitor-none,
    <GFileMonitorEvent*>,
    <GFileMonitorEvent>,
    $g-file-monitor-event-moved,
    $g-file-monitor-event-unmounted,
    $g-file-monitor-event-pre-unmount,
    $g-file-monitor-event-attribute-changed,
    $g-file-monitor-event-created,
    $g-file-monitor-event-deleted,
    $g-file-monitor-event-changes-done-hint,
    $g-file-monitor-event-changed,
    g-file-monitor-class-_g-reserved5,
    g-file-monitor-class-_g-reserved4,
    g-file-monitor-class-_g-reserved3,
    g-file-monitor-class-_g-reserved2,
    g-file-monitor-class-_g-reserved1,
    g-file-monitor-class-cancel,
    g-file-monitor-class-changed,
    g-file-monitor-class-parent-class,
    <GFileMonitorClass>,
    g-file-monitor-set-rate-limit,
    g-file-monitor-is-cancelled,
    g-file-monitor-emit-event,
    g-file-monitor-cancel,
    <GFileMonitor*>,
    g-file-monitor-priv,
    g-file-monitor-parent-instance,
    <GFileMonitor>,
    <GFileInputStreamPrivate>,
    g-file-input-stream-class-_g-reserved5,
    g-file-input-stream-class-_g-reserved4,
    g-file-input-stream-class-_g-reserved3,
    g-file-input-stream-class-_g-reserved2,
    g-file-input-stream-class-_g-reserved1,
    g-file-input-stream-class-query-info-finish,
    g-file-input-stream-class-query-info-async,
    g-file-input-stream-class-query-info,
    g-file-input-stream-class-seek,
    g-file-input-stream-class-can-seek,
    g-file-input-stream-class-tell,
    g-file-input-stream-class-parent-class,
    <GFileInputStreamClass>,
    g-file-input-stream-query-info-finish,
    g-file-input-stream-query-info-async,
    g-file-input-stream-query-info,
    <GFileInputStream*>,
    g-file-input-stream-priv,
    g-file-input-stream-parent-instance,
    <GFileInputStream>,
    <GFileInfoClass>,
    g-file-info-unset-attribute-mask,
    g-file-info-set-symlink-target,
    g-file-info-set-sort-order,
    g-file-info-set-size,
    g-file-info-set-name,
    g-file-info-set-modification-time,
    g-file-info-set-is-symlink,
    g-file-info-set-is-hidden,
    g-file-info-set-icon,
    g-file-info-set-file-type,
    g-file-info-set-edit-name,
    g-file-info-set-display-name,
    g-file-info-set-content-type,
    g-file-info-set-attribute-uint64,
    g-file-info-set-attribute-uint32,
    g-file-info-set-attribute-stringv,
    g-file-info-set-attribute-string,
    g-file-info-set-attribute-status,
    g-file-info-set-attribute-object,
    g-file-info-set-attribute-mask,
    g-file-info-set-attribute-int64,
    g-file-info-set-attribute-int32,
    g-file-info-set-attribute-byte-string,
    g-file-info-set-attribute-boolean,
    g-file-info-set-attribute,
    g-file-info-remove-attribute,
    g-file-info-list-attributes,
    g-file-info-has-namespace,
    g-file-info-has-attribute,
    g-file-info-get-symlink-target,
    g-file-info-get-sort-order,
    g-file-info-get-size,
    g-file-info-get-name,
    g-file-info-get-modification-time,
    g-file-info-get-is-symlink,
    g-file-info-get-is-hidden,
    g-file-info-get-is-backup,
    g-file-info-get-icon,
    g-file-info-get-file-type,
    g-file-info-get-etag,
    g-file-info-get-edit-name,
    g-file-info-get-display-name,
    g-file-info-get-content-type,
    g-file-info-get-attribute-uint64,
    g-file-info-get-attribute-uint32,
    g-file-info-get-attribute-type,
    g-file-info-get-attribute-stringv,
    g-file-info-get-attribute-string,
    g-file-info-get-attribute-status,
    g-file-info-get-attribute-object,
    g-file-info-get-attribute-int64,
    g-file-info-get-attribute-int32,
    g-file-info-get-attribute-data,
    g-file-info-get-attribute-byte-string,
    g-file-info-get-attribute-boolean,
    g-file-info-get-attribute-as-string,
    g-file-info-dup,
    g-file-info-copy-into,
    g-file-info-clear-status,
    g-file-info-new,
    <GFileInfo*>,
    <GFileInfo>,
    g-file-iface-poll-mountable-finish,
    g-file-iface-poll-mountable,
    g-file-iface-eject-mountable-with-operation-finish,
    g-file-iface-eject-mountable-with-operation,
    g-file-iface-unmount-mountable-with-operation-finish,
    g-file-iface-unmount-mountable-with-operation,
    g-file-iface-supports-thread-contexts,
    g-file-iface-stop-mountable-finish,
    g-file-iface-stop-mountable,
    g-file-iface-start-mountable-finish,
    g-file-iface-start-mountable,
    g-file-iface-replace-readwrite-finish,
    g-file-iface-replace-readwrite-async,
    g-file-iface-replace-readwrite,
    g-file-iface-create-readwrite-finish,
    g-file-iface-create-readwrite-async,
    g-file-iface-create-readwrite,
    g-file-iface-open-readwrite-finish,
    g-file-iface-open-readwrite-async,
    g-file-iface-open-readwrite,
    g-file-iface-monitor-file,
    g-file-iface-monitor-dir,
    g-file-iface-mount-enclosing-volume-finish,
    g-file-iface-mount-enclosing-volume,
    g-file-iface-eject-mountable-finish,
    g-file-iface-eject-mountable,
    g-file-iface-unmount-mountable-finish,
    g-file-iface-unmount-mountable,
    g-file-iface-mount-mountable-finish,
    g-file-iface-mount-mountable,
    g-file-iface-_move-finish,
    g-file-iface-_move-async,
    g-file-iface-move,
    g-file-iface-copy-finish,
    g-file-iface-copy-async,
    g-file-iface-copy,
    g-file-iface-_make-symbolic-link-finish,
    g-file-iface-_make-symbolic-link-async,
    g-file-iface-make-symbolic-link,
    g-file-iface-_make-directory-finish,
    g-file-iface-_make-directory-async,
    g-file-iface-make-directory,
    g-file-iface-_trash-finish,
    g-file-iface-_trash-async,
    g-file-iface-trash,
    g-file-iface-_delete-file-finish,
    g-file-iface-_delete-file-async,
    g-file-iface-delete-file,
    g-file-iface-replace-finish,
    g-file-iface-replace-async,
    g-file-iface-replace,
    g-file-iface-create-finish,
    g-file-iface-create-async,
    g-file-iface-create,
    g-file-iface-append-to-finish,
    g-file-iface-append-to-async,
    g-file-iface-append-to,
    g-file-iface-read-finish,
    g-file-iface-read-async,
    g-file-iface-read-fn,
    g-file-iface-set-attributes-finish,
    g-file-iface-set-attributes-async,
    g-file-iface-set-attributes-from-info,
    g-file-iface-set-attribute,
    g-file-iface-_query-writable-namespaces-finish,
    g-file-iface-_query-writable-namespaces-async,
    g-file-iface-query-writable-namespaces,
    g-file-iface-_query-settable-attributes-finish,
    g-file-iface-_query-settable-attributes-async,
    g-file-iface-query-settable-attributes,
    g-file-iface-set-display-name-finish,
    g-file-iface-set-display-name-async,
    g-file-iface-set-display-name,
    g-file-iface-find-enclosing-mount-finish,
    g-file-iface-find-enclosing-mount-async,
    g-file-iface-find-enclosing-mount,
    g-file-iface-query-filesystem-info-finish,
    g-file-iface-query-filesystem-info-async,
    g-file-iface-query-filesystem-info,
    g-file-iface-query-info-finish,
    g-file-iface-query-info-async,
    g-file-iface-query-info,
    g-file-iface-enumerate-children-finish,
    g-file-iface-enumerate-children-async,
    g-file-iface-enumerate-children,
    g-file-iface-get-child-for-display-name,
    g-file-iface-resolve-relative-path,
    g-file-iface-get-relative-path,
    g-file-iface-prefix-matches,
    g-file-iface-get-parent,
    g-file-iface-get-parse-name,
    g-file-iface-get-uri,
    g-file-iface-get-path,
    g-file-iface-get-basename,
    g-file-iface-get-uri-scheme,
    g-file-iface-has-uri-scheme,
    g-file-iface-is-native,
    g-file-iface-equal,
    g-file-iface-hash,
    g-file-iface-dup,
    g-file-iface-g-iface,
    <GFileIface>,
    <GFileIconClass>,
    g-file-icon-get-file,
    g-file-icon-new,
    <GFileIcon*>,
    <GFileIcon>,
    <GFileIOStreamPrivate>,
    g-file-io-stream-class-_g-reserved5,
    g-file-io-stream-class-_g-reserved4,
    g-file-io-stream-class-_g-reserved3,
    g-file-io-stream-class-_g-reserved2,
    g-file-io-stream-class-_g-reserved1,
    g-file-io-stream-class-get-etag,
    g-file-io-stream-class-query-info-finish,
    g-file-io-stream-class-query-info-async,
    g-file-io-stream-class-query-info,
    g-file-io-stream-class-truncate-fn,
    g-file-io-stream-class-can-truncate,
    g-file-io-stream-class-seek,
    g-file-io-stream-class-can-seek,
    g-file-io-stream-class-tell,
    g-file-io-stream-class-parent-class,
    <GFileIOStreamClass>,
    g-file-io-stream-query-info-finish,
    g-file-io-stream-query-info-async,
    g-file-io-stream-query-info,
    g-file-io-stream-get-etag,
    <GFileIOStream*>,
    g-file-io-stream-priv,
    g-file-io-stream-parent-instance,
    <GFileIOStream>,
    <GFileEnumeratorPrivate>,
    g-file-enumerator-class-_g-reserved7,
    g-file-enumerator-class-_g-reserved6,
    g-file-enumerator-class-_g-reserved5,
    g-file-enumerator-class-_g-reserved4,
    g-file-enumerator-class-_g-reserved3,
    g-file-enumerator-class-_g-reserved2,
    g-file-enumerator-class-_g-reserved1,
    g-file-enumerator-class-close-finish,
    g-file-enumerator-class-close-async,
    g-file-enumerator-class-next-files-finish,
    g-file-enumerator-class-next-files-async,
    g-file-enumerator-class-close-fn,
    g-file-enumerator-class-next-file,
    g-file-enumerator-class-parent-class,
    <GFileEnumeratorClass>,
    g-file-enumerator-set-pending,
    g-file-enumerator-next-files-finish,
    g-file-enumerator-next-files-async,
    g-file-enumerator-next-file,
    g-file-enumerator-is-closed,
    g-file-enumerator-has-pending,
    g-file-enumerator-get-container,
    g-file-enumerator-close-finish,
    g-file-enumerator-close-async,
    g-file-enumerator-close,
    <GFileEnumerator*>,
    g-file-enumerator-priv,
    g-file-enumerator-parent-instance,
    <GFileEnumerator>,
    g-file-descriptor-based-iface-get-fd,
    g-file-descriptor-based-iface-g-iface,
    <GFileDescriptorBasedIface>,
    g-file-descriptor-based-get-fd,
    <GFileDescriptorBased*>,
    <GFileDescriptorBased>,
    <GFileCreateFlags*>,
    <GFileCreateFlags>,
    $g-file-create-replace-destination,
    $g-file-create-private,
    $g-file-create-none,
    <GFileCopyFlags*>,
    <GFileCopyFlags>,
    $g-file-copy-target-default-perms,
    $g-file-copy-no-fallback-for-move,
    $g-file-copy-all-metadata,
    $g-file-copy-nofollow-symlinks,
    $g-file-copy-backup,
    $g-file-copy-overwrite,
    $g-file-copy-none,
    <GFileAttributeType*>,
    <GFileAttributeType>,
    $g-file-attribute-type-stringv,
    $g-file-attribute-type-object,
    $g-file-attribute-type-int64,
    $g-file-attribute-type-uint64,
    $g-file-attribute-type-int32,
    $g-file-attribute-type-uint32,
    $g-file-attribute-type-boolean,
    $g-file-attribute-type-byte-string,
    $g-file-attribute-type-string,
    $g-file-attribute-type-invalid,
    <GFileAttributeStatus*>,
    <GFileAttributeStatus>,
    $g-file-attribute-status-error-setting,
    $g-file-attribute-status-set,
    $g-file-attribute-status-unset,
    g-file-attribute-matcher-unref,
    g-file-attribute-matcher-to-string,
    g-file-attribute-matcher-subtract,
    g-file-attribute-matcher-ref,
    g-file-attribute-matcher-matches-only,
    g-file-attribute-matcher-matches,
    g-file-attribute-matcher-enumerate-next,
    g-file-attribute-matcher-enumerate-namespace,
    g-file-attribute-matcher-new,
    <GFileAttributeMatcher>,
    g-file-attribute-info-list-unref,
    g-file-attribute-info-list-ref,
    g-file-attribute-info-list-lookup,
    g-file-attribute-info-list-dup,
    g-file-attribute-info-list-add,
    g-file-attribute-info-list-new,
    g-file-attribute-info-list-n-infos-setter,
    g-file-attribute-info-list-n-infos,
    g-file-attribute-info-list-infos-setter,
    g-file-attribute-info-list-infos,
    <GFileAttributeInfoList>,
    <GFileAttributeInfoFlags*>,
    <GFileAttributeInfoFlags>,
    $g-file-attribute-info-copy-when-moved,
    $g-file-attribute-info-copy-with-file,
    $g-file-attribute-info-none,
    g-file-attribute-info-flags-setter,
    g-file-attribute-info-flags,
    g-file-attribute-info-type-setter,
    g-file-attribute-info-type,
    g-file-attribute-info-name-setter,
    g-file-attribute-info-name,
    <GFileAttributeInfo>,
    g-file-unmount-mountable-with-operation-finish,
    g-file-unmount-mountable-with-operation,
    g-file-unmount-mountable-finish,
    g-file-unmount-mountable,
    g-file-trash,
    g-file-supports-thread-contexts,
    g-file-stop-mountable-finish,
    g-file-stop-mountable,
    g-file-start-mountable-finish,
    g-file-start-mountable,
    g-file-set-display-name-finish,
    g-file-set-display-name-async,
    g-file-set-display-name,
    g-file-set-attributes-from-info,
    g-file-set-attributes-finish,
    g-file-set-attributes-async,
    g-file-set-attribute-uint64,
    g-file-set-attribute-uint32,
    g-file-set-attribute-string,
    g-file-set-attribute-int64,
    g-file-set-attribute-int32,
    g-file-set-attribute-byte-string,
    g-file-set-attribute,
    g-file-resolve-relative-path,
    g-file-replace-readwrite-finish,
    g-file-replace-readwrite-async,
    g-file-replace-readwrite,
    g-file-replace-finish,
    g-file-replace-contents-finish,
    g-file-replace-contents-async,
    g-file-replace-contents,
    g-file-replace-async,
    g-file-replace,
    g-file-read-finish,
    g-file-read-async,
    g-file-read,
    g-file-query-writable-namespaces,
    g-file-query-settable-attributes,
    g-file-query-info-finish,
    g-file-query-info-async,
    g-file-query-info,
    g-file-query-filesystem-info-finish,
    g-file-query-filesystem-info-async,
    g-file-query-filesystem-info,
    g-file-query-file-type,
    g-file-query-exists,
    g-file-query-default-handler,
    g-file-poll-mountable-finish,
    g-file-poll-mountable,
    g-file-open-readwrite-finish,
    g-file-open-readwrite-async,
    g-file-open-readwrite,
    g-file-move,
    g-file-mount-mountable-finish,
    g-file-mount-mountable,
    g-file-mount-enclosing-volume-finish,
    g-file-mount-enclosing-volume,
    g-file-monitor-file,
    g-file-monitor-directory,
    g-file-monitor,
    g-file-make-symbolic-link,
    g-file-make-directory-with-parents,
    g-file-make-directory,
    g-file-load-partial-contents-finish,
    g-file-load-contents-finish,
    g-file-load-contents-async,
    g-file-load-contents,
    g-file-is-native,
    g-file-hash,
    g-file-has-uri-scheme,
    g-file-has-prefix,
    g-file-has-parent,
    g-file-get-uri-scheme,
    g-file-get-uri,
    g-file-get-relative-path,
    g-file-get-path,
    g-file-get-parse-name,
    g-file-get-parent,
    g-file-get-child-for-display-name,
    g-file-get-child,
    g-file-get-basename,
    g-file-find-enclosing-mount-finish,
    g-file-find-enclosing-mount-async,
    g-file-find-enclosing-mount,
    g-file-equal,
    g-file-enumerate-children-finish,
    g-file-enumerate-children-async,
    g-file-enumerate-children,
    g-file-eject-mountable-with-operation-finish,
    g-file-eject-mountable-with-operation,
    g-file-eject-mountable-finish,
    g-file-eject-mountable,
    g-file-dup,
    g-file-delete,
    g-file-create-readwrite-finish,
    g-file-create-readwrite-async,
    g-file-create-readwrite,
    g-file-create-finish,
    g-file-create-async,
    g-file-create,
    g-file-copy-finish,
    g-file-copy-attributes,
    g-file-copy,
    g-file-append-to-finish,
    g-file-append-to-async,
    g-file-append-to,
    g-file-parse-name,
    g-file-new-tmp,
    g-file-new-for-uri,
    g-file-new-for-path,
    g-file-new-for-commandline-arg,
    <GFile*>,
    <GFile>,
    $file-attribute-unix-uid,
    $file-attribute-unix-rdev,
    $file-attribute-unix-nlink,
    $file-attribute-unix-mode,
    $file-attribute-unix-is-mountpoint,
    $file-attribute-unix-inode,
    $file-attribute-unix-gid,
    $file-attribute-unix-device,
    $file-attribute-unix-block-size,
    $file-attribute-unix-blocks,
    $file-attribute-trash-orig-path,
    $file-attribute-trash-item-count,
    $file-attribute-trash-deletion-date,
    $file-attribute-time-modified-usec,
    $file-attribute-time-modified,
    $file-attribute-time-created-usec,
    $file-attribute-time-created,
    $file-attribute-time-changed-usec,
    $file-attribute-time-changed,
    $file-attribute-time-access-usec,
    $file-attribute-time-access,
    $file-attribute-thumbnail-path,
    $file-attribute-thumbnailing-failed,
    $file-attribute-standard-type,
    $file-attribute-standard-target-uri,
    $file-attribute-standard-symlink-target,
    $file-attribute-standard-sort-order,
    $file-attribute-standard-size,
    $file-attribute-standard-name,
    $file-attribute-standard-is-virtual,
    $file-attribute-standard-is-symlink,
    $file-attribute-standard-is-hidden,
    $file-attribute-standard-is-backup,
    $file-attribute-standard-icon,
    $file-attribute-standard-fast-content-type,
    $file-attribute-standard-edit-name,
    $file-attribute-standard-display-name,
    $file-attribute-standard-description,
    $file-attribute-standard-copy-name,
    $file-attribute-standard-content-type,
    $file-attribute-standard-allocated-size,
    $file-attribute-selinux-context,
    $file-attribute-preview-icon,
    $file-attribute-owner-user-real,
    $file-attribute-owner-user,
    $file-attribute-owner-group,
    $file-attribute-mountable-unix-device-file,
    $file-attribute-mountable-unix-device,
    $file-attribute-mountable-start-stop-type,
    $file-attribute-mountable-is-media-check-automatic,
    $file-attribute-mountable-hal-udi,
    $file-attribute-mountable-can-unmount,
    $file-attribute-mountable-can-stop,
    $file-attribute-mountable-can-start-degraded,
    $file-attribute-mountable-can-start,
    $file-attribute-mountable-can-poll,
    $file-attribute-mountable-can-mount,
    $file-attribute-mountable-can-eject,
    $file-attribute-id-filesystem,
    $file-attribute-id-file,
    $file-attribute-gvfs-backend,
    $file-attribute-filesystem-use-preview,
    $file-attribute-filesystem-used,
    $file-attribute-filesystem-type,
    $file-attribute-filesystem-size,
    $file-attribute-filesystem-readonly,
    $file-attribute-filesystem-free,
    $file-attribute-etag-value,
    $file-attribute-dos-is-system,
    $file-attribute-dos-is-archive,
    $file-attribute-access-can-write,
    $file-attribute-access-can-trash,
    $file-attribute-access-can-rename,
    $file-attribute-access-can-read,
    $file-attribute-access-can-execute,
    $file-attribute-access-can-delete,
    <GEmblemedIconPrivate>,
    g-emblemed-icon-class-parent-class,
    <GEmblemedIconClass>,
    g-emblemed-icon-get-icon,
    g-emblemed-icon-get-emblems,
    g-emblemed-icon-clear-emblems,
    g-emblemed-icon-add-emblem,
    g-emblemed-icon-new,
    <GEmblemedIcon*>,
    g-emblemed-icon-priv,
    g-emblemed-icon-parent-instance,
    <GEmblemedIcon>,
    <GEmblemOrigin*>,
    <GEmblemOrigin>,
    $g-emblem-origin-tag,
    $g-emblem-origin-livemetadata,
    $g-emblem-origin-device,
    $g-emblem-origin-unknown,
    <GEmblemClass>,
    g-emblem-get-origin,
    g-emblem-get-icon,
    g-emblem-new-with-origin,
    g-emblem-new,
    <GEmblem*>,
    <GEmblem>,
    <GDriveStartStopType*>,
    <GDriveStartStopType>,
    $g-drive-start-stop-type-password,
    $g-drive-start-stop-type-multidisk,
    $g-drive-start-stop-type-network,
    $g-drive-start-stop-type-shutdown,
    $g-drive-start-stop-type-unknown,
    <GDriveStartFlags*>,
    <GDriveStartFlags>,
    $g-drive-start-none,
    g-drive-iface-get-sort-key,
    g-drive-iface-eject-with-operation-finish,
    g-drive-iface-eject-with-operation,
    g-drive-iface-stop-button,
    g-drive-iface-stop-finish,
    g-drive-iface-stop,
    g-drive-iface-can-stop,
    g-drive-iface-start-finish,
    g-drive-iface-start,
    g-drive-iface-can-start-degraded,
    g-drive-iface-can-start,
    g-drive-iface-get-start-stop-type,
    g-drive-iface-enumerate-identifiers,
    g-drive-iface-get-identifier,
    g-drive-iface-poll-for-media-finish,
    g-drive-iface-poll-for-media,
    g-drive-iface-eject-finish,
    g-drive-iface-eject,
    g-drive-iface-can-poll-for-media,
    g-drive-iface-can-eject,
    g-drive-iface-is-media-check-automatic,
    g-drive-iface-has-media,
    g-drive-iface-is-media-removable,
    g-drive-iface-get-volumes,
    g-drive-iface-has-volumes,
    g-drive-iface-get-icon,
    g-drive-iface-get-name,
    g-drive-iface-eject-button,
    g-drive-iface-disconnected,
    g-drive-iface-changed,
    g-drive-iface-g-iface,
    <GDriveIface>,
    g-drive-stop-finish,
    g-drive-stop,
    g-drive-start-finish,
    g-drive-start,
    g-drive-poll-for-media-finish,
    g-drive-poll-for-media,
    g-drive-is-media-removable,
    g-drive-is-media-check-automatic,
    g-drive-has-volumes,
    g-drive-has-media,
    g-drive-get-volumes,
    g-drive-get-start-stop-type,
    g-drive-get-sort-key,
    g-drive-get-name,
    g-drive-get-identifier,
    g-drive-get-icon,
    g-drive-enumerate-identifiers,
    g-drive-eject-with-operation-finish,
    g-drive-eject-with-operation,
    g-drive-eject-finish,
    g-drive-eject,
    g-drive-can-stop,
    g-drive-can-start-degraded,
    g-drive-can-start,
    g-drive-can-poll-for-media,
    g-drive-can-eject,
    <GDrive*>,
    <GDrive>,
    g-desktop-app-info-lookup-iface-get-default-for-uri-scheme,
    g-desktop-app-info-lookup-iface-g-iface,
    <GDesktopAppInfoLookupIface>,
    g-desktop-app-info-lookup-get-default-for-uri-scheme,
    <GDesktopAppInfoLookup*>,
    <GDesktopAppInfoLookup>,
    g-desktop-app-info-class-parent-class,
    <GDesktopAppInfoClass>,
    g-desktop-app-info-launch-uris-as-manager,
    g-desktop-app-info-get-show-in,
    g-desktop-app-info-get-nodisplay,
    g-desktop-app-info-get-keywords,
    g-desktop-app-info-get-is-hidden,
    g-desktop-app-info-get-generic-name,
    g-desktop-app-info-get-filename,
    g-desktop-app-info-get-categories,
    g-desktop-app-info-set-desktop-env,
    g-desktop-app-info-new-from-keyfile,
    g-desktop-app-info-new-from-filename,
    g-desktop-app-info-new,
    <GDesktopAppInfo*>,
    <GDesktopAppInfo>,
    <GDataStreamNewlineType*>,
    <GDataStreamNewlineType>,
    $g-data-stream-newline-type-any,
    $g-data-stream-newline-type-cr-lf,
    $g-data-stream-newline-type-cr,
    $g-data-stream-newline-type-lf,
    <GDataStreamByteOrder*>,
    <GDataStreamByteOrder>,
    $g-data-stream-byte-order-host-endian,
    $g-data-stream-byte-order-little-endian,
    $g-data-stream-byte-order-big-endian,
    <GDataOutputStreamPrivate>,
    g-data-output-stream-class-_g-reserved5,
    g-data-output-stream-class-_g-reserved4,
    g-data-output-stream-class-_g-reserved3,
    g-data-output-stream-class-_g-reserved2,
    g-data-output-stream-class-_g-reserved1,
    g-data-output-stream-class-parent-class,
    <GDataOutputStreamClass>,
    g-data-output-stream-set-byte-order,
    g-data-output-stream-put-uint64,
    g-data-output-stream-put-uint32,
    g-data-output-stream-put-uint16,
    g-data-output-stream-put-string,
    g-data-output-stream-put-int64,
    g-data-output-stream-put-int32,
    g-data-output-stream-put-int16,
    g-data-output-stream-put-byte,
    g-data-output-stream-get-byte-order,
    g-data-output-stream-new,
    <GDataOutputStream*>,
    g-data-output-stream-priv,
    g-data-output-stream-parent-instance,
    <GDataOutputStream>,
    <GDataInputStreamPrivate>,
    g-data-input-stream-class-_g-reserved5,
    g-data-input-stream-class-_g-reserved4,
    g-data-input-stream-class-_g-reserved3,
    g-data-input-stream-class-_g-reserved2,
    g-data-input-stream-class-_g-reserved1,
    g-data-input-stream-class-parent-class,
    <GDataInputStreamClass>,
    g-data-input-stream-set-newline-type,
    g-data-input-stream-set-byte-order,
    g-data-input-stream-read-upto-finish,
    g-data-input-stream-read-upto-async,
    g-data-input-stream-read-upto,
    g-data-input-stream-read-until-finish,
    g-data-input-stream-read-until-async,
    g-data-input-stream-read-until,
    g-data-input-stream-read-uint64,
    g-data-input-stream-read-uint32,
    g-data-input-stream-read-uint16,
    g-data-input-stream-read-line-utf8,
    g-data-input-stream-read-line-finish-utf8,
    g-data-input-stream-read-line-finish,
    g-data-input-stream-read-line-async,
    g-data-input-stream-read-line,
    g-data-input-stream-read-int64,
    g-data-input-stream-read-int32,
    g-data-input-stream-read-int16,
    g-data-input-stream-read-byte,
    g-data-input-stream-get-newline-type,
    g-data-input-stream-get-byte-order,
    g-data-input-stream-new,
    <GDataInputStream*>,
    g-data-input-stream-priv,
    g-data-input-stream-parent-instance,
    <GDataInputStream>,
    $desktop-app-info-lookup-extension-point-name,
    g-d-bus-subtree-v-table-padding,
    g-d-bus-subtree-v-table-dispatch-setter,
    g-d-bus-subtree-v-table-dispatch,
    g-d-bus-subtree-v-table-introspect-setter,
    g-d-bus-subtree-v-table-introspect,
    g-d-bus-subtree-v-table-enumerate-setter,
    g-d-bus-subtree-v-table-enumerate,
    <GDBusSubtreeVTable>,
    <GDBusSubtreeFlags*>,
    <GDBusSubtreeFlags>,
    $g-dbus-subtree-flags-dispatch-to-unenumerated-nodes,
    $g-dbus-subtree-flags-none,
    g-dbus-signal-info-unref,
    g-dbus-signal-info-ref,
    g-d-bus-signal-info-annotations-setter,
    g-d-bus-signal-info-annotations,
    g-d-bus-signal-info-args-setter,
    g-d-bus-signal-info-args,
    g-d-bus-signal-info-name-setter,
    g-d-bus-signal-info-name,
    g-d-bus-signal-info-ref-count-setter,
    g-d-bus-signal-info-ref-count,
    <GDBusSignalInfo>,
    <GDBusSignalFlags*>,
    <GDBusSignalFlags>,
    $g-dbus-signal-flags-no-match-rule,
    $g-dbus-signal-flags-none,
    <GDBusServerFlags*>,
    <GDBusServerFlags>,
    $g-dbus-server-flags-authentication-allow-anonymous,
    $g-dbus-server-flags-run-in-thread,
    $g-dbus-server-flags-none,
    g-dbus-server-stop,
    g-dbus-server-start,
    g-dbus-server-is-active,
    g-dbus-server-get-guid,
    g-dbus-server-get-flags,
    g-dbus-server-get-client-address,
    g-dbus-server-new-sync,
    <GDBusServer*>,
    <GDBusServer>,
    <GDBusSendMessageFlags*>,
    <GDBusSendMessageFlags>,
    $g-dbus-send-message-flags-preserve-serial,
    $g-dbus-send-message-flags-none,
    <GDBusProxyPrivate>,
    <GDBusProxyFlags*>,
    <GDBusProxyFlags>,
    $g-dbus-proxy-flags-get-invalidated-properties,
    $g-dbus-proxy-flags-do-not-auto-start,
    $g-dbus-proxy-flags-do-not-connect-signals,
    $g-dbus-proxy-flags-do-not-load-properties,
    $g-dbus-proxy-flags-none,
    g-d-bus-proxy-class-padding,
    g-d-bus-proxy-class-g-signal,
    g-d-bus-proxy-class-g-properties-changed,
    g-d-bus-proxy-class-parent-class,
    <GDBusProxyClass>,
    g-dbus-proxy-set-interface-info,
    g-dbus-proxy-set-default-timeout,
    g-dbus-proxy-set-cached-property,
    g-dbus-proxy-get-object-path,
    g-dbus-proxy-get-name-owner,
    g-dbus-proxy-get-name,
    g-dbus-proxy-get-interface-name,
    g-dbus-proxy-get-interface-info,
    g-dbus-proxy-get-flags,
    g-dbus-proxy-get-default-timeout,
    g-dbus-proxy-get-connection,
    g-dbus-proxy-get-cached-property-names,
    g-dbus-proxy-get-cached-property,
    g-dbus-proxy-call-with-unix-fd-list-sync,
    g-dbus-proxy-call-with-unix-fd-list-finish,
    g-dbus-proxy-call-with-unix-fd-list,
    g-dbus-proxy-call-sync,
    g-dbus-proxy-call-finish,
    g-dbus-proxy-call,
    g-dbus-proxy-new-for-bus,
    g-dbus-proxy-new,
    g-dbus-proxy-new-sync,
    g-dbus-proxy-new-for-bus-sync,
    g-dbus-proxy-new-for-bus-finish,
    g-dbus-proxy-new-finish,
    <GDBusProxy*>,
    g-d-bus-proxy-priv,
    g-d-bus-proxy-parent-instance,
    <GDBusProxy>,
    <GDBusPropertyInfoFlags*>,
    <GDBusPropertyInfoFlags>,
    $g-dbus-property-info-flags-writable,
    $g-dbus-property-info-flags-readable,
    $g-dbus-property-info-flags-none,
    g-dbus-property-info-unref,
    g-dbus-property-info-ref,
    g-d-bus-property-info-annotations-setter,
    g-d-bus-property-info-annotations,
    g-d-bus-property-info-flags-setter,
    g-d-bus-property-info-flags,
    g-d-bus-property-info-signature-setter,
    g-d-bus-property-info-signature,
    g-d-bus-property-info-name-setter,
    g-d-bus-property-info-name,
    g-d-bus-property-info-ref-count-setter,
    g-d-bus-property-info-ref-count,
    <GDBusPropertyInfo>,
    <GDBusObjectSkeletonPrivate>,
    g-d-bus-object-skeleton-class-padding,
    g-d-bus-object-skeleton-class-authorize-method,
    g-d-bus-object-skeleton-class-parent-class,
    <GDBusObjectSkeletonClass>,
    g-dbus-object-skeleton-set-object-path,
    g-dbus-object-skeleton-remove-interface-by-name,
    g-dbus-object-skeleton-remove-interface,
    g-dbus-object-skeleton-flush,
    g-dbus-object-skeleton-add-interface,
    g-dbus-object-skeleton-new,
    <GDBusObjectSkeleton*>,
    g-d-bus-object-skeleton-priv,
    g-d-bus-object-skeleton-parent-instance,
    <GDBusObjectSkeleton>,
    <GDBusObjectProxyPrivate>,
    g-d-bus-object-proxy-class-padding,
    g-d-bus-object-proxy-class-parent-class,
    <GDBusObjectProxyClass>,
    g-dbus-object-proxy-get-connection,
    g-dbus-object-proxy-new,
    <GDBusObjectProxy*>,
    g-d-bus-object-proxy-priv,
    g-d-bus-object-proxy-parent-instance,
    <GDBusObjectProxy>,
    <GDBusObjectManagerServerPrivate>,
    g-d-bus-object-manager-server-class-padding,
    g-d-bus-object-manager-server-class-parent-class,
    <GDBusObjectManagerServerClass>,
    g-dbus-object-manager-server-unexport,
    g-dbus-object-manager-server-set-connection,
    g-dbus-object-manager-server-get-connection,
    g-dbus-object-manager-server-export-uniquely,
    g-dbus-object-manager-server-export,
    g-dbus-object-manager-server-new,
    <GDBusObjectManagerServer*>,
    g-d-bus-object-manager-server-priv,
    g-d-bus-object-manager-server-parent-instance,
    <GDBusObjectManagerServer>,
    g-d-bus-object-manager-iface-interface-removed,
    g-d-bus-object-manager-iface-interface-added,
    g-d-bus-object-manager-iface-object-removed,
    g-d-bus-object-manager-iface-object-added,
    g-d-bus-object-manager-iface-get-interface,
    g-d-bus-object-manager-iface-get-object,
    g-d-bus-object-manager-iface-get-objects,
    g-d-bus-object-manager-iface-get-object-path,
    g-d-bus-object-manager-iface-parent-iface,
    <GDBusObjectManagerIface>,
    <GDBusObjectManagerClientPrivate>,
    <GDBusObjectManagerClientFlags*>,
    <GDBusObjectManagerClientFlags>,
    $g-dbus-object-manager-client-flags-do-not-auto-start,
    $g-dbus-object-manager-client-flags-none,
    g-d-bus-object-manager-client-class-padding,
    g-d-bus-object-manager-client-class-interface-proxy-properties-changed,
    g-d-bus-object-manager-client-class-interface-proxy-signal,
    g-d-bus-object-manager-client-class-parent-class,
    <GDBusObjectManagerClientClass>,
    g-dbus-object-manager-client-get-name-owner,
    g-dbus-object-manager-client-get-name,
    g-dbus-object-manager-client-get-flags,
    g-dbus-object-manager-client-get-connection,
    g-dbus-object-manager-client-new-for-bus,
    g-dbus-object-manager-client-new,
    g-dbus-object-manager-client-new-sync,
    g-dbus-object-manager-client-new-for-bus-sync,
    g-dbus-object-manager-client-new-for-bus-finish,
    g-dbus-object-manager-client-new-finish,
    <GDBusObjectManagerClient*>,
    g-d-bus-object-manager-client-priv,
    g-d-bus-object-manager-client-parent-instance,
    <GDBusObjectManagerClient>,
    g-dbus-object-manager-get-objects,
    g-dbus-object-manager-get-object-path,
    g-dbus-object-manager-get-object,
    g-dbus-object-manager-get-interface,
    <GDBusObjectManager*>,
    <GDBusObjectManager>,
    g-d-bus-object-iface-interface-removed,
    g-d-bus-object-iface-interface-added,
    g-d-bus-object-iface-get-interface,
    g-d-bus-object-iface-get-interfaces,
    g-d-bus-object-iface-get-object-path,
    g-d-bus-object-iface-parent-iface,
    <GDBusObjectIface>,
    g-dbus-object-get-object-path,
    g-dbus-object-get-interfaces,
    g-dbus-object-get-interface,
    <GDBusObject*>,
    <GDBusObject>,
    g-dbus-node-info-unref,
    g-dbus-node-info-ref,
    g-dbus-node-info-lookup-interface,
    g-dbus-node-info-generate-xml,
    g-dbus-node-info-new-for-xml,
    g-d-bus-node-info-annotations-setter,
    g-d-bus-node-info-annotations,
    g-d-bus-node-info-nodes-setter,
    g-d-bus-node-info-nodes,
    g-d-bus-node-info-interfaces-setter,
    g-d-bus-node-info-interfaces,
    g-d-bus-node-info-path-setter,
    g-d-bus-node-info-path,
    g-d-bus-node-info-ref-count-setter,
    g-d-bus-node-info-ref-count,
    <GDBusNodeInfo>,
    g-dbus-method-invocation-return-value-with-unix-fd-list,
    g-dbus-method-invocation-return-value,
    g-dbus-method-invocation-return-gerror,
    g-dbus-method-invocation-return-error-literal,
    g-dbus-method-invocation-return-dbus-error,
    g-dbus-method-invocation-get-sender,
    g-dbus-method-invocation-get-parameters,
    g-dbus-method-invocation-get-object-path,
    g-dbus-method-invocation-get-method-name,
    g-dbus-method-invocation-get-method-info,
    g-dbus-method-invocation-get-message,
    g-dbus-method-invocation-get-interface-name,
    g-dbus-method-invocation-get-connection,
    <GDBusMethodInvocation*>,
    <GDBusMethodInvocation>,
    g-dbus-method-info-unref,
    g-dbus-method-info-ref,
    g-d-bus-method-info-annotations-setter,
    g-d-bus-method-info-annotations,
    g-d-bus-method-info-out-args-setter,
    g-d-bus-method-info-out-args,
    g-d-bus-method-info-in-args-setter,
    g-d-bus-method-info-in-args,
    g-d-bus-method-info-name-setter,
    g-d-bus-method-info-name,
    g-d-bus-method-info-ref-count-setter,
    g-d-bus-method-info-ref-count,
    <GDBusMethodInfo>,
    <GDBusMessageType*>,
    <GDBusMessageType>,
    $g-dbus-message-type-signal,
    $g-dbus-message-type-error,
    $g-dbus-message-type-method-return,
    $g-dbus-message-type-method-call,
    $g-dbus-message-type-invalid,
    <GDBusMessageHeaderField*>,
    <GDBusMessageHeaderField>,
    $g-dbus-message-header-field-num-unix-fds,
    $g-dbus-message-header-field-signature,
    $g-dbus-message-header-field-sender,
    $g-dbus-message-header-field-destination,
    $g-dbus-message-header-field-reply-serial,
    $g-dbus-message-header-field-error-name,
    $g-dbus-message-header-field-member,
    $g-dbus-message-header-field-interface,
    $g-dbus-message-header-field-path,
    $g-dbus-message-header-field-invalid,
    <GDBusMessageFlags*>,
    <GDBusMessageFlags>,
    $g-dbus-message-flags-no-auto-start,
    $g-dbus-message-flags-no-reply-expected,
    $g-dbus-message-flags-none,
    <GDBusMessageByteOrder*>,
    <GDBusMessageByteOrder>,
    $g-dbus-message-byte-order-little-endian,
    $g-dbus-message-byte-order-big-endian,
    g-dbus-message-to-gerror,
    g-dbus-message-to-blob,
    g-dbus-message-set-unix-fd-list,
    g-dbus-message-set-signature,
    g-dbus-message-set-serial,
    g-dbus-message-set-sender,
    g-dbus-message-set-reply-serial,
    g-dbus-message-set-path,
    g-dbus-message-set-num-unix-fds,
    g-dbus-message-set-message-type,
    g-dbus-message-set-member,
    g-dbus-message-set-interface,
    g-dbus-message-set-header,
    g-dbus-message-set-flags,
    g-dbus-message-set-error-name,
    g-dbus-message-set-destination,
    g-dbus-message-set-byte-order,
    g-dbus-message-set-body,
    g-dbus-message-print,
    g-dbus-message-new-method-reply,
    g-dbus-message-new-method-error-literal,
    g-dbus-message-lock,
    g-dbus-message-get-unix-fd-list,
    g-dbus-message-get-signature,
    g-dbus-message-get-serial,
    g-dbus-message-get-sender,
    g-dbus-message-get-reply-serial,
    g-dbus-message-get-path,
    g-dbus-message-get-num-unix-fds,
    g-dbus-message-get-message-type,
    g-dbus-message-get-member,
    g-dbus-message-get-locked,
    g-dbus-message-get-interface,
    g-dbus-message-get-header-fields,
    g-dbus-message-get-header,
    g-dbus-message-get-flags,
    g-dbus-message-get-error-name,
    g-dbus-message-get-destination,
    g-dbus-message-get-byte-order,
    g-dbus-message-get-body,
    g-dbus-message-get-arg0,
    g-dbus-message-copy,
    g-dbus-message-bytes-needed,
    g-dbus-message-new-signal,
    g-dbus-message-new-method-call,
    g-dbus-message-new-from-blob,
    g-dbus-message-new,
    <GDBusMessage*>,
    <GDBusMessage>,
    g-dbus-menu-model-get,
    <GDBusMenuModel*>,
    <GDBusMenuModel>,
    g-d-bus-interface-v-table-padding,
    g-d-bus-interface-v-table-set-property-setter,
    g-d-bus-interface-v-table-set-property,
    g-d-bus-interface-v-table-get-property-setter,
    g-d-bus-interface-v-table-get-property,
    g-d-bus-interface-v-table-method-call-setter,
    g-d-bus-interface-v-table-method-call,
    <GDBusInterfaceVTable>,
    <GDBusInterfaceSkeletonPrivate>,
    <GDBusInterfaceSkeletonFlags*>,
    <GDBusInterfaceSkeletonFlags>,
    $g-dbus-interface-skeleton-flags-handle-method-invocations-in-thread,
    $g-dbus-interface-skeleton-flags-none,
    g-d-bus-interface-skeleton-class-signal-padding,
    g-d-bus-interface-skeleton-class-g-authorize-method,
    g-d-bus-interface-skeleton-class-vfunc-padding,
    g-d-bus-interface-skeleton-class-flush,
    g-d-bus-interface-skeleton-class-get-properties,
    g-d-bus-interface-skeleton-class-get-vtable,
    g-d-bus-interface-skeleton-class-get-info,
    g-d-bus-interface-skeleton-class-parent-class,
    <GDBusInterfaceSkeletonClass>,
    g-dbus-interface-skeleton-unexport-from-connection,
    g-dbus-interface-skeleton-unexport,
    g-dbus-interface-skeleton-set-flags,
    g-dbus-interface-skeleton-has-connection,
    g-dbus-interface-skeleton-get-properties,
    g-dbus-interface-skeleton-get-object-path,
    g-dbus-interface-skeleton-get-info,
    g-dbus-interface-skeleton-get-flags,
    g-dbus-interface-skeleton-get-connections,
    g-dbus-interface-skeleton-get-connection,
    g-dbus-interface-skeleton-flush,
    g-dbus-interface-skeleton-export,
    <GDBusInterfaceSkeleton*>,
    g-d-bus-interface-skeleton-priv,
    g-d-bus-interface-skeleton-parent-instance,
    <GDBusInterfaceSkeleton>,
    g-dbus-interface-info-unref,
    g-dbus-interface-info-ref,
    g-dbus-interface-info-lookup-signal,
    g-dbus-interface-info-lookup-property,
    g-dbus-interface-info-lookup-method,
    g-dbus-interface-info-generate-xml,
    g-dbus-interface-info-cache-release,
    g-dbus-interface-info-cache-build,
    g-d-bus-interface-info-annotations-setter,
    g-d-bus-interface-info-annotations,
    g-d-bus-interface-info-properties-setter,
    g-d-bus-interface-info-properties,
    g-d-bus-interface-info-signals-setter,
    g-d-bus-interface-info-signals,
    g-d-bus-interface-info-methods-setter,
    g-d-bus-interface-info-methods,
    g-d-bus-interface-info-name-setter,
    g-d-bus-interface-info-name,
    g-d-bus-interface-info-ref-count-setter,
    g-d-bus-interface-info-ref-count,
    <GDBusInterfaceInfo>,
    g-d-bus-interface-iface-dup-object,
    g-d-bus-interface-iface-set-object,
    g-d-bus-interface-iface-get-object,
    g-d-bus-interface-iface-get-info,
    g-d-bus-interface-iface-parent-iface,
    <GDBusInterfaceIface>,
    g-dbus-interface-set-object,
    g-dbus-interface-get-info,
    g-dbus-interface-dup-object,
    <GDBusInterface*>,
    <GDBusInterface>,
    g-d-bus-error-entry-dbus-error-name-setter,
    g-d-bus-error-entry-dbus-error-name,
    g-d-bus-error-entry-error-code-setter,
    g-d-bus-error-entry-error-code,
    <GDBusErrorEntry>,
    <GDBusError*>,
    <GDBusError>,
    $g-dbus-error-object-path-in-use,
    $g-dbus-error-adt-audit-data-unknown,
    $g-dbus-error-selinux-security-context-unknown,
    $g-dbus-error-invalid-file-content,
    $g-dbus-error-invalid-signature,
    $g-dbus-error-unix-process-id-unknown,
    $g-dbus-error-spawn-no-memory,
    $g-dbus-error-spawn-file-invalid,
    $g-dbus-error-spawn-permissions-invalid,
    $g-dbus-error-spawn-service-not-found,
    $g-dbus-error-spawn-service-invalid,
    $g-dbus-error-spawn-config-invalid,
    $g-dbus-error-spawn-setup-failed,
    $g-dbus-error-spawn-failed,
    $g-dbus-error-spawn-child-signaled,
    $g-dbus-error-spawn-child-exited,
    $g-dbus-error-spawn-fork-failed,
    $g-dbus-error-spawn-exec-failed,
    $g-dbus-error-match-rule-invalid,
    $g-dbus-error-match-rule-not-found,
    $g-dbus-error-timed-out,
    $g-dbus-error-unknown-method,
    $g-dbus-error-file-exists,
    $g-dbus-error-file-not-found,
    $g-dbus-error-invalid-args,
    $g-dbus-error-disconnected,
    $g-dbus-error-address-in-use,
    $g-dbus-error-no-network,
    $g-dbus-error-timeout,
    $g-dbus-error-no-server,
    $g-dbus-error-auth-failed,
    $g-dbus-error-access-denied,
    $g-dbus-error-limits-exceeded,
    $g-dbus-error-not-supported,
    $g-dbus-error-bad-address,
    $g-dbus-error-io-error,
    $g-dbus-error-no-reply,
    $g-dbus-error-name-has-no-owner,
    $g-dbus-error-service-unknown,
    $g-dbus-error-no-memory,
    $g-dbus-error-failed,
    <GDBusConnectionFlags*>,
    <GDBusConnectionFlags>,
    $g-dbus-connection-flags-delay-message-processing,
    $g-dbus-connection-flags-message-bus-connection,
    $g-dbus-connection-flags-authentication-allow-anonymous,
    $g-dbus-connection-flags-authentication-server,
    $g-dbus-connection-flags-authentication-client,
    $g-dbus-connection-flags-none,
    g-dbus-connection-unregister-subtree,
    g-dbus-connection-unregister-object,
    g-dbus-connection-unexport-menu-model,
    g-dbus-connection-unexport-action-group,
    g-dbus-connection-start-message-processing,
    g-dbus-connection-signal-unsubscribe,
    g-dbus-connection-signal-subscribe,
    g-dbus-connection-set-exit-on-close,
    g-dbus-connection-send-message-with-reply-sync,
    g-dbus-connection-send-message-with-reply-finish,
    g-dbus-connection-send-message-with-reply,
    g-dbus-connection-send-message,
    g-dbus-connection-remove-filter,
    g-dbus-connection-register-subtree,
    g-dbus-connection-register-object,
    g-dbus-connection-is-closed,
    g-dbus-connection-get-unique-name,
    g-dbus-connection-get-stream,
    g-dbus-connection-get-peer-credentials,
    g-dbus-connection-get-guid,
    g-dbus-connection-get-exit-on-close,
    g-dbus-connection-get-capabilities,
    g-dbus-connection-flush-sync,
    g-dbus-connection-flush-finish,
    g-dbus-connection-flush,
    g-dbus-connection-export-menu-model,
    g-dbus-connection-export-action-group,
    g-dbus-connection-emit-signal,
    g-dbus-connection-close-sync,
    g-dbus-connection-close-finish,
    g-dbus-connection-close,
    g-dbus-connection-call-with-unix-fd-list-sync,
    g-dbus-connection-call-with-unix-fd-list-finish,
    g-dbus-connection-call-with-unix-fd-list,
    g-dbus-connection-call-sync,
    g-dbus-connection-call-finish,
    g-dbus-connection-call,
    g-dbus-connection-add-filter,
    g-dbus-connection-new-for-address,
    g-dbus-connection-new,
    g-dbus-connection-new-sync,
    g-dbus-connection-new-for-address-sync,
    g-dbus-connection-new-for-address-finish,
    g-dbus-connection-new-finish,
    <GDBusConnection*>,
    <GDBusConnection>,
    <GDBusCapabilityFlags*>,
    <GDBusCapabilityFlags>,
    $g-dbus-capability-flags-unix-fd-passing,
    $g-dbus-capability-flags-none,
    <GDBusCallFlags*>,
    <GDBusCallFlags>,
    $g-dbus-call-flags-no-auto-start,
    $g-dbus-call-flags-none,
    g-dbus-auth-observer-authorize-authenticated-peer,
    g-dbus-auth-observer-new,
    <GDBusAuthObserver*>,
    <GDBusAuthObserver>,
    g-dbus-arg-info-unref,
    g-dbus-arg-info-ref,
    g-d-bus-arg-info-annotations-setter,
    g-d-bus-arg-info-annotations,
    g-d-bus-arg-info-signature-setter,
    g-d-bus-arg-info-signature,
    g-d-bus-arg-info-name-setter,
    g-d-bus-arg-info-name,
    g-d-bus-arg-info-ref-count-setter,
    g-d-bus-arg-info-ref-count,
    <GDBusArgInfo>,
    g-dbus-annotation-info-lookup,
    g-dbus-annotation-info-unref,
    g-dbus-annotation-info-ref,
    g-d-bus-annotation-info-annotations-setter,
    g-d-bus-annotation-info-annotations,
    g-d-bus-annotation-info-value-setter,
    g-d-bus-annotation-info-value,
    g-d-bus-annotation-info-key-setter,
    g-d-bus-annotation-info-key,
    g-d-bus-annotation-info-ref-count-setter,
    g-d-bus-annotation-info-ref-count,
    <GDBusAnnotationInfo>,
    g-dbus-action-group-get,
    <GDBusActionGroup*>,
    <GDBusActionGroup>,
    <GCredentialsType*>,
    <GCredentialsType>,
    $g-credentials-type-openbsd-sockpeercred,
    $g-credentials-type-freebsd-cmsgcred,
    $g-credentials-type-linux-ucred,
    $g-credentials-type-invalid,
    <GCredentialsClass>,
    g-credentials-to-string,
    g-credentials-set-unix-user,
    g-credentials-set-native,
    g-credentials-is-same-user,
    g-credentials-get-unix-user,
    g-credentials-new,
    <GCredentials*>,
    <GCredentials>,
    <GConverterResult*>,
    <GConverterResult>,
    $g-converter-flushed,
    $g-converter-finished,
    $g-converter-converted,
    $g-converter-error,
    <GConverterOutputStreamPrivate>,
    g-converter-output-stream-class-_g-reserved5,
    g-converter-output-stream-class-_g-reserved4,
    g-converter-output-stream-class-_g-reserved3,
    g-converter-output-stream-class-_g-reserved2,
    g-converter-output-stream-class-_g-reserved1,
    g-converter-output-stream-class-parent-class,
    <GConverterOutputStreamClass>,
    g-converter-output-stream-get-converter,
    g-converter-output-stream-new,
    <GConverterOutputStream*>,
    g-converter-output-stream-priv,
    g-converter-output-stream-parent-instance,
    <GConverterOutputStream>,
    <GConverterInputStreamPrivate>,
    g-converter-input-stream-class-_g-reserved5,
    g-converter-input-stream-class-_g-reserved4,
    g-converter-input-stream-class-_g-reserved3,
    g-converter-input-stream-class-_g-reserved2,
    g-converter-input-stream-class-_g-reserved1,
    g-converter-input-stream-class-parent-class,
    <GConverterInputStreamClass>,
    g-converter-input-stream-get-converter,
    g-converter-input-stream-new,
    <GConverterInputStream*>,
    g-converter-input-stream-priv,
    g-converter-input-stream-parent-instance,
    <GConverterInputStream>,
    g-converter-iface-reset,
    g-converter-iface-convert,
    g-converter-iface-g-iface,
    <GConverterIface>,
    <GConverterFlags*>,
    <GConverterFlags>,
    $g-converter-flush,
    $g-converter-input-at-end,
    $g-converter-no-flags,
    g-converter-reset,
    g-converter-convert,
    <GConverter*>,
    <GConverter>,
    g-charset-converter-class-parent-class,
    <GCharsetConverterClass>,
    g-charset-converter-set-use-fallback,
    g-charset-converter-get-use-fallback,
    g-charset-converter-get-num-fallbacks,
    g-charset-converter-new,
    <GCharsetConverter*>,
    <GCharsetConverter>,
    <GCancellablePrivate>,
    g-cancellable-class-_g-reserved5,
    g-cancellable-class-_g-reserved4,
    g-cancellable-class-_g-reserved3,
    g-cancellable-class-_g-reserved2,
    g-cancellable-class-_g-reserved1,
    g-cancellable-class-cancelled,
    g-cancellable-class-parent-class,
    <GCancellableClass>,
    g-cancellable-set-error-if-cancelled,
    g-cancellable-reset,
    g-cancellable-release-fd,
    g-cancellable-push-current,
    g-cancellable-pop-current,
    g-cancellable-make-pollfd,
    g-cancellable-is-cancelled,
    g-cancellable-get-fd,
    g-cancellable-disconnect,
    g-cancellable-connect,
    g-cancellable-cancel,
    g-cancellable-get-current,
    g-cancellable-new,
    <GCancellable*>,
    g-cancellable-priv,
    g-cancellable-parent-instance,
    <GCancellable>,
    <GBusType*>,
    <GBusType>,
    $g-bus-type-session,
    $g-bus-type-system,
    $g-bus-type-none,
    $g-bus-type-starter,
    <GBusNameWatcherFlags*>,
    <GBusNameWatcherFlags>,
    $g-bus-name-watcher-flags-auto-start,
    $g-bus-name-watcher-flags-none,
    <GBusNameOwnerFlags*>,
    <GBusNameOwnerFlags>,
    $g-bus-name-owner-flags-replace,
    $g-bus-name-owner-flags-allow-replacement,
    $g-bus-name-owner-flags-none,
    <GBufferedOutputStreamPrivate>,
    g-buffered-output-stream-class-_g-reserved2,
    g-buffered-output-stream-class-_g-reserved1,
    g-buffered-output-stream-class-parent-class,
    <GBufferedOutputStreamClass>,
    g-buffered-output-stream-set-buffer-size,
    g-buffered-output-stream-set-auto-grow,
    g-buffered-output-stream-get-buffer-size,
    g-buffered-output-stream-get-auto-grow,
    g-buffered-output-stream-new-sized,
    g-buffered-output-stream-new,
    <GBufferedOutputStream*>,
    g-buffered-output-stream-priv,
    g-buffered-output-stream-parent-instance,
    <GBufferedOutputStream>,
    <GBufferedInputStreamPrivate>,
    g-buffered-input-stream-class-_g-reserved5,
    g-buffered-input-stream-class-_g-reserved4,
    g-buffered-input-stream-class-_g-reserved3,
    g-buffered-input-stream-class-_g-reserved2,
    g-buffered-input-stream-class-_g-reserved1,
    g-buffered-input-stream-class-fill-finish,
    g-buffered-input-stream-class-fill-async,
    g-buffered-input-stream-class-fill,
    g-buffered-input-stream-class-parent-class,
    <GBufferedInputStreamClass>,
    g-buffered-input-stream-set-buffer-size,
    g-buffered-input-stream-read-byte,
    g-buffered-input-stream-peek-buffer,
    g-buffered-input-stream-peek,
    g-buffered-input-stream-get-buffer-size,
    g-buffered-input-stream-get-available,
    g-buffered-input-stream-fill-finish,
    g-buffered-input-stream-fill-async,
    g-buffered-input-stream-fill,
    g-buffered-input-stream-new-sized,
    g-buffered-input-stream-new,
    <GBufferedInputStream*>,
    g-buffered-input-stream-priv,
    g-buffered-input-stream-parent-instance,
    <GBufferedInputStream>,
    g-async-result-iface-get-source-object,
    g-async-result-iface-get-user-data,
    g-async-result-iface-g-iface,
    <GAsyncResultIface>,
    g-async-result-get-user-data,
    g-async-result-get-source-object,
    <GAsyncResult*>,
    <GAsyncResult>,
    g-async-initable-iface-init-finish,
    g-async-initable-iface-init-async,
    g-async-initable-iface-g-iface,
    <GAsyncInitableIface>,
    g-async-initable-new-finish,
    g-async-initable-init-finish,
    g-async-initable-init-async,
    g-async-initable-newv-async,
    <GAsyncInitable*>,
    <GAsyncInitable>,
    <GAskPasswordFlags*>,
    <GAskPasswordFlags>,
    $g-ask-password-anonymous-supported,
    $g-ask-password-saving-supported,
    $g-ask-password-need-domain,
    $g-ask-password-need-username,
    $g-ask-password-need-password,
    <GApplicationPrivate>,
    <GApplicationFlags*>,
    <GApplicationFlags>,
    $g-application-non-unique,
    $g-application-send-environment,
    $g-application-handles-command-line,
    $g-application-handles-open,
    $g-application-is-launcher,
    $g-application-is-service,
    $g-application-flags-none,
    <GApplicationCommandLinePrivate>,
    g-application-command-line-class-padding,
    g-application-command-line-class-printerr-literal,
    g-application-command-line-class-print-literal,
    g-application-command-line-class-parent-class,
    <GApplicationCommandLineClass>,
    g-application-command-line-set-exit-status,
    g-application-command-line-getenv,
    g-application-command-line-get-platform-data,
    g-application-command-line-get-is-remote,
    g-application-command-line-get-exit-status,
    g-application-command-line-get-environ,
    g-application-command-line-get-cwd,
    g-application-command-line-get-arguments,
    <GApplicationCommandLine*>,
    g-application-command-line-priv,
    g-application-command-line-parent-instance,
    <GApplicationCommandLine>,
    g-application-class-padding,
    g-application-class-shutdown,
    g-application-class-run-mainloop,
    g-application-class-quit-mainloop,
    g-application-class-add-platform-data,
    g-application-class-after-emit,
    g-application-class-before-emit,
    g-application-class-local-command-line,
    g-application-class-command-line,
    g-application-class-open,
    g-application-class-activate,
    g-application-class-startup,
    g-application-class-parent-class,
    <GApplicationClass>,
    g-application-set-inactivity-timeout,
    g-application-set-flags,
    g-application-set-default,
    g-application-set-application-id,
    g-application-set-action-group,
    g-application-run,
    g-application-release,
    g-application-register,
    g-application-quit,
    g-application-open,
    g-application-hold,
    g-application-get-is-remote,
    g-application-get-is-registered,
    g-application-get-inactivity-timeout,
    g-application-get-flags,
    g-application-get-application-id,
    g-application-activate,
    g-application-id-is-valid,
    g-application-get-default,
    g-application-new,
    <GApplication*>,
    g-application-priv,
    g-application-parent-instance,
    <GApplication>,
    <GAppLaunchContextPrivate>,
    g-app-launch-context-class-_g-reserved5,
    g-app-launch-context-class-_g-reserved4,
    g-app-launch-context-class-_g-reserved3,
    g-app-launch-context-class-_g-reserved2,
    g-app-launch-context-class-_g-reserved1,
    g-app-launch-context-class-launch-failed,
    g-app-launch-context-class-get-startup-notify-id,
    g-app-launch-context-class-get-display,
    g-app-launch-context-class-parent-class,
    <GAppLaunchContextClass>,
    g-app-launch-context-unsetenv,
    g-app-launch-context-setenv,
    g-app-launch-context-launch-failed,
    g-app-launch-context-get-startup-notify-id,
    g-app-launch-context-get-environment,
    g-app-launch-context-get-display,
    g-app-launch-context-new,
    <GAppLaunchContext*>,
    g-app-launch-context-priv,
    g-app-launch-context-parent-instance,
    <GAppLaunchContext>,
    g-app-info-iface-set-as-last-used-for-type,
    g-app-info-iface-get-display-name,
    g-app-info-iface-get-commandline,
    g-app-info-iface-do-delete,
    g-app-info-iface-can-delete,
    g-app-info-iface-remove-supports-type,
    g-app-info-iface-can-remove-supports-type,
    g-app-info-iface-add-supports-type,
    g-app-info-iface-set-as-default-for-extension,
    g-app-info-iface-set-as-default-for-type,
    g-app-info-iface-should-show,
    g-app-info-iface-launch-uris,
    g-app-info-iface-supports-files,
    g-app-info-iface-supports-uris,
    g-app-info-iface-launch,
    g-app-info-iface-get-icon,
    g-app-info-iface-get-executable,
    g-app-info-iface-get-description,
    g-app-info-iface-get-name,
    g-app-info-iface-get-id,
    g-app-info-iface-equal,
    g-app-info-iface-dup,
    g-app-info-iface-g-iface,
    <GAppInfoIface>,
    <GAppInfoCreateFlags*>,
    <GAppInfoCreateFlags>,
    $g-app-info-create-supports-startup-notification,
    $g-app-info-create-supports-uris,
    $g-app-info-create-needs-terminal,
    $g-app-info-create-none,
    g-app-info-supports-uris,
    g-app-info-supports-files,
    g-app-info-should-show,
    g-app-info-set-as-last-used-for-type,
    g-app-info-set-as-default-for-type,
    g-app-info-set-as-default-for-extension,
    g-app-info-remove-supports-type,
    g-app-info-launch-uris,
    g-app-info-launch,
    g-app-info-get-name,
    g-app-info-get-id,
    g-app-info-get-icon,
    g-app-info-get-executable,
    g-app-info-get-display-name,
    g-app-info-get-description,
    g-app-info-get-commandline,
    g-app-info-equal,
    g-app-info-dup,
    g-app-info-delete,
    g-app-info-can-remove-supports-type,
    g-app-info-can-delete,
    g-app-info-add-supports-type,
    g-app-info-reset-type-associations,
    g-app-info-launch-default-for-uri,
    g-app-info-get-recommended-for-type,
    g-app-info-get-fallback-for-type,
    g-app-info-get-default-for-uri-scheme,
    g-app-info-get-default-for-type,
    g-app-info-get-all-for-type,
    g-app-info-get-all,
    g-app-info-create-from-commandline,
    <GAppInfo*>,
    <GAppInfo>,
    g-action-map-interface-remove-action,
    g-action-map-interface-add-action,
    g-action-map-interface-lookup-action,
    g-action-map-interface-g-iface,
    <GActionMapInterface>,
    g-action-map-remove-action,
    g-action-map-lookup-action,
    g-action-map-add-action-entries,
    g-action-map-add-action,
    <GActionMap*>,
    <GActionMap>,
    g-action-interface-activate,
    g-action-interface-change-state,
    g-action-interface-get-state,
    g-action-interface-get-enabled,
    g-action-interface-get-state-hint,
    g-action-interface-get-state-type,
    g-action-interface-get-parameter-type,
    g-action-interface-get-name,
    g-action-interface-g-iface,
    <GActionInterface>,
    g-action-group-interface-query-action,
    g-action-group-interface-action-state-changed,
    g-action-group-interface-action-enabled-changed,
    g-action-group-interface-action-removed,
    g-action-group-interface-action-added,
    g-action-group-interface-activate-action,
    g-action-group-interface-change-action-state,
    g-action-group-interface-get-action-state,
    g-action-group-interface-get-action-state-hint,
    g-action-group-interface-get-action-state-type,
    g-action-group-interface-get-action-parameter-type,
    g-action-group-interface-get-action-enabled,
    g-action-group-interface-list-actions,
    g-action-group-interface-has-action,
    g-action-group-interface-g-iface,
    <GActionGroupInterface>,
    g-action-group-query-action,
    g-action-group-list-actions,
    g-action-group-has-action,
    g-action-group-get-action-state-type,
    g-action-group-get-action-state-hint,
    g-action-group-get-action-state,
    g-action-group-get-action-parameter-type,
    g-action-group-get-action-enabled,
    g-action-group-change-action-state,
    g-action-group-activate-action,
    g-action-group-action-state-changed,
    g-action-group-action-removed,
    g-action-group-action-enabled-changed,
    g-action-group-action-added,
    <GActionGroup*>,
    <GActionGroup>,
    g-action-entry-padding,
    g-action-entry-change-state,
    g-action-entry-state-setter,
    g-action-entry-state,
    g-action-entry-parameter-type-setter,
    g-action-entry-parameter-type,
    g-action-entry-activate,
    g-action-entry-name-setter,
    g-action-entry-name,
    <GActionEntry>,
    g-action-get-state-type,
    g-action-get-state-hint,
    g-action-get-state,
    g-action-get-parameter-type,
    g-action-get-name,
    g-action-get-enabled,
    g-action-change-state,
    g-action-activate,
    <GAction*>,
    <GAction>;
end module;

define module gio-properties
  use gio;
  use gobject-glue;

  export
    @format-setter,
    @format,
    @file-info,
    @level-setter,
    @level,
    @format-setter,
    @format,
    @file-info-setter,
    @file-info,
    @path-as-array-setter,
    @path-as-array,
    @path-setter,
    @path,
    @address-type-setter,
    @address-type,
    @abstract-setter,
    @abstract,
    @fd-setter,
    @fd,
    @close-fd-setter,
    @close-fd,
    @fd-setter,
    @fd,
    @close-fd-setter,
    @close-fd,
    @fd-list-setter,
    @fd-list,
    @credentials-setter,
    @credentials,
    @warning-setter,
    @warning,
    @flags-setter,
    @flags,
    @description-setter,
    @description,
    @use-system-certdb-setter,
    @use-system-certdb,
    @require-close-notify-setter,
    @require-close-notify,
    @rehandshake-mode-setter,
    @rehandshake-mode,
    @peer-certificate-errors,
    @peer-certificate,
    @interaction-setter,
    @interaction,
    @database-setter,
    @database,
    @certificate-setter,
    @certificate,
    @base-io-stream-setter,
    @base-io-stream,
    @private-key-pem-setter,
    @private-key-setter,
    @issuer-setter,
    @issuer,
    @certificate-pem-setter,
    @certificate-pem,
    @certificate-setter,
    @certificate,
    @max-threads-setter,
    @max-threads,
    @use-default-fallbacks-setter,
    @use-default-fallbacks,
    @names-setter,
    @names,
    @name-setter,
    @base-io-stream-setter,
    @base-io-stream,
    @graceful-disconnect-setter,
    @graceful-disconnect,
    @listen-backlog-setter,
    @listen-backlog,
    @socket-setter,
    @socket,
    @type-setter,
    @type,
    @tls-validation-flags-setter,
    @tls-validation-flags,
    @tls-setter,
    @tls,
    @timeout-setter,
    @timeout,
    @protocol-setter,
    @protocol,
    @local-address-setter,
    @local-address,
    @family-setter,
    @family,
    @enable-proxy-setter,
    @enable-proxy,
    @family,
    @type-setter,
    @type,
    @ttl-setter,
    @ttl,
    @timeout-setter,
    @timeout,
    @remote-address,
    @protocol-setter,
    @protocol,
    @multicast-ttl-setter,
    @multicast-ttl,
    @multicast-loopback-setter,
    @multicast-loopback,
    @local-address,
    @listen-backlog-setter,
    @listen-backlog,
    @keepalive-setter,
    @keepalive,
    @fd-setter,
    @fd,
    @family-setter,
    @family,
    @broadcast-setter,
    @broadcast,
    @blocking-setter,
    @blocking,
    @state-type,
    @state-setter,
    @state,
    @parameter-type-setter,
    @parameter-type,
    @name-setter,
    @name,
    @enabled-setter,
    @enabled,
    @settings-schema-setter,
    @settings-schema,
    @schema-id-setter,
    @schema-id,
    @schema-setter,
    @schema,
    @path-setter,
    @path,
    @has-unapplied,
    @delay-apply,
    @uri-setter,
    @uri,
    @connectable-setter,
    @connectable,
    @username-setter,
    @username,
    @protocol-setter,
    @protocol,
    @password-setter,
    @password,
    @destination-port-setter,
    @destination-port,
    @destination-hostname-setter,
    @destination-hostname,
    @can-release,
    @can-acquire,
    @allowed,
    @service-setter,
    @service,
    @scheme-setter,
    @scheme,
    @protocol-setter,
    @protocol,
    @domain-setter,
    @domain,
    @scheme-setter,
    @scheme,
    @port-setter,
    @port,
    @hostname-setter,
    @hostname,
    @username-setter,
    @username,
    @password-save-setter,
    @password-save,
    @password-setter,
    @password,
    @domain-setter,
    @domain,
    @choice-setter,
    @choice,
    @anonymous-setter,
    @anonymous,
    @size-setter,
    @size,
    @data-size,
    @data-setter,
    @data,
    @scope-id-setter,
    @scope-id,
    @port-setter,
    @port,
    @flowinfo-setter,
    @flowinfo,
    @address-setter,
    @address,
    @length-setter,
    @length,
    @family,
    @address-setter,
    @address,
    @is-site-local,
    @is-multicast,
    @is-mc-site-local,
    @is-mc-org-local,
    @is-mc-node-local,
    @is-mc-link-local,
    @is-mc-global,
    @is-loopback,
    @is-link-local,
    @is-any,
    @family-setter,
    @family,
    @bytes-setter,
    @bytes,
    @output-stream,
    @input-stream,
    @closed,
    @close-base-stream-setter,
    @close-base-stream,
    @base-stream-setter,
    @base-stream,
    @close-base-stream-setter,
    @close-base-stream,
    @base-stream-setter,
    @base-stream,
    @rate-limit-setter,
    @rate-limit,
    @cancelled,
    @file-setter,
    @file,
    @container-setter,
    @gicon-setter,
    @gicon,
    @origin-setter,
    @origin,
    @icon-setter,
    @icon,
    @filename-setter,
    @filename,
    @byte-order-setter,
    @byte-order,
    @newline-type-setter,
    @newline-type,
    @byte-order-setter,
    @byte-order,
    @guid-setter,
    @guid,
    @flags-setter,
    @flags,
    @client-address,
    @authentication-observer-setter,
    @authentication-observer,
    @address-setter,
    @address,
    @active,
    @g-object-path-setter,
    @g-object-path,
    @g-name-owner,
    @g-name-setter,
    @g-name,
    @g-interface-name-setter,
    @g-interface-name,
    @g-interface-info-setter,
    @g-interface-info,
    @g-flags-setter,
    @g-flags,
    @g-default-timeout-setter,
    @g-default-timeout,
    @g-connection-setter,
    @g-connection,
    @g-bus-type-setter,
    @g-object-path-setter,
    @g-object-path,
    @g-object-path-setter,
    @g-object-path,
    @g-connection-setter,
    @g-connection,
    @object-path-setter,
    @object-path,
    @connection-setter,
    @connection,
    @object-path-setter,
    @object-path,
    @name-owner,
    @name-setter,
    @name,
    @get-proxy-type-user-data-setter,
    @get-proxy-type-user-data,
    @get-proxy-type-func-setter,
    @get-proxy-type-func,
    @get-proxy-type-destroy-notify-setter,
    @get-proxy-type-destroy-notify,
    @flags-setter,
    @flags,
    @connection-setter,
    @connection,
    @bus-type-setter,
    @locked,
    @g-flags-setter,
    @g-flags,
    @unique-name,
    @stream-setter,
    @stream,
    @guid-setter,
    @guid,
    @flags-setter,
    @exit-on-close-setter,
    @exit-on-close,
    @closed,
    @capabilities,
    @authentication-observer-setter,
    @address-setter,
    @converter-setter,
    @converter,
    @converter-setter,
    @converter,
    @use-fallback-setter,
    @use-fallback,
    @to-charset-setter,
    @to-charset,
    @from-charset-setter,
    @from-charset,
    @buffer-size-setter,
    @buffer-size,
    @auto-grow-setter,
    @auto-grow,
    @buffer-size-setter,
    @buffer-size,
    @platform-data-setter,
    @is-remote,
    @arguments-setter,
    @is-remote,
    @is-registered,
    @inactivity-timeout-setter,
    @inactivity-timeout,
    @flags-setter,
    @flags,
    @application-id-setter,
    @application-id,
    @action-group-setter;
end module;
